import { openBlock as K, createElementBlock as J, mergeProps as It, withDirectives as ti, vModelDynamic as dv, createElementVNode as Ce, Fragment as Zt, renderList as mn, createCommentVNode as je, resolveDirective as pv, normalizeClass as Jn, renderSlot as wn, vModelSelect as gv, vModelText as _v, pushScopeId as vv, popScopeId as mv, defineComponent as Qt, nextTick as wv, createBlock as ni, normalizeProps as yv, guardReactiveProps as xv, withScopeId as bv, resolveComponent as Xn, normalizeStyle as Ro, withKeys as Tv, withCtx as Zr, createVNode as Za, ref as Ho, createApp as $v, h as Av, toDisplayString as Cv } from "vue";
String.prototype.html2text = function() {
  return this.replace(/ *\<[^>]*\> */g, "");
};
const ri = (r, s) => {
  const o = r.__vccOpts || r;
  for (const [c, d] of s)
    o[c] = d;
  return o;
}, Sv = {
  name: "xb-input",
  inheritAttrs: !1,
  props: {
    modelValue: {
      required: !0
    },
    errors: {
      required: !1,
      type: Array,
      default: () => []
    },
    tips: {
      required: !1,
      type: Array,
      default: () => []
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    name: {
      required: !0,
      type: String
    },
    type: {
      required: !1,
      type: String,
      default: "text"
    }
  },
  emits: [
    "update:modelValue",
    "update:errors"
  ],
  computed: {
    computedValue: {
      get() {
        return this.modelValue;
      },
      set(r) {
        this.$emit("update:modelValue", r);
      }
    },
    computedErrors: {
      get() {
        return this.errors;
      },
      set(r) {
        this.$emit("update:errors", r);
      }
    },
    hasErrors() {
      return this.errors.length > 0;
    },
    hasTips() {
      return this.tips.length > 0;
    },
    inputIsDescribedby() {
      return [
        this.hasTips ? `${this.name}-tips` : null,
        this.hasErrors ? `${this.name}-errors` : null
      ].filter((r) => r).join(" ");
    }
  },
  methods: {
    fileInputChanged() {
      let r = this.$refs.input, s = r.files[0];
      s ? this.computedValue = s : r.value = null;
    }
  }
}, Pv = ["type", "id", "aria-describedby", "placeholder"], Ev = ["type", "id", "aria-describedby", "placeholder"], Ov = ["for", "innerHTML"], Lv = ["id"], Iv = ["innerHTML"], Rv = ["id"], Mv = ["innerHTML"];
function Dv(r, s, o, c, d, _) {
  return K(), J("fieldset", It({
    class: ["xb-input-wrapper", {
      "has-errors": _.hasErrors
    }]
  }, r.$attrsClassStyleIdOnly), [
    o.type !== "file" ? ti((K(), J("input", It({
      key: 0,
      type: o.type,
      id: `${o.name}-input`,
      "aria-describedby": _.inputIsDescribedby,
      placeholder: o.placeholder.html2text() || " ",
      "onUpdate:modelValue": s[0] || (s[0] = (m) => _.computedValue = m)
    }, r.$attrsWithoutClassStyleId), null, 16, Pv)), [
      [dv, _.computedValue]
    ]) : (K(), J("input", It({
      key: 1,
      ref: "input",
      type: o.type,
      id: `${o.name}-input`,
      "aria-describedby": _.inputIsDescribedby,
      placeholder: o.placeholder.html2text() || " ",
      onChange: s[1] || (s[1] = (...m) => _.fileInputChanged && _.fileInputChanged(...m))
    }, r.$attrsWithoutClassStyleId), null, 16, Ev)),
    Ce("label", {
      for: `${o.name}-input`,
      innerHTML: o.placeholder
    }, null, 8, Ov),
    _.hasTips && !_.hasErrors ? (K(), J("p", {
      key: 2,
      class: "text-slate-600",
      id: `${o.name}-tips`
    }, [
      (K(!0), J(Zt, null, mn(o.tips, (m) => (K(), J("span", { innerHTML: m }, null, 8, Iv))), 256))
    ], 8, Lv)) : je("", !0),
    _.hasErrors ? (K(), J("p", {
      key: 3,
      class: "text-red-600",
      role: "alert",
      id: `${o.name}-errors`
    }, [
      (K(!0), J(Zt, null, mn(o.errors, (m) => (K(), J("span", { innerHTML: m }, null, 8, Mv))), 256))
    ], 8, Rv)) : je("", !0)
  ], 16);
}
const Wv = /* @__PURE__ */ ri(Sv, [["render", Dv]]);
const Nv = {
  name: "xb-button",
  props: {
    loading: {
      required: !1,
      type: Boolean,
      default: !1
    },
    disabled: {
      required: !1,
      type: Boolean,
      default: !1
    },
    scheme: {
      required: !1,
      type: String,
      default: "primary",
      validator: (r) => ["primary", "success", "danger", "info", "alert"].includes(r)
    }
  },
  computed: {
    computedDisabled() {
      return this.disabled || this.loading;
    }
  }
}, Bv = ["disabled"], Hv = {
  key: 0,
  class: "mdi mdi-loading mdi-spin pr-2"
};
function Fv(r, s, o, c, d, _) {
  const m = pv("wave");
  return ti((K(), J("button", {
    class: Jn(["xb-button", [
      o.scheme
    ]]),
    disabled: _.computedDisabled
  }, [
    o.loading ? (K(), J("i", Hv)) : je("", !0),
    wn(r.$slots, "default")
  ], 10, Bv)), [
    [m, !_.computedDisabled]
  ]);
}
const zv = /* @__PURE__ */ ri(Nv, [["render", Fv]]);
const Uv = {
  name: "xb-select",
  inheritAttrs: !1,
  props: {
    modelValue: {
      required: !0
    },
    errors: {
      required: !1,
      type: Array,
      default: () => []
    },
    tips: {
      required: !1,
      type: Array,
      default: () => []
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    name: {
      required: !0,
      type: String
    },
    disabled: {
      required: !1,
      type: Boolean,
      default: !1
    }
  },
  emits: [
    "update:modelValue",
    "update:errors"
  ],
  computed: {
    computedValue: {
      get() {
        return this.modelValue;
      },
      set(r) {
        this.$emit("update:modelValue", r);
      }
    },
    computedErrors: {
      get() {
        return this.errors;
      },
      set(r) {
        this.$emit("update:errors", r);
      }
    },
    hasErrors() {
      return this.errors.length > 0;
    },
    hasTips() {
      return this.tips.length > 0;
    },
    hasPlaceholder() {
      return !!this.placeholder;
    },
    inputIsDescribedby() {
      return [
        this.hasTips ? `${this.name}-tips` : null,
        this.hasErrors ? `${this.name}-errors` : null
      ].filter((r) => r).join(" ");
    }
  }
}, kv = ["id", "aria-describedby", "placeholder", "disabled"], qv = ["innerHTML"], Gv = ["for", "innerHTML"], Vv = { class: "actions-container" }, Kv = ["disabled"], Yv = /* @__PURE__ */ Ce("i", { class: "mdi mdi-close" }, null, -1), Xv = [
  Yv
], Zv = ["disabled"], Jv = /* @__PURE__ */ Ce("i", { class: "mdi mdi-chevron-down" }, null, -1), Qv = [
  Jv
], jv = ["id"], em = ["innerHTML"], tm = ["id"], nm = ["innerHTML"];
function rm(r, s, o, c, d, _) {
  return K(), J("fieldset", It({
    class: ["xb-select-wrapper", {
      "has-errors": _.hasErrors
    }]
  }, r.$attrsClassStyleIdOnly), [
    ti(Ce("select", It({
      id: `${o.name}-select`,
      class: {
        "value-empty": !_.computedValue
      },
      "aria-describedby": _.inputIsDescribedby,
      placeholder: o.placeholder.html2text() || " ",
      disabled: o.disabled,
      "onUpdate:modelValue": s[0] || (s[0] = (m) => _.computedValue = m)
    }, r.$attrsWithoutClassStyleId), [
      _.hasPlaceholder ? (K(), J("option", {
        key: 0,
        value: "",
        disabled: "",
        selected: "",
        class: "text-slate-300",
        innerHTML: o.placeholder
      }, null, 8, qv)) : je("", !0),
      wn(r.$slots, "default")
    ], 16, kv), [
      [gv, _.computedValue]
    ]),
    Ce("label", {
      for: `${o.name}-select`,
      innerHTML: o.placeholder
    }, null, 8, Gv),
    Ce("span", Vv, [
      _.computedValue ? (K(), J("button", {
        key: 0,
        class: "w-5 h-5 text-lg flex items-center",
        "aria-label": "\u6E05\u7A7A\u9009\u62E9\u6846",
        type: "button",
        onClick: s[1] || (s[1] = (m) => _.computedValue = ""),
        disabled: o.disabled
      }, Xv, 8, Kv)) : _.computedValue ? je("", !0) : (K(), J("button", {
        key: 1,
        class: "w-5 h-5 text-lg flex items-center",
        "aria-label": "\u9009\u62E9",
        disabled: o.disabled,
        type: "button"
      }, Qv, 8, Zv))
    ]),
    _.hasTips && !_.hasErrors ? (K(), J("p", {
      key: 0,
      class: "text-slate-600",
      id: `${o.name}-tips`
    }, [
      (K(!0), J(Zt, null, mn(o.tips, (m) => (K(), J("span", { innerHTML: m }, null, 8, em))), 256))
    ], 8, jv)) : je("", !0),
    _.hasErrors ? (K(), J("p", {
      key: 1,
      class: "text-red-600",
      role: "alert",
      id: `${o.name}-errors`
    }, [
      (K(!0), J(Zt, null, mn(o.errors, (m) => (K(), J("span", { innerHTML: m }, null, 8, nm))), 256))
    ], 8, tm)) : je("", !0)
  ], 16);
}
const im = /* @__PURE__ */ ri(Uv, [["render", rm]]);
const om = {
  name: "xb-textarea",
  inheritAttrs: !1,
  props: {
    modelValue: {
      required: !0
    },
    errors: {
      required: !1,
      type: Array,
      default: () => []
    },
    tips: {
      required: !1,
      type: Array,
      default: () => []
    },
    placeholder: {
      required: !1,
      type: String,
      default: ""
    },
    name: {
      required: !0,
      type: String
    }
  },
  emits: [
    "update:modelValue",
    "update:errors"
  ],
  computed: {
    computedValue: {
      get() {
        return this.modelValue;
      },
      set(r) {
        this.$emit("update:modelValue", r);
      }
    },
    computedErrors: {
      get() {
        return this.errors;
      },
      set(r) {
        this.$emit("update:errors", r);
      }
    },
    hasErrors() {
      return this.errors.length > 0;
    },
    hasTips() {
      return this.tips.length > 0;
    },
    inputIsDescribedby() {
      return [
        this.hasTips ? `${this.name}-tips` : null,
        this.hasErrors ? `${this.name}-errors` : null
      ].filter((r) => r).join(" ");
    }
  }
}, sm = ["id", "aria-describedby", "placeholder"], um = ["for", "innerHTML"], am = ["id"], lm = ["innerHTML"], fm = ["id"], cm = ["innerHTML"];
function hm(r, s, o, c, d, _) {
  return K(), J("fieldset", It({
    class: ["xb-textarea-wrapper", {
      "has-errors": _.hasErrors
    }]
  }, r.$attrsClassStyleIdOnly), [
    ti(Ce("textarea", It({
      id: `${o.name}-input`,
      "aria-describedby": _.inputIsDescribedby,
      placeholder: o.placeholder.html2text() || " ",
      "onUpdate:modelValue": s[0] || (s[0] = (m) => _.computedValue = m)
    }, r.$attrsWithoutClassStyleId), null, 16, sm), [
      [_v, _.computedValue]
    ]),
    Ce("label", {
      for: `${o.name}-input`,
      innerHTML: o.placeholder
    }, null, 8, um),
    _.hasTips && !_.hasErrors ? (K(), J("p", {
      key: 0,
      class: "text-slate-600",
      id: `${o.name}-tips`
    }, [
      (K(!0), J(Zt, null, mn(o.tips, (m) => (K(), J("span", { innerHTML: m }, null, 8, lm))), 256))
    ], 8, am)) : je("", !0),
    _.hasErrors ? (K(), J("p", {
      key: 1,
      class: "text-red-600",
      role: "alert",
      id: `${o.name}-errors`
    }, [
      (K(!0), J(Zt, null, mn(o.errors, (m) => (K(), J("span", { innerHTML: m }, null, 8, cm))), 256))
    ], 8, fm)) : je("", !0)
  ], 16);
}
const dm = /* @__PURE__ */ ri(om, [["render", hm]]), Mo = {
  input: Wv,
  button: zv,
  select: im,
  textarea: dm
};
var _n = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {}, Fo = { exports: {} };
/**
 * @license
 * Lodash <https://lodash.com/>
 * Copyright OpenJS Foundation and other contributors <https://openjsf.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */
(function(r, s) {
  (function() {
    var o, c = "4.17.21", d = 200, _ = "Unsupported core-js use. Try https://npms.io/search?q=ponyfill.", m = "Expected a function", w = "Invalid `variable` option passed into `_.template`", $ = "__lodash_hash_undefined__", L = 500, C = "__lodash_placeholder__", E = 1, O = 2, D = 4, U = 1, Q = 2, N = 1, G = 2, F = 4, W = 8, ee = 16, se = 32, ce = 64, pe = 128, ue = 256, me = 512, wt = 30, Dt = "...", Wt = 800, Nt = 16, Ne = 1, bn = 2, bl = 3, Bt = 1 / 0, yt = 9007199254740991, Tl = 17976931348623157e292, er = 0 / 0, et = 4294967295, $l = et - 1, Al = et >>> 1, Cl = [
      ["ary", pe],
      ["bind", N],
      ["bindKey", G],
      ["curry", W],
      ["curryRight", ee],
      ["flip", me],
      ["partial", se],
      ["partialRight", ce],
      ["rearg", ue]
    ], jt = "[object Arguments]", tr = "[object Array]", Sl = "[object AsyncFunction]", Tn = "[object Boolean]", $n = "[object Date]", Pl = "[object DOMException]", nr = "[object Error]", rr = "[object Function]", Qo = "[object GeneratorFunction]", Ve = "[object Map]", An = "[object Number]", El = "[object Null]", it = "[object Object]", jo = "[object Promise]", Ol = "[object Proxy]", Cn = "[object RegExp]", Ke = "[object Set]", Sn = "[object String]", ir = "[object Symbol]", Ll = "[object Undefined]", Pn = "[object WeakMap]", Il = "[object WeakSet]", En = "[object ArrayBuffer]", en = "[object DataView]", ci = "[object Float32Array]", hi = "[object Float64Array]", di = "[object Int8Array]", pi = "[object Int16Array]", gi = "[object Int32Array]", _i = "[object Uint8Array]", vi = "[object Uint8ClampedArray]", mi = "[object Uint16Array]", wi = "[object Uint32Array]", Rl = /\b__p \+= '';/g, Ml = /\b(__p \+=) '' \+/g, Dl = /(__e\(.*?\)|\b__t\)) \+\n'';/g, es = /&(?:amp|lt|gt|quot|#39);/g, ts = /[&<>"']/g, Wl = RegExp(es.source), Nl = RegExp(ts.source), Bl = /<%-([\s\S]+?)%>/g, Hl = /<%([\s\S]+?)%>/g, ns = /<%=([\s\S]+?)%>/g, Fl = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/, zl = /^\w*$/, Ul = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g, yi = /[\\^$.*+?()[\]{}|]/g, kl = RegExp(yi.source), xi = /^\s+/, ql = /\s/, Gl = /\{(?:\n\/\* \[wrapped with .+\] \*\/)?\n?/, Vl = /\{\n\/\* \[wrapped with (.+)\] \*/, Kl = /,? & /, Yl = /[^\x00-\x2f\x3a-\x40\x5b-\x60\x7b-\x7f]+/g, Xl = /[()=,{}\[\]\/\s]/, Zl = /\\(\\)?/g, Jl = /\$\{([^\\}]*(?:\\.[^\\}]*)*)\}/g, rs = /\w*$/, Ql = /^[-+]0x[0-9a-f]+$/i, jl = /^0b[01]+$/i, ef = /^\[object .+?Constructor\]$/, tf = /^0o[0-7]+$/i, nf = /^(?:0|[1-9]\d*)$/, rf = /[\xc0-\xd6\xd8-\xf6\xf8-\xff\u0100-\u017f]/g, or = /($^)/, of = /['\n\r\u2028\u2029\\]/g, sr = "\\ud800-\\udfff", sf = "\\u0300-\\u036f", uf = "\\ufe20-\\ufe2f", af = "\\u20d0-\\u20ff", is = sf + uf + af, os = "\\u2700-\\u27bf", ss = "a-z\\xdf-\\xf6\\xf8-\\xff", lf = "\\xac\\xb1\\xd7\\xf7", ff = "\\x00-\\x2f\\x3a-\\x40\\x5b-\\x60\\x7b-\\xbf", cf = "\\u2000-\\u206f", hf = " \\t\\x0b\\f\\xa0\\ufeff\\n\\r\\u2028\\u2029\\u1680\\u180e\\u2000\\u2001\\u2002\\u2003\\u2004\\u2005\\u2006\\u2007\\u2008\\u2009\\u200a\\u202f\\u205f\\u3000", us = "A-Z\\xc0-\\xd6\\xd8-\\xde", as = "\\ufe0e\\ufe0f", ls = lf + ff + cf + hf, bi = "['\u2019]", df = "[" + sr + "]", fs = "[" + ls + "]", ur = "[" + is + "]", cs = "\\d+", pf = "[" + os + "]", hs = "[" + ss + "]", ds = "[^" + sr + ls + cs + os + ss + us + "]", Ti = "\\ud83c[\\udffb-\\udfff]", gf = "(?:" + ur + "|" + Ti + ")", ps = "[^" + sr + "]", $i = "(?:\\ud83c[\\udde6-\\uddff]){2}", Ai = "[\\ud800-\\udbff][\\udc00-\\udfff]", tn = "[" + us + "]", gs = "\\u200d", _s = "(?:" + hs + "|" + ds + ")", _f = "(?:" + tn + "|" + ds + ")", vs = "(?:" + bi + "(?:d|ll|m|re|s|t|ve))?", ms = "(?:" + bi + "(?:D|LL|M|RE|S|T|VE))?", ws = gf + "?", ys = "[" + as + "]?", vf = "(?:" + gs + "(?:" + [ps, $i, Ai].join("|") + ")" + ys + ws + ")*", mf = "\\d*(?:1st|2nd|3rd|(?![123])\\dth)(?=\\b|[A-Z_])", wf = "\\d*(?:1ST|2ND|3RD|(?![123])\\dTH)(?=\\b|[a-z_])", xs = ys + ws + vf, yf = "(?:" + [pf, $i, Ai].join("|") + ")" + xs, xf = "(?:" + [ps + ur + "?", ur, $i, Ai, df].join("|") + ")", bf = RegExp(bi, "g"), Tf = RegExp(ur, "g"), Ci = RegExp(Ti + "(?=" + Ti + ")|" + xf + xs, "g"), $f = RegExp([
      tn + "?" + hs + "+" + vs + "(?=" + [fs, tn, "$"].join("|") + ")",
      _f + "+" + ms + "(?=" + [fs, tn + _s, "$"].join("|") + ")",
      tn + "?" + _s + "+" + vs,
      tn + "+" + ms,
      wf,
      mf,
      cs,
      yf
    ].join("|"), "g"), Af = RegExp("[" + gs + sr + is + as + "]"), Cf = /[a-z][A-Z]|[A-Z]{2}[a-z]|[0-9][a-zA-Z]|[a-zA-Z][0-9]|[^a-zA-Z0-9 ]/, Sf = [
      "Array",
      "Buffer",
      "DataView",
      "Date",
      "Error",
      "Float32Array",
      "Float64Array",
      "Function",
      "Int8Array",
      "Int16Array",
      "Int32Array",
      "Map",
      "Math",
      "Object",
      "Promise",
      "RegExp",
      "Set",
      "String",
      "Symbol",
      "TypeError",
      "Uint8Array",
      "Uint8ClampedArray",
      "Uint16Array",
      "Uint32Array",
      "WeakMap",
      "_",
      "clearTimeout",
      "isFinite",
      "parseInt",
      "setTimeout"
    ], Pf = -1, oe = {};
    oe[ci] = oe[hi] = oe[di] = oe[pi] = oe[gi] = oe[_i] = oe[vi] = oe[mi] = oe[wi] = !0, oe[jt] = oe[tr] = oe[En] = oe[Tn] = oe[en] = oe[$n] = oe[nr] = oe[rr] = oe[Ve] = oe[An] = oe[it] = oe[Cn] = oe[Ke] = oe[Sn] = oe[Pn] = !1;
    var ie = {};
    ie[jt] = ie[tr] = ie[En] = ie[en] = ie[Tn] = ie[$n] = ie[ci] = ie[hi] = ie[di] = ie[pi] = ie[gi] = ie[Ve] = ie[An] = ie[it] = ie[Cn] = ie[Ke] = ie[Sn] = ie[ir] = ie[_i] = ie[vi] = ie[mi] = ie[wi] = !0, ie[nr] = ie[rr] = ie[Pn] = !1;
    var Ef = {
      \u00C0: "A",
      \u00C1: "A",
      \u00C2: "A",
      \u00C3: "A",
      \u00C4: "A",
      \u00C5: "A",
      \u00E0: "a",
      \u00E1: "a",
      \u00E2: "a",
      \u00E3: "a",
      \u00E4: "a",
      \u00E5: "a",
      \u00C7: "C",
      \u00E7: "c",
      \u00D0: "D",
      \u00F0: "d",
      \u00C8: "E",
      \u00C9: "E",
      \u00CA: "E",
      \u00CB: "E",
      \u00E8: "e",
      \u00E9: "e",
      \u00EA: "e",
      \u00EB: "e",
      \u00CC: "I",
      \u00CD: "I",
      \u00CE: "I",
      \u00CF: "I",
      \u00EC: "i",
      \u00ED: "i",
      \u00EE: "i",
      \u00EF: "i",
      \u00D1: "N",
      \u00F1: "n",
      \u00D2: "O",
      \u00D3: "O",
      \u00D4: "O",
      \u00D5: "O",
      \u00D6: "O",
      \u00D8: "O",
      \u00F2: "o",
      \u00F3: "o",
      \u00F4: "o",
      \u00F5: "o",
      \u00F6: "o",
      \u00F8: "o",
      \u00D9: "U",
      \u00DA: "U",
      \u00DB: "U",
      \u00DC: "U",
      \u00F9: "u",
      \u00FA: "u",
      \u00FB: "u",
      \u00FC: "u",
      \u00DD: "Y",
      \u00FD: "y",
      \u00FF: "y",
      \u00C6: "Ae",
      \u00E6: "ae",
      \u00DE: "Th",
      \u00FE: "th",
      \u00DF: "ss",
      \u0100: "A",
      \u0102: "A",
      \u0104: "A",
      \u0101: "a",
      \u0103: "a",
      \u0105: "a",
      \u0106: "C",
      \u0108: "C",
      \u010A: "C",
      \u010C: "C",
      \u0107: "c",
      \u0109: "c",
      \u010B: "c",
      \u010D: "c",
      \u010E: "D",
      \u0110: "D",
      \u010F: "d",
      \u0111: "d",
      \u0112: "E",
      \u0114: "E",
      \u0116: "E",
      \u0118: "E",
      \u011A: "E",
      \u0113: "e",
      \u0115: "e",
      \u0117: "e",
      \u0119: "e",
      \u011B: "e",
      \u011C: "G",
      \u011E: "G",
      \u0120: "G",
      \u0122: "G",
      \u011D: "g",
      \u011F: "g",
      \u0121: "g",
      \u0123: "g",
      \u0124: "H",
      \u0126: "H",
      \u0125: "h",
      \u0127: "h",
      \u0128: "I",
      \u012A: "I",
      \u012C: "I",
      \u012E: "I",
      \u0130: "I",
      \u0129: "i",
      \u012B: "i",
      \u012D: "i",
      \u012F: "i",
      \u0131: "i",
      \u0134: "J",
      \u0135: "j",
      \u0136: "K",
      \u0137: "k",
      \u0138: "k",
      \u0139: "L",
      \u013B: "L",
      \u013D: "L",
      \u013F: "L",
      \u0141: "L",
      \u013A: "l",
      \u013C: "l",
      \u013E: "l",
      \u0140: "l",
      \u0142: "l",
      \u0143: "N",
      \u0145: "N",
      \u0147: "N",
      \u014A: "N",
      \u0144: "n",
      \u0146: "n",
      \u0148: "n",
      \u014B: "n",
      \u014C: "O",
      \u014E: "O",
      \u0150: "O",
      \u014D: "o",
      \u014F: "o",
      \u0151: "o",
      \u0154: "R",
      \u0156: "R",
      \u0158: "R",
      \u0155: "r",
      \u0157: "r",
      \u0159: "r",
      \u015A: "S",
      \u015C: "S",
      \u015E: "S",
      \u0160: "S",
      \u015B: "s",
      \u015D: "s",
      \u015F: "s",
      \u0161: "s",
      \u0162: "T",
      \u0164: "T",
      \u0166: "T",
      \u0163: "t",
      \u0165: "t",
      \u0167: "t",
      \u0168: "U",
      \u016A: "U",
      \u016C: "U",
      \u016E: "U",
      \u0170: "U",
      \u0172: "U",
      \u0169: "u",
      \u016B: "u",
      \u016D: "u",
      \u016F: "u",
      \u0171: "u",
      \u0173: "u",
      \u0174: "W",
      \u0175: "w",
      \u0176: "Y",
      \u0177: "y",
      \u0178: "Y",
      \u0179: "Z",
      \u017B: "Z",
      \u017D: "Z",
      \u017A: "z",
      \u017C: "z",
      \u017E: "z",
      \u0132: "IJ",
      \u0133: "ij",
      \u0152: "Oe",
      \u0153: "oe",
      \u0149: "'n",
      \u017F: "s"
    }, Of = {
      "&": "&amp;",
      "<": "&lt;",
      ">": "&gt;",
      '"': "&quot;",
      "'": "&#39;"
    }, Lf = {
      "&amp;": "&",
      "&lt;": "<",
      "&gt;": ">",
      "&quot;": '"',
      "&#39;": "'"
    }, If = {
      "\\": "\\",
      "'": "'",
      "\n": "n",
      "\r": "r",
      "\u2028": "u2028",
      "\u2029": "u2029"
    }, Rf = parseFloat, Mf = parseInt, bs = typeof _n == "object" && _n && _n.Object === Object && _n, Df = typeof self == "object" && self && self.Object === Object && self, we = bs || Df || Function("return this")(), Si = s && !s.nodeType && s, Ht = Si && !0 && r && !r.nodeType && r, Ts = Ht && Ht.exports === Si, Pi = Ts && bs.process, Be = function() {
      try {
        var p = Ht && Ht.require && Ht.require("util").types;
        return p || Pi && Pi.binding && Pi.binding("util");
      } catch {
      }
    }(), $s = Be && Be.isArrayBuffer, As = Be && Be.isDate, Cs = Be && Be.isMap, Ss = Be && Be.isRegExp, Ps = Be && Be.isSet, Es = Be && Be.isTypedArray;
    function Le(p, y, v) {
      switch (v.length) {
        case 0:
          return p.call(y);
        case 1:
          return p.call(y, v[0]);
        case 2:
          return p.call(y, v[0], v[1]);
        case 3:
          return p.call(y, v[0], v[1], v[2]);
      }
      return p.apply(y, v);
    }
    function Wf(p, y, v, S) {
      for (var B = -1, j = p == null ? 0 : p.length; ++B < j; ) {
        var ge = p[B];
        y(S, ge, v(ge), p);
      }
      return S;
    }
    function He(p, y) {
      for (var v = -1, S = p == null ? 0 : p.length; ++v < S && y(p[v], v, p) !== !1; )
        ;
      return p;
    }
    function Nf(p, y) {
      for (var v = p == null ? 0 : p.length; v-- && y(p[v], v, p) !== !1; )
        ;
      return p;
    }
    function Os(p, y) {
      for (var v = -1, S = p == null ? 0 : p.length; ++v < S; )
        if (!y(p[v], v, p))
          return !1;
      return !0;
    }
    function xt(p, y) {
      for (var v = -1, S = p == null ? 0 : p.length, B = 0, j = []; ++v < S; ) {
        var ge = p[v];
        y(ge, v, p) && (j[B++] = ge);
      }
      return j;
    }
    function ar(p, y) {
      var v = p == null ? 0 : p.length;
      return !!v && nn(p, y, 0) > -1;
    }
    function Ei(p, y, v) {
      for (var S = -1, B = p == null ? 0 : p.length; ++S < B; )
        if (v(y, p[S]))
          return !0;
      return !1;
    }
    function ae(p, y) {
      for (var v = -1, S = p == null ? 0 : p.length, B = Array(S); ++v < S; )
        B[v] = y(p[v], v, p);
      return B;
    }
    function bt(p, y) {
      for (var v = -1, S = y.length, B = p.length; ++v < S; )
        p[B + v] = y[v];
      return p;
    }
    function Oi(p, y, v, S) {
      var B = -1, j = p == null ? 0 : p.length;
      for (S && j && (v = p[++B]); ++B < j; )
        v = y(v, p[B], B, p);
      return v;
    }
    function Bf(p, y, v, S) {
      var B = p == null ? 0 : p.length;
      for (S && B && (v = p[--B]); B--; )
        v = y(v, p[B], B, p);
      return v;
    }
    function Li(p, y) {
      for (var v = -1, S = p == null ? 0 : p.length; ++v < S; )
        if (y(p[v], v, p))
          return !0;
      return !1;
    }
    var Hf = Ii("length");
    function Ff(p) {
      return p.split("");
    }
    function zf(p) {
      return p.match(Yl) || [];
    }
    function Ls(p, y, v) {
      var S;
      return v(p, function(B, j, ge) {
        if (y(B, j, ge))
          return S = j, !1;
      }), S;
    }
    function lr(p, y, v, S) {
      for (var B = p.length, j = v + (S ? 1 : -1); S ? j-- : ++j < B; )
        if (y(p[j], j, p))
          return j;
      return -1;
    }
    function nn(p, y, v) {
      return y === y ? jf(p, y, v) : lr(p, Is, v);
    }
    function Uf(p, y, v, S) {
      for (var B = v - 1, j = p.length; ++B < j; )
        if (S(p[B], y))
          return B;
      return -1;
    }
    function Is(p) {
      return p !== p;
    }
    function Rs(p, y) {
      var v = p == null ? 0 : p.length;
      return v ? Mi(p, y) / v : er;
    }
    function Ii(p) {
      return function(y) {
        return y == null ? o : y[p];
      };
    }
    function Ri(p) {
      return function(y) {
        return p == null ? o : p[y];
      };
    }
    function Ms(p, y, v, S, B) {
      return B(p, function(j, ge, re) {
        v = S ? (S = !1, j) : y(v, j, ge, re);
      }), v;
    }
    function kf(p, y) {
      var v = p.length;
      for (p.sort(y); v--; )
        p[v] = p[v].value;
      return p;
    }
    function Mi(p, y) {
      for (var v, S = -1, B = p.length; ++S < B; ) {
        var j = y(p[S]);
        j !== o && (v = v === o ? j : v + j);
      }
      return v;
    }
    function Di(p, y) {
      for (var v = -1, S = Array(p); ++v < p; )
        S[v] = y(v);
      return S;
    }
    function qf(p, y) {
      return ae(y, function(v) {
        return [v, p[v]];
      });
    }
    function Ds(p) {
      return p && p.slice(0, Hs(p) + 1).replace(xi, "");
    }
    function Ie(p) {
      return function(y) {
        return p(y);
      };
    }
    function Wi(p, y) {
      return ae(y, function(v) {
        return p[v];
      });
    }
    function On(p, y) {
      return p.has(y);
    }
    function Ws(p, y) {
      for (var v = -1, S = p.length; ++v < S && nn(y, p[v], 0) > -1; )
        ;
      return v;
    }
    function Ns(p, y) {
      for (var v = p.length; v-- && nn(y, p[v], 0) > -1; )
        ;
      return v;
    }
    function Gf(p, y) {
      for (var v = p.length, S = 0; v--; )
        p[v] === y && ++S;
      return S;
    }
    var Vf = Ri(Ef), Kf = Ri(Of);
    function Yf(p) {
      return "\\" + If[p];
    }
    function Xf(p, y) {
      return p == null ? o : p[y];
    }
    function rn(p) {
      return Af.test(p);
    }
    function Zf(p) {
      return Cf.test(p);
    }
    function Jf(p) {
      for (var y, v = []; !(y = p.next()).done; )
        v.push(y.value);
      return v;
    }
    function Ni(p) {
      var y = -1, v = Array(p.size);
      return p.forEach(function(S, B) {
        v[++y] = [B, S];
      }), v;
    }
    function Bs(p, y) {
      return function(v) {
        return p(y(v));
      };
    }
    function Tt(p, y) {
      for (var v = -1, S = p.length, B = 0, j = []; ++v < S; ) {
        var ge = p[v];
        (ge === y || ge === C) && (p[v] = C, j[B++] = v);
      }
      return j;
    }
    function fr(p) {
      var y = -1, v = Array(p.size);
      return p.forEach(function(S) {
        v[++y] = S;
      }), v;
    }
    function Qf(p) {
      var y = -1, v = Array(p.size);
      return p.forEach(function(S) {
        v[++y] = [S, S];
      }), v;
    }
    function jf(p, y, v) {
      for (var S = v - 1, B = p.length; ++S < B; )
        if (p[S] === y)
          return S;
      return -1;
    }
    function ec(p, y, v) {
      for (var S = v + 1; S--; )
        if (p[S] === y)
          return S;
      return S;
    }
    function on(p) {
      return rn(p) ? nc(p) : Hf(p);
    }
    function Ye(p) {
      return rn(p) ? rc(p) : Ff(p);
    }
    function Hs(p) {
      for (var y = p.length; y-- && ql.test(p.charAt(y)); )
        ;
      return y;
    }
    var tc = Ri(Lf);
    function nc(p) {
      for (var y = Ci.lastIndex = 0; Ci.test(p); )
        ++y;
      return y;
    }
    function rc(p) {
      return p.match(Ci) || [];
    }
    function ic(p) {
      return p.match($f) || [];
    }
    var oc = function p(y) {
      y = y == null ? we : sn.defaults(we.Object(), y, sn.pick(we, Sf));
      var v = y.Array, S = y.Date, B = y.Error, j = y.Function, ge = y.Math, re = y.Object, Bi = y.RegExp, sc = y.String, Fe = y.TypeError, cr = v.prototype, uc = j.prototype, un = re.prototype, hr = y["__core-js_shared__"], dr = uc.toString, ne = un.hasOwnProperty, ac = 0, Fs = function() {
        var e = /[^.]+$/.exec(hr && hr.keys && hr.keys.IE_PROTO || "");
        return e ? "Symbol(src)_1." + e : "";
      }(), pr = un.toString, lc = dr.call(re), fc = we._, cc = Bi(
        "^" + dr.call(ne).replace(yi, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
      ), gr = Ts ? y.Buffer : o, $t = y.Symbol, _r = y.Uint8Array, zs = gr ? gr.allocUnsafe : o, vr = Bs(re.getPrototypeOf, re), Us = re.create, ks = un.propertyIsEnumerable, mr = cr.splice, qs = $t ? $t.isConcatSpreadable : o, Ln = $t ? $t.iterator : o, Ft = $t ? $t.toStringTag : o, wr = function() {
        try {
          var e = Gt(re, "defineProperty");
          return e({}, "", {}), e;
        } catch {
        }
      }(), hc = y.clearTimeout !== we.clearTimeout && y.clearTimeout, dc = S && S.now !== we.Date.now && S.now, pc = y.setTimeout !== we.setTimeout && y.setTimeout, yr = ge.ceil, xr = ge.floor, Hi = re.getOwnPropertySymbols, gc = gr ? gr.isBuffer : o, Gs = y.isFinite, _c = cr.join, vc = Bs(re.keys, re), _e = ge.max, xe = ge.min, mc = S.now, wc = y.parseInt, Vs = ge.random, yc = cr.reverse, Fi = Gt(y, "DataView"), In = Gt(y, "Map"), zi = Gt(y, "Promise"), an = Gt(y, "Set"), Rn = Gt(y, "WeakMap"), Mn = Gt(re, "create"), br = Rn && new Rn(), ln = {}, xc = Vt(Fi), bc = Vt(In), Tc = Vt(zi), $c = Vt(an), Ac = Vt(Rn), Tr = $t ? $t.prototype : o, Dn = Tr ? Tr.valueOf : o, Ks = Tr ? Tr.toString : o;
      function a(e) {
        if (fe(e) && !H(e) && !(e instanceof Y)) {
          if (e instanceof ze)
            return e;
          if (ne.call(e, "__wrapped__"))
            return Yu(e);
        }
        return new ze(e);
      }
      var fn = function() {
        function e() {
        }
        return function(t) {
          if (!le(t))
            return {};
          if (Us)
            return Us(t);
          e.prototype = t;
          var n = new e();
          return e.prototype = o, n;
        };
      }();
      function $r() {
      }
      function ze(e, t) {
        this.__wrapped__ = e, this.__actions__ = [], this.__chain__ = !!t, this.__index__ = 0, this.__values__ = o;
      }
      a.templateSettings = {
        escape: Bl,
        evaluate: Hl,
        interpolate: ns,
        variable: "",
        imports: {
          _: a
        }
      }, a.prototype = $r.prototype, a.prototype.constructor = a, ze.prototype = fn($r.prototype), ze.prototype.constructor = ze;
      function Y(e) {
        this.__wrapped__ = e, this.__actions__ = [], this.__dir__ = 1, this.__filtered__ = !1, this.__iteratees__ = [], this.__takeCount__ = et, this.__views__ = [];
      }
      function Cc() {
        var e = new Y(this.__wrapped__);
        return e.__actions__ = Se(this.__actions__), e.__dir__ = this.__dir__, e.__filtered__ = this.__filtered__, e.__iteratees__ = Se(this.__iteratees__), e.__takeCount__ = this.__takeCount__, e.__views__ = Se(this.__views__), e;
      }
      function Sc() {
        if (this.__filtered__) {
          var e = new Y(this);
          e.__dir__ = -1, e.__filtered__ = !0;
        } else
          e = this.clone(), e.__dir__ *= -1;
        return e;
      }
      function Pc() {
        var e = this.__wrapped__.value(), t = this.__dir__, n = H(e), i = t < 0, u = n ? e.length : 0, l = Fh(0, u, this.__views__), f = l.start, h = l.end, g = h - f, x = i ? h : f - 1, b = this.__iteratees__, T = b.length, A = 0, P = xe(g, this.__takeCount__);
        if (!n || !i && u == g && P == g)
          return vu(e, this.__actions__);
        var R = [];
        e:
          for (; g-- && A < P; ) {
            x += t;
            for (var k = -1, M = e[x]; ++k < T; ) {
              var V = b[k], X = V.iteratee, De = V.type, Ae = X(M);
              if (De == bn)
                M = Ae;
              else if (!Ae) {
                if (De == Ne)
                  continue e;
                break e;
              }
            }
            R[A++] = M;
          }
        return R;
      }
      Y.prototype = fn($r.prototype), Y.prototype.constructor = Y;
      function zt(e) {
        var t = -1, n = e == null ? 0 : e.length;
        for (this.clear(); ++t < n; ) {
          var i = e[t];
          this.set(i[0], i[1]);
        }
      }
      function Ec() {
        this.__data__ = Mn ? Mn(null) : {}, this.size = 0;
      }
      function Oc(e) {
        var t = this.has(e) && delete this.__data__[e];
        return this.size -= t ? 1 : 0, t;
      }
      function Lc(e) {
        var t = this.__data__;
        if (Mn) {
          var n = t[e];
          return n === $ ? o : n;
        }
        return ne.call(t, e) ? t[e] : o;
      }
      function Ic(e) {
        var t = this.__data__;
        return Mn ? t[e] !== o : ne.call(t, e);
      }
      function Rc(e, t) {
        var n = this.__data__;
        return this.size += this.has(e) ? 0 : 1, n[e] = Mn && t === o ? $ : t, this;
      }
      zt.prototype.clear = Ec, zt.prototype.delete = Oc, zt.prototype.get = Lc, zt.prototype.has = Ic, zt.prototype.set = Rc;
      function ot(e) {
        var t = -1, n = e == null ? 0 : e.length;
        for (this.clear(); ++t < n; ) {
          var i = e[t];
          this.set(i[0], i[1]);
        }
      }
      function Mc() {
        this.__data__ = [], this.size = 0;
      }
      function Dc(e) {
        var t = this.__data__, n = Ar(t, e);
        if (n < 0)
          return !1;
        var i = t.length - 1;
        return n == i ? t.pop() : mr.call(t, n, 1), --this.size, !0;
      }
      function Wc(e) {
        var t = this.__data__, n = Ar(t, e);
        return n < 0 ? o : t[n][1];
      }
      function Nc(e) {
        return Ar(this.__data__, e) > -1;
      }
      function Bc(e, t) {
        var n = this.__data__, i = Ar(n, e);
        return i < 0 ? (++this.size, n.push([e, t])) : n[i][1] = t, this;
      }
      ot.prototype.clear = Mc, ot.prototype.delete = Dc, ot.prototype.get = Wc, ot.prototype.has = Nc, ot.prototype.set = Bc;
      function st(e) {
        var t = -1, n = e == null ? 0 : e.length;
        for (this.clear(); ++t < n; ) {
          var i = e[t];
          this.set(i[0], i[1]);
        }
      }
      function Hc() {
        this.size = 0, this.__data__ = {
          hash: new zt(),
          map: new (In || ot)(),
          string: new zt()
        };
      }
      function Fc(e) {
        var t = Nr(this, e).delete(e);
        return this.size -= t ? 1 : 0, t;
      }
      function zc(e) {
        return Nr(this, e).get(e);
      }
      function Uc(e) {
        return Nr(this, e).has(e);
      }
      function kc(e, t) {
        var n = Nr(this, e), i = n.size;
        return n.set(e, t), this.size += n.size == i ? 0 : 1, this;
      }
      st.prototype.clear = Hc, st.prototype.delete = Fc, st.prototype.get = zc, st.prototype.has = Uc, st.prototype.set = kc;
      function Ut(e) {
        var t = -1, n = e == null ? 0 : e.length;
        for (this.__data__ = new st(); ++t < n; )
          this.add(e[t]);
      }
      function qc(e) {
        return this.__data__.set(e, $), this;
      }
      function Gc(e) {
        return this.__data__.has(e);
      }
      Ut.prototype.add = Ut.prototype.push = qc, Ut.prototype.has = Gc;
      function Xe(e) {
        var t = this.__data__ = new ot(e);
        this.size = t.size;
      }
      function Vc() {
        this.__data__ = new ot(), this.size = 0;
      }
      function Kc(e) {
        var t = this.__data__, n = t.delete(e);
        return this.size = t.size, n;
      }
      function Yc(e) {
        return this.__data__.get(e);
      }
      function Xc(e) {
        return this.__data__.has(e);
      }
      function Zc(e, t) {
        var n = this.__data__;
        if (n instanceof ot) {
          var i = n.__data__;
          if (!In || i.length < d - 1)
            return i.push([e, t]), this.size = ++n.size, this;
          n = this.__data__ = new st(i);
        }
        return n.set(e, t), this.size = n.size, this;
      }
      Xe.prototype.clear = Vc, Xe.prototype.delete = Kc, Xe.prototype.get = Yc, Xe.prototype.has = Xc, Xe.prototype.set = Zc;
      function Ys(e, t) {
        var n = H(e), i = !n && Kt(e), u = !n && !i && Et(e), l = !n && !i && !u && pn(e), f = n || i || u || l, h = f ? Di(e.length, sc) : [], g = h.length;
        for (var x in e)
          (t || ne.call(e, x)) && !(f && (x == "length" || u && (x == "offset" || x == "parent") || l && (x == "buffer" || x == "byteLength" || x == "byteOffset") || ft(x, g))) && h.push(x);
        return h;
      }
      function Xs(e) {
        var t = e.length;
        return t ? e[Qi(0, t - 1)] : o;
      }
      function Jc(e, t) {
        return Br(Se(e), kt(t, 0, e.length));
      }
      function Qc(e) {
        return Br(Se(e));
      }
      function Ui(e, t, n) {
        (n !== o && !Ze(e[t], n) || n === o && !(t in e)) && ut(e, t, n);
      }
      function Wn(e, t, n) {
        var i = e[t];
        (!(ne.call(e, t) && Ze(i, n)) || n === o && !(t in e)) && ut(e, t, n);
      }
      function Ar(e, t) {
        for (var n = e.length; n--; )
          if (Ze(e[n][0], t))
            return n;
        return -1;
      }
      function jc(e, t, n, i) {
        return At(e, function(u, l, f) {
          t(i, u, n(u), f);
        }), i;
      }
      function Zs(e, t) {
        return e && nt(t, ve(t), e);
      }
      function eh(e, t) {
        return e && nt(t, Ee(t), e);
      }
      function ut(e, t, n) {
        t == "__proto__" && wr ? wr(e, t, {
          configurable: !0,
          enumerable: !0,
          value: n,
          writable: !0
        }) : e[t] = n;
      }
      function ki(e, t) {
        for (var n = -1, i = t.length, u = v(i), l = e == null; ++n < i; )
          u[n] = l ? o : $o(e, t[n]);
        return u;
      }
      function kt(e, t, n) {
        return e === e && (n !== o && (e = e <= n ? e : n), t !== o && (e = e >= t ? e : t)), e;
      }
      function Ue(e, t, n, i, u, l) {
        var f, h = t & E, g = t & O, x = t & D;
        if (n && (f = u ? n(e, i, u, l) : n(e)), f !== o)
          return f;
        if (!le(e))
          return e;
        var b = H(e);
        if (b) {
          if (f = Uh(e), !h)
            return Se(e, f);
        } else {
          var T = be(e), A = T == rr || T == Qo;
          if (Et(e))
            return yu(e, h);
          if (T == it || T == jt || A && !u) {
            if (f = g || A ? {} : Hu(e), !h)
              return g ? Lh(e, eh(f, e)) : Oh(e, Zs(f, e));
          } else {
            if (!ie[T])
              return u ? e : {};
            f = kh(e, T, h);
          }
        }
        l || (l = new Xe());
        var P = l.get(e);
        if (P)
          return P;
        l.set(e, f), pa(e) ? e.forEach(function(M) {
          f.add(Ue(M, t, n, M, e, l));
        }) : ha(e) && e.forEach(function(M, V) {
          f.set(V, Ue(M, t, n, V, e, l));
        });
        var R = x ? g ? lo : ao : g ? Ee : ve, k = b ? o : R(e);
        return He(k || e, function(M, V) {
          k && (V = M, M = e[V]), Wn(f, V, Ue(M, t, n, V, e, l));
        }), f;
      }
      function th(e) {
        var t = ve(e);
        return function(n) {
          return Js(n, e, t);
        };
      }
      function Js(e, t, n) {
        var i = n.length;
        if (e == null)
          return !i;
        for (e = re(e); i--; ) {
          var u = n[i], l = t[u], f = e[u];
          if (f === o && !(u in e) || !l(f))
            return !1;
        }
        return !0;
      }
      function Qs(e, t, n) {
        if (typeof e != "function")
          throw new Fe(m);
        return kn(function() {
          e.apply(o, n);
        }, t);
      }
      function Nn(e, t, n, i) {
        var u = -1, l = ar, f = !0, h = e.length, g = [], x = t.length;
        if (!h)
          return g;
        n && (t = ae(t, Ie(n))), i ? (l = Ei, f = !1) : t.length >= d && (l = On, f = !1, t = new Ut(t));
        e:
          for (; ++u < h; ) {
            var b = e[u], T = n == null ? b : n(b);
            if (b = i || b !== 0 ? b : 0, f && T === T) {
              for (var A = x; A--; )
                if (t[A] === T)
                  continue e;
              g.push(b);
            } else
              l(t, T, i) || g.push(b);
          }
        return g;
      }
      var At = Au(tt), js = Au(Gi, !0);
      function nh(e, t) {
        var n = !0;
        return At(e, function(i, u, l) {
          return n = !!t(i, u, l), n;
        }), n;
      }
      function Cr(e, t, n) {
        for (var i = -1, u = e.length; ++i < u; ) {
          var l = e[i], f = t(l);
          if (f != null && (h === o ? f === f && !Me(f) : n(f, h)))
            var h = f, g = l;
        }
        return g;
      }
      function rh(e, t, n, i) {
        var u = e.length;
        for (n = z(n), n < 0 && (n = -n > u ? 0 : u + n), i = i === o || i > u ? u : z(i), i < 0 && (i += u), i = n > i ? 0 : _a(i); n < i; )
          e[n++] = t;
        return e;
      }
      function eu(e, t) {
        var n = [];
        return At(e, function(i, u, l) {
          t(i, u, l) && n.push(i);
        }), n;
      }
      function ye(e, t, n, i, u) {
        var l = -1, f = e.length;
        for (n || (n = Gh), u || (u = []); ++l < f; ) {
          var h = e[l];
          t > 0 && n(h) ? t > 1 ? ye(h, t - 1, n, i, u) : bt(u, h) : i || (u[u.length] = h);
        }
        return u;
      }
      var qi = Cu(), tu = Cu(!0);
      function tt(e, t) {
        return e && qi(e, t, ve);
      }
      function Gi(e, t) {
        return e && tu(e, t, ve);
      }
      function Sr(e, t) {
        return xt(t, function(n) {
          return ct(e[n]);
        });
      }
      function qt(e, t) {
        t = St(t, e);
        for (var n = 0, i = t.length; e != null && n < i; )
          e = e[rt(t[n++])];
        return n && n == i ? e : o;
      }
      function nu(e, t, n) {
        var i = t(e);
        return H(e) ? i : bt(i, n(e));
      }
      function Te(e) {
        return e == null ? e === o ? Ll : El : Ft && Ft in re(e) ? Hh(e) : Qh(e);
      }
      function Vi(e, t) {
        return e > t;
      }
      function ih(e, t) {
        return e != null && ne.call(e, t);
      }
      function oh(e, t) {
        return e != null && t in re(e);
      }
      function sh(e, t, n) {
        return e >= xe(t, n) && e < _e(t, n);
      }
      function Ki(e, t, n) {
        for (var i = n ? Ei : ar, u = e[0].length, l = e.length, f = l, h = v(l), g = 1 / 0, x = []; f--; ) {
          var b = e[f];
          f && t && (b = ae(b, Ie(t))), g = xe(b.length, g), h[f] = !n && (t || u >= 120 && b.length >= 120) ? new Ut(f && b) : o;
        }
        b = e[0];
        var T = -1, A = h[0];
        e:
          for (; ++T < u && x.length < g; ) {
            var P = b[T], R = t ? t(P) : P;
            if (P = n || P !== 0 ? P : 0, !(A ? On(A, R) : i(x, R, n))) {
              for (f = l; --f; ) {
                var k = h[f];
                if (!(k ? On(k, R) : i(e[f], R, n)))
                  continue e;
              }
              A && A.push(R), x.push(P);
            }
          }
        return x;
      }
      function uh(e, t, n, i) {
        return tt(e, function(u, l, f) {
          t(i, n(u), l, f);
        }), i;
      }
      function Bn(e, t, n) {
        t = St(t, e), e = ku(e, t);
        var i = e == null ? e : e[rt(qe(t))];
        return i == null ? o : Le(i, e, n);
      }
      function ru(e) {
        return fe(e) && Te(e) == jt;
      }
      function ah(e) {
        return fe(e) && Te(e) == En;
      }
      function lh(e) {
        return fe(e) && Te(e) == $n;
      }
      function Hn(e, t, n, i, u) {
        return e === t ? !0 : e == null || t == null || !fe(e) && !fe(t) ? e !== e && t !== t : fh(e, t, n, i, Hn, u);
      }
      function fh(e, t, n, i, u, l) {
        var f = H(e), h = H(t), g = f ? tr : be(e), x = h ? tr : be(t);
        g = g == jt ? it : g, x = x == jt ? it : x;
        var b = g == it, T = x == it, A = g == x;
        if (A && Et(e)) {
          if (!Et(t))
            return !1;
          f = !0, b = !1;
        }
        if (A && !b)
          return l || (l = new Xe()), f || pn(e) ? Wu(e, t, n, i, u, l) : Nh(e, t, g, n, i, u, l);
        if (!(n & U)) {
          var P = b && ne.call(e, "__wrapped__"), R = T && ne.call(t, "__wrapped__");
          if (P || R) {
            var k = P ? e.value() : e, M = R ? t.value() : t;
            return l || (l = new Xe()), u(k, M, n, i, l);
          }
        }
        return A ? (l || (l = new Xe()), Bh(e, t, n, i, u, l)) : !1;
      }
      function ch(e) {
        return fe(e) && be(e) == Ve;
      }
      function Yi(e, t, n, i) {
        var u = n.length, l = u, f = !i;
        if (e == null)
          return !l;
        for (e = re(e); u--; ) {
          var h = n[u];
          if (f && h[2] ? h[1] !== e[h[0]] : !(h[0] in e))
            return !1;
        }
        for (; ++u < l; ) {
          h = n[u];
          var g = h[0], x = e[g], b = h[1];
          if (f && h[2]) {
            if (x === o && !(g in e))
              return !1;
          } else {
            var T = new Xe();
            if (i)
              var A = i(x, b, g, e, t, T);
            if (!(A === o ? Hn(b, x, U | Q, i, T) : A))
              return !1;
          }
        }
        return !0;
      }
      function iu(e) {
        if (!le(e) || Kh(e))
          return !1;
        var t = ct(e) ? cc : ef;
        return t.test(Vt(e));
      }
      function hh(e) {
        return fe(e) && Te(e) == Cn;
      }
      function dh(e) {
        return fe(e) && be(e) == Ke;
      }
      function ph(e) {
        return fe(e) && qr(e.length) && !!oe[Te(e)];
      }
      function ou(e) {
        return typeof e == "function" ? e : e == null ? Oe : typeof e == "object" ? H(e) ? au(e[0], e[1]) : uu(e) : Sa(e);
      }
      function Xi(e) {
        if (!Un(e))
          return vc(e);
        var t = [];
        for (var n in re(e))
          ne.call(e, n) && n != "constructor" && t.push(n);
        return t;
      }
      function gh(e) {
        if (!le(e))
          return Jh(e);
        var t = Un(e), n = [];
        for (var i in e)
          i == "constructor" && (t || !ne.call(e, i)) || n.push(i);
        return n;
      }
      function Zi(e, t) {
        return e < t;
      }
      function su(e, t) {
        var n = -1, i = Pe(e) ? v(e.length) : [];
        return At(e, function(u, l, f) {
          i[++n] = t(u, l, f);
        }), i;
      }
      function uu(e) {
        var t = co(e);
        return t.length == 1 && t[0][2] ? zu(t[0][0], t[0][1]) : function(n) {
          return n === e || Yi(n, e, t);
        };
      }
      function au(e, t) {
        return po(e) && Fu(t) ? zu(rt(e), t) : function(n) {
          var i = $o(n, e);
          return i === o && i === t ? Ao(n, e) : Hn(t, i, U | Q);
        };
      }
      function Pr(e, t, n, i, u) {
        e !== t && qi(t, function(l, f) {
          if (u || (u = new Xe()), le(l))
            _h(e, t, f, n, Pr, i, u);
          else {
            var h = i ? i(_o(e, f), l, f + "", e, t, u) : o;
            h === o && (h = l), Ui(e, f, h);
          }
        }, Ee);
      }
      function _h(e, t, n, i, u, l, f) {
        var h = _o(e, n), g = _o(t, n), x = f.get(g);
        if (x) {
          Ui(e, n, x);
          return;
        }
        var b = l ? l(h, g, n + "", e, t, f) : o, T = b === o;
        if (T) {
          var A = H(g), P = !A && Et(g), R = !A && !P && pn(g);
          b = g, A || P || R ? H(h) ? b = h : he(h) ? b = Se(h) : P ? (T = !1, b = yu(g, !0)) : R ? (T = !1, b = xu(g, !0)) : b = [] : qn(g) || Kt(g) ? (b = h, Kt(h) ? b = va(h) : (!le(h) || ct(h)) && (b = Hu(g))) : T = !1;
        }
        T && (f.set(g, b), u(b, g, i, l, f), f.delete(g)), Ui(e, n, b);
      }
      function lu(e, t) {
        var n = e.length;
        if (!!n)
          return t += t < 0 ? n : 0, ft(t, n) ? e[t] : o;
      }
      function fu(e, t, n) {
        t.length ? t = ae(t, function(l) {
          return H(l) ? function(f) {
            return qt(f, l.length === 1 ? l[0] : l);
          } : l;
        }) : t = [Oe];
        var i = -1;
        t = ae(t, Ie(I()));
        var u = su(e, function(l, f, h) {
          var g = ae(t, function(x) {
            return x(l);
          });
          return { criteria: g, index: ++i, value: l };
        });
        return kf(u, function(l, f) {
          return Eh(l, f, n);
        });
      }
      function vh(e, t) {
        return cu(e, t, function(n, i) {
          return Ao(e, i);
        });
      }
      function cu(e, t, n) {
        for (var i = -1, u = t.length, l = {}; ++i < u; ) {
          var f = t[i], h = qt(e, f);
          n(h, f) && Fn(l, St(f, e), h);
        }
        return l;
      }
      function mh(e) {
        return function(t) {
          return qt(t, e);
        };
      }
      function Ji(e, t, n, i) {
        var u = i ? Uf : nn, l = -1, f = t.length, h = e;
        for (e === t && (t = Se(t)), n && (h = ae(e, Ie(n))); ++l < f; )
          for (var g = 0, x = t[l], b = n ? n(x) : x; (g = u(h, b, g, i)) > -1; )
            h !== e && mr.call(h, g, 1), mr.call(e, g, 1);
        return e;
      }
      function hu(e, t) {
        for (var n = e ? t.length : 0, i = n - 1; n--; ) {
          var u = t[n];
          if (n == i || u !== l) {
            var l = u;
            ft(u) ? mr.call(e, u, 1) : to(e, u);
          }
        }
        return e;
      }
      function Qi(e, t) {
        return e + xr(Vs() * (t - e + 1));
      }
      function wh(e, t, n, i) {
        for (var u = -1, l = _e(yr((t - e) / (n || 1)), 0), f = v(l); l--; )
          f[i ? l : ++u] = e, e += n;
        return f;
      }
      function ji(e, t) {
        var n = "";
        if (!e || t < 1 || t > yt)
          return n;
        do
          t % 2 && (n += e), t = xr(t / 2), t && (e += e);
        while (t);
        return n;
      }
      function q(e, t) {
        return vo(Uu(e, t, Oe), e + "");
      }
      function yh(e) {
        return Xs(gn(e));
      }
      function xh(e, t) {
        var n = gn(e);
        return Br(n, kt(t, 0, n.length));
      }
      function Fn(e, t, n, i) {
        if (!le(e))
          return e;
        t = St(t, e);
        for (var u = -1, l = t.length, f = l - 1, h = e; h != null && ++u < l; ) {
          var g = rt(t[u]), x = n;
          if (g === "__proto__" || g === "constructor" || g === "prototype")
            return e;
          if (u != f) {
            var b = h[g];
            x = i ? i(b, g, h) : o, x === o && (x = le(b) ? b : ft(t[u + 1]) ? [] : {});
          }
          Wn(h, g, x), h = h[g];
        }
        return e;
      }
      var du = br ? function(e, t) {
        return br.set(e, t), e;
      } : Oe, bh = wr ? function(e, t) {
        return wr(e, "toString", {
          configurable: !0,
          enumerable: !1,
          value: So(t),
          writable: !0
        });
      } : Oe;
      function Th(e) {
        return Br(gn(e));
      }
      function ke(e, t, n) {
        var i = -1, u = e.length;
        t < 0 && (t = -t > u ? 0 : u + t), n = n > u ? u : n, n < 0 && (n += u), u = t > n ? 0 : n - t >>> 0, t >>>= 0;
        for (var l = v(u); ++i < u; )
          l[i] = e[i + t];
        return l;
      }
      function $h(e, t) {
        var n;
        return At(e, function(i, u, l) {
          return n = t(i, u, l), !n;
        }), !!n;
      }
      function Er(e, t, n) {
        var i = 0, u = e == null ? i : e.length;
        if (typeof t == "number" && t === t && u <= Al) {
          for (; i < u; ) {
            var l = i + u >>> 1, f = e[l];
            f !== null && !Me(f) && (n ? f <= t : f < t) ? i = l + 1 : u = l;
          }
          return u;
        }
        return eo(e, t, Oe, n);
      }
      function eo(e, t, n, i) {
        var u = 0, l = e == null ? 0 : e.length;
        if (l === 0)
          return 0;
        t = n(t);
        for (var f = t !== t, h = t === null, g = Me(t), x = t === o; u < l; ) {
          var b = xr((u + l) / 2), T = n(e[b]), A = T !== o, P = T === null, R = T === T, k = Me(T);
          if (f)
            var M = i || R;
          else
            x ? M = R && (i || A) : h ? M = R && A && (i || !P) : g ? M = R && A && !P && (i || !k) : P || k ? M = !1 : M = i ? T <= t : T < t;
          M ? u = b + 1 : l = b;
        }
        return xe(l, $l);
      }
      function pu(e, t) {
        for (var n = -1, i = e.length, u = 0, l = []; ++n < i; ) {
          var f = e[n], h = t ? t(f) : f;
          if (!n || !Ze(h, g)) {
            var g = h;
            l[u++] = f === 0 ? 0 : f;
          }
        }
        return l;
      }
      function gu(e) {
        return typeof e == "number" ? e : Me(e) ? er : +e;
      }
      function Re(e) {
        if (typeof e == "string")
          return e;
        if (H(e))
          return ae(e, Re) + "";
        if (Me(e))
          return Ks ? Ks.call(e) : "";
        var t = e + "";
        return t == "0" && 1 / e == -Bt ? "-0" : t;
      }
      function Ct(e, t, n) {
        var i = -1, u = ar, l = e.length, f = !0, h = [], g = h;
        if (n)
          f = !1, u = Ei;
        else if (l >= d) {
          var x = t ? null : Dh(e);
          if (x)
            return fr(x);
          f = !1, u = On, g = new Ut();
        } else
          g = t ? [] : h;
        e:
          for (; ++i < l; ) {
            var b = e[i], T = t ? t(b) : b;
            if (b = n || b !== 0 ? b : 0, f && T === T) {
              for (var A = g.length; A--; )
                if (g[A] === T)
                  continue e;
              t && g.push(T), h.push(b);
            } else
              u(g, T, n) || (g !== h && g.push(T), h.push(b));
          }
        return h;
      }
      function to(e, t) {
        return t = St(t, e), e = ku(e, t), e == null || delete e[rt(qe(t))];
      }
      function _u(e, t, n, i) {
        return Fn(e, t, n(qt(e, t)), i);
      }
      function Or(e, t, n, i) {
        for (var u = e.length, l = i ? u : -1; (i ? l-- : ++l < u) && t(e[l], l, e); )
          ;
        return n ? ke(e, i ? 0 : l, i ? l + 1 : u) : ke(e, i ? l + 1 : 0, i ? u : l);
      }
      function vu(e, t) {
        var n = e;
        return n instanceof Y && (n = n.value()), Oi(t, function(i, u) {
          return u.func.apply(u.thisArg, bt([i], u.args));
        }, n);
      }
      function no(e, t, n) {
        var i = e.length;
        if (i < 2)
          return i ? Ct(e[0]) : [];
        for (var u = -1, l = v(i); ++u < i; )
          for (var f = e[u], h = -1; ++h < i; )
            h != u && (l[u] = Nn(l[u] || f, e[h], t, n));
        return Ct(ye(l, 1), t, n);
      }
      function mu(e, t, n) {
        for (var i = -1, u = e.length, l = t.length, f = {}; ++i < u; ) {
          var h = i < l ? t[i] : o;
          n(f, e[i], h);
        }
        return f;
      }
      function ro(e) {
        return he(e) ? e : [];
      }
      function io(e) {
        return typeof e == "function" ? e : Oe;
      }
      function St(e, t) {
        return H(e) ? e : po(e, t) ? [e] : Ku(te(e));
      }
      var Ah = q;
      function Pt(e, t, n) {
        var i = e.length;
        return n = n === o ? i : n, !t && n >= i ? e : ke(e, t, n);
      }
      var wu = hc || function(e) {
        return we.clearTimeout(e);
      };
      function yu(e, t) {
        if (t)
          return e.slice();
        var n = e.length, i = zs ? zs(n) : new e.constructor(n);
        return e.copy(i), i;
      }
      function oo(e) {
        var t = new e.constructor(e.byteLength);
        return new _r(t).set(new _r(e)), t;
      }
      function Ch(e, t) {
        var n = t ? oo(e.buffer) : e.buffer;
        return new e.constructor(n, e.byteOffset, e.byteLength);
      }
      function Sh(e) {
        var t = new e.constructor(e.source, rs.exec(e));
        return t.lastIndex = e.lastIndex, t;
      }
      function Ph(e) {
        return Dn ? re(Dn.call(e)) : {};
      }
      function xu(e, t) {
        var n = t ? oo(e.buffer) : e.buffer;
        return new e.constructor(n, e.byteOffset, e.length);
      }
      function bu(e, t) {
        if (e !== t) {
          var n = e !== o, i = e === null, u = e === e, l = Me(e), f = t !== o, h = t === null, g = t === t, x = Me(t);
          if (!h && !x && !l && e > t || l && f && g && !h && !x || i && f && g || !n && g || !u)
            return 1;
          if (!i && !l && !x && e < t || x && n && u && !i && !l || h && n && u || !f && u || !g)
            return -1;
        }
        return 0;
      }
      function Eh(e, t, n) {
        for (var i = -1, u = e.criteria, l = t.criteria, f = u.length, h = n.length; ++i < f; ) {
          var g = bu(u[i], l[i]);
          if (g) {
            if (i >= h)
              return g;
            var x = n[i];
            return g * (x == "desc" ? -1 : 1);
          }
        }
        return e.index - t.index;
      }
      function Tu(e, t, n, i) {
        for (var u = -1, l = e.length, f = n.length, h = -1, g = t.length, x = _e(l - f, 0), b = v(g + x), T = !i; ++h < g; )
          b[h] = t[h];
        for (; ++u < f; )
          (T || u < l) && (b[n[u]] = e[u]);
        for (; x--; )
          b[h++] = e[u++];
        return b;
      }
      function $u(e, t, n, i) {
        for (var u = -1, l = e.length, f = -1, h = n.length, g = -1, x = t.length, b = _e(l - h, 0), T = v(b + x), A = !i; ++u < b; )
          T[u] = e[u];
        for (var P = u; ++g < x; )
          T[P + g] = t[g];
        for (; ++f < h; )
          (A || u < l) && (T[P + n[f]] = e[u++]);
        return T;
      }
      function Se(e, t) {
        var n = -1, i = e.length;
        for (t || (t = v(i)); ++n < i; )
          t[n] = e[n];
        return t;
      }
      function nt(e, t, n, i) {
        var u = !n;
        n || (n = {});
        for (var l = -1, f = t.length; ++l < f; ) {
          var h = t[l], g = i ? i(n[h], e[h], h, n, e) : o;
          g === o && (g = e[h]), u ? ut(n, h, g) : Wn(n, h, g);
        }
        return n;
      }
      function Oh(e, t) {
        return nt(e, ho(e), t);
      }
      function Lh(e, t) {
        return nt(e, Nu(e), t);
      }
      function Lr(e, t) {
        return function(n, i) {
          var u = H(n) ? Wf : jc, l = t ? t() : {};
          return u(n, e, I(i, 2), l);
        };
      }
      function cn(e) {
        return q(function(t, n) {
          var i = -1, u = n.length, l = u > 1 ? n[u - 1] : o, f = u > 2 ? n[2] : o;
          for (l = e.length > 3 && typeof l == "function" ? (u--, l) : o, f && $e(n[0], n[1], f) && (l = u < 3 ? o : l, u = 1), t = re(t); ++i < u; ) {
            var h = n[i];
            h && e(t, h, i, l);
          }
          return t;
        });
      }
      function Au(e, t) {
        return function(n, i) {
          if (n == null)
            return n;
          if (!Pe(n))
            return e(n, i);
          for (var u = n.length, l = t ? u : -1, f = re(n); (t ? l-- : ++l < u) && i(f[l], l, f) !== !1; )
            ;
          return n;
        };
      }
      function Cu(e) {
        return function(t, n, i) {
          for (var u = -1, l = re(t), f = i(t), h = f.length; h--; ) {
            var g = f[e ? h : ++u];
            if (n(l[g], g, l) === !1)
              break;
          }
          return t;
        };
      }
      function Ih(e, t, n) {
        var i = t & N, u = zn(e);
        function l() {
          var f = this && this !== we && this instanceof l ? u : e;
          return f.apply(i ? n : this, arguments);
        }
        return l;
      }
      function Su(e) {
        return function(t) {
          t = te(t);
          var n = rn(t) ? Ye(t) : o, i = n ? n[0] : t.charAt(0), u = n ? Pt(n, 1).join("") : t.slice(1);
          return i[e]() + u;
        };
      }
      function hn(e) {
        return function(t) {
          return Oi(Aa($a(t).replace(bf, "")), e, "");
        };
      }
      function zn(e) {
        return function() {
          var t = arguments;
          switch (t.length) {
            case 0:
              return new e();
            case 1:
              return new e(t[0]);
            case 2:
              return new e(t[0], t[1]);
            case 3:
              return new e(t[0], t[1], t[2]);
            case 4:
              return new e(t[0], t[1], t[2], t[3]);
            case 5:
              return new e(t[0], t[1], t[2], t[3], t[4]);
            case 6:
              return new e(t[0], t[1], t[2], t[3], t[4], t[5]);
            case 7:
              return new e(t[0], t[1], t[2], t[3], t[4], t[5], t[6]);
          }
          var n = fn(e.prototype), i = e.apply(n, t);
          return le(i) ? i : n;
        };
      }
      function Rh(e, t, n) {
        var i = zn(e);
        function u() {
          for (var l = arguments.length, f = v(l), h = l, g = dn(u); h--; )
            f[h] = arguments[h];
          var x = l < 3 && f[0] !== g && f[l - 1] !== g ? [] : Tt(f, g);
          if (l -= x.length, l < n)
            return Iu(
              e,
              t,
              Ir,
              u.placeholder,
              o,
              f,
              x,
              o,
              o,
              n - l
            );
          var b = this && this !== we && this instanceof u ? i : e;
          return Le(b, this, f);
        }
        return u;
      }
      function Pu(e) {
        return function(t, n, i) {
          var u = re(t);
          if (!Pe(t)) {
            var l = I(n, 3);
            t = ve(t), n = function(h) {
              return l(u[h], h, u);
            };
          }
          var f = e(t, n, i);
          return f > -1 ? u[l ? t[f] : f] : o;
        };
      }
      function Eu(e) {
        return lt(function(t) {
          var n = t.length, i = n, u = ze.prototype.thru;
          for (e && t.reverse(); i--; ) {
            var l = t[i];
            if (typeof l != "function")
              throw new Fe(m);
            if (u && !f && Wr(l) == "wrapper")
              var f = new ze([], !0);
          }
          for (i = f ? i : n; ++i < n; ) {
            l = t[i];
            var h = Wr(l), g = h == "wrapper" ? fo(l) : o;
            g && go(g[0]) && g[1] == (pe | W | se | ue) && !g[4].length && g[9] == 1 ? f = f[Wr(g[0])].apply(f, g[3]) : f = l.length == 1 && go(l) ? f[h]() : f.thru(l);
          }
          return function() {
            var x = arguments, b = x[0];
            if (f && x.length == 1 && H(b))
              return f.plant(b).value();
            for (var T = 0, A = n ? t[T].apply(this, x) : b; ++T < n; )
              A = t[T].call(this, A);
            return A;
          };
        });
      }
      function Ir(e, t, n, i, u, l, f, h, g, x) {
        var b = t & pe, T = t & N, A = t & G, P = t & (W | ee), R = t & me, k = A ? o : zn(e);
        function M() {
          for (var V = arguments.length, X = v(V), De = V; De--; )
            X[De] = arguments[De];
          if (P)
            var Ae = dn(M), We = Gf(X, Ae);
          if (i && (X = Tu(X, i, u, P)), l && (X = $u(X, l, f, P)), V -= We, P && V < x) {
            var de = Tt(X, Ae);
            return Iu(
              e,
              t,
              Ir,
              M.placeholder,
              n,
              X,
              de,
              h,
              g,
              x - V
            );
          }
          var Je = T ? n : this, dt = A ? Je[e] : e;
          return V = X.length, h ? X = jh(X, h) : R && V > 1 && X.reverse(), b && g < V && (X.length = g), this && this !== we && this instanceof M && (dt = k || zn(dt)), dt.apply(Je, X);
        }
        return M;
      }
      function Ou(e, t) {
        return function(n, i) {
          return uh(n, e, t(i), {});
        };
      }
      function Rr(e, t) {
        return function(n, i) {
          var u;
          if (n === o && i === o)
            return t;
          if (n !== o && (u = n), i !== o) {
            if (u === o)
              return i;
            typeof n == "string" || typeof i == "string" ? (n = Re(n), i = Re(i)) : (n = gu(n), i = gu(i)), u = e(n, i);
          }
          return u;
        };
      }
      function so(e) {
        return lt(function(t) {
          return t = ae(t, Ie(I())), q(function(n) {
            var i = this;
            return e(t, function(u) {
              return Le(u, i, n);
            });
          });
        });
      }
      function Mr(e, t) {
        t = t === o ? " " : Re(t);
        var n = t.length;
        if (n < 2)
          return n ? ji(t, e) : t;
        var i = ji(t, yr(e / on(t)));
        return rn(t) ? Pt(Ye(i), 0, e).join("") : i.slice(0, e);
      }
      function Mh(e, t, n, i) {
        var u = t & N, l = zn(e);
        function f() {
          for (var h = -1, g = arguments.length, x = -1, b = i.length, T = v(b + g), A = this && this !== we && this instanceof f ? l : e; ++x < b; )
            T[x] = i[x];
          for (; g--; )
            T[x++] = arguments[++h];
          return Le(A, u ? n : this, T);
        }
        return f;
      }
      function Lu(e) {
        return function(t, n, i) {
          return i && typeof i != "number" && $e(t, n, i) && (n = i = o), t = ht(t), n === o ? (n = t, t = 0) : n = ht(n), i = i === o ? t < n ? 1 : -1 : ht(i), wh(t, n, i, e);
        };
      }
      function Dr(e) {
        return function(t, n) {
          return typeof t == "string" && typeof n == "string" || (t = Ge(t), n = Ge(n)), e(t, n);
        };
      }
      function Iu(e, t, n, i, u, l, f, h, g, x) {
        var b = t & W, T = b ? f : o, A = b ? o : f, P = b ? l : o, R = b ? o : l;
        t |= b ? se : ce, t &= ~(b ? ce : se), t & F || (t &= ~(N | G));
        var k = [
          e,
          t,
          u,
          P,
          T,
          R,
          A,
          h,
          g,
          x
        ], M = n.apply(o, k);
        return go(e) && qu(M, k), M.placeholder = i, Gu(M, e, t);
      }
      function uo(e) {
        var t = ge[e];
        return function(n, i) {
          if (n = Ge(n), i = i == null ? 0 : xe(z(i), 292), i && Gs(n)) {
            var u = (te(n) + "e").split("e"), l = t(u[0] + "e" + (+u[1] + i));
            return u = (te(l) + "e").split("e"), +(u[0] + "e" + (+u[1] - i));
          }
          return t(n);
        };
      }
      var Dh = an && 1 / fr(new an([, -0]))[1] == Bt ? function(e) {
        return new an(e);
      } : Oo;
      function Ru(e) {
        return function(t) {
          var n = be(t);
          return n == Ve ? Ni(t) : n == Ke ? Qf(t) : qf(t, e(t));
        };
      }
      function at(e, t, n, i, u, l, f, h) {
        var g = t & G;
        if (!g && typeof e != "function")
          throw new Fe(m);
        var x = i ? i.length : 0;
        if (x || (t &= ~(se | ce), i = u = o), f = f === o ? f : _e(z(f), 0), h = h === o ? h : z(h), x -= u ? u.length : 0, t & ce) {
          var b = i, T = u;
          i = u = o;
        }
        var A = g ? o : fo(e), P = [
          e,
          t,
          n,
          i,
          u,
          b,
          T,
          l,
          f,
          h
        ];
        if (A && Zh(P, A), e = P[0], t = P[1], n = P[2], i = P[3], u = P[4], h = P[9] = P[9] === o ? g ? 0 : e.length : _e(P[9] - x, 0), !h && t & (W | ee) && (t &= ~(W | ee)), !t || t == N)
          var R = Ih(e, t, n);
        else
          t == W || t == ee ? R = Rh(e, t, h) : (t == se || t == (N | se)) && !u.length ? R = Mh(e, t, n, i) : R = Ir.apply(o, P);
        var k = A ? du : qu;
        return Gu(k(R, P), e, t);
      }
      function Mu(e, t, n, i) {
        return e === o || Ze(e, un[n]) && !ne.call(i, n) ? t : e;
      }
      function Du(e, t, n, i, u, l) {
        return le(e) && le(t) && (l.set(t, e), Pr(e, t, o, Du, l), l.delete(t)), e;
      }
      function Wh(e) {
        return qn(e) ? o : e;
      }
      function Wu(e, t, n, i, u, l) {
        var f = n & U, h = e.length, g = t.length;
        if (h != g && !(f && g > h))
          return !1;
        var x = l.get(e), b = l.get(t);
        if (x && b)
          return x == t && b == e;
        var T = -1, A = !0, P = n & Q ? new Ut() : o;
        for (l.set(e, t), l.set(t, e); ++T < h; ) {
          var R = e[T], k = t[T];
          if (i)
            var M = f ? i(k, R, T, t, e, l) : i(R, k, T, e, t, l);
          if (M !== o) {
            if (M)
              continue;
            A = !1;
            break;
          }
          if (P) {
            if (!Li(t, function(V, X) {
              if (!On(P, X) && (R === V || u(R, V, n, i, l)))
                return P.push(X);
            })) {
              A = !1;
              break;
            }
          } else if (!(R === k || u(R, k, n, i, l))) {
            A = !1;
            break;
          }
        }
        return l.delete(e), l.delete(t), A;
      }
      function Nh(e, t, n, i, u, l, f) {
        switch (n) {
          case en:
            if (e.byteLength != t.byteLength || e.byteOffset != t.byteOffset)
              return !1;
            e = e.buffer, t = t.buffer;
          case En:
            return !(e.byteLength != t.byteLength || !l(new _r(e), new _r(t)));
          case Tn:
          case $n:
          case An:
            return Ze(+e, +t);
          case nr:
            return e.name == t.name && e.message == t.message;
          case Cn:
          case Sn:
            return e == t + "";
          case Ve:
            var h = Ni;
          case Ke:
            var g = i & U;
            if (h || (h = fr), e.size != t.size && !g)
              return !1;
            var x = f.get(e);
            if (x)
              return x == t;
            i |= Q, f.set(e, t);
            var b = Wu(h(e), h(t), i, u, l, f);
            return f.delete(e), b;
          case ir:
            if (Dn)
              return Dn.call(e) == Dn.call(t);
        }
        return !1;
      }
      function Bh(e, t, n, i, u, l) {
        var f = n & U, h = ao(e), g = h.length, x = ao(t), b = x.length;
        if (g != b && !f)
          return !1;
        for (var T = g; T--; ) {
          var A = h[T];
          if (!(f ? A in t : ne.call(t, A)))
            return !1;
        }
        var P = l.get(e), R = l.get(t);
        if (P && R)
          return P == t && R == e;
        var k = !0;
        l.set(e, t), l.set(t, e);
        for (var M = f; ++T < g; ) {
          A = h[T];
          var V = e[A], X = t[A];
          if (i)
            var De = f ? i(X, V, A, t, e, l) : i(V, X, A, e, t, l);
          if (!(De === o ? V === X || u(V, X, n, i, l) : De)) {
            k = !1;
            break;
          }
          M || (M = A == "constructor");
        }
        if (k && !M) {
          var Ae = e.constructor, We = t.constructor;
          Ae != We && "constructor" in e && "constructor" in t && !(typeof Ae == "function" && Ae instanceof Ae && typeof We == "function" && We instanceof We) && (k = !1);
        }
        return l.delete(e), l.delete(t), k;
      }
      function lt(e) {
        return vo(Uu(e, o, Ju), e + "");
      }
      function ao(e) {
        return nu(e, ve, ho);
      }
      function lo(e) {
        return nu(e, Ee, Nu);
      }
      var fo = br ? function(e) {
        return br.get(e);
      } : Oo;
      function Wr(e) {
        for (var t = e.name + "", n = ln[t], i = ne.call(ln, t) ? n.length : 0; i--; ) {
          var u = n[i], l = u.func;
          if (l == null || l == e)
            return u.name;
        }
        return t;
      }
      function dn(e) {
        var t = ne.call(a, "placeholder") ? a : e;
        return t.placeholder;
      }
      function I() {
        var e = a.iteratee || Po;
        return e = e === Po ? ou : e, arguments.length ? e(arguments[0], arguments[1]) : e;
      }
      function Nr(e, t) {
        var n = e.__data__;
        return Vh(t) ? n[typeof t == "string" ? "string" : "hash"] : n.map;
      }
      function co(e) {
        for (var t = ve(e), n = t.length; n--; ) {
          var i = t[n], u = e[i];
          t[n] = [i, u, Fu(u)];
        }
        return t;
      }
      function Gt(e, t) {
        var n = Xf(e, t);
        return iu(n) ? n : o;
      }
      function Hh(e) {
        var t = ne.call(e, Ft), n = e[Ft];
        try {
          e[Ft] = o;
          var i = !0;
        } catch {
        }
        var u = pr.call(e);
        return i && (t ? e[Ft] = n : delete e[Ft]), u;
      }
      var ho = Hi ? function(e) {
        return e == null ? [] : (e = re(e), xt(Hi(e), function(t) {
          return ks.call(e, t);
        }));
      } : Lo, Nu = Hi ? function(e) {
        for (var t = []; e; )
          bt(t, ho(e)), e = vr(e);
        return t;
      } : Lo, be = Te;
      (Fi && be(new Fi(new ArrayBuffer(1))) != en || In && be(new In()) != Ve || zi && be(zi.resolve()) != jo || an && be(new an()) != Ke || Rn && be(new Rn()) != Pn) && (be = function(e) {
        var t = Te(e), n = t == it ? e.constructor : o, i = n ? Vt(n) : "";
        if (i)
          switch (i) {
            case xc:
              return en;
            case bc:
              return Ve;
            case Tc:
              return jo;
            case $c:
              return Ke;
            case Ac:
              return Pn;
          }
        return t;
      });
      function Fh(e, t, n) {
        for (var i = -1, u = n.length; ++i < u; ) {
          var l = n[i], f = l.size;
          switch (l.type) {
            case "drop":
              e += f;
              break;
            case "dropRight":
              t -= f;
              break;
            case "take":
              t = xe(t, e + f);
              break;
            case "takeRight":
              e = _e(e, t - f);
              break;
          }
        }
        return { start: e, end: t };
      }
      function zh(e) {
        var t = e.match(Vl);
        return t ? t[1].split(Kl) : [];
      }
      function Bu(e, t, n) {
        t = St(t, e);
        for (var i = -1, u = t.length, l = !1; ++i < u; ) {
          var f = rt(t[i]);
          if (!(l = e != null && n(e, f)))
            break;
          e = e[f];
        }
        return l || ++i != u ? l : (u = e == null ? 0 : e.length, !!u && qr(u) && ft(f, u) && (H(e) || Kt(e)));
      }
      function Uh(e) {
        var t = e.length, n = new e.constructor(t);
        return t && typeof e[0] == "string" && ne.call(e, "index") && (n.index = e.index, n.input = e.input), n;
      }
      function Hu(e) {
        return typeof e.constructor == "function" && !Un(e) ? fn(vr(e)) : {};
      }
      function kh(e, t, n) {
        var i = e.constructor;
        switch (t) {
          case En:
            return oo(e);
          case Tn:
          case $n:
            return new i(+e);
          case en:
            return Ch(e, n);
          case ci:
          case hi:
          case di:
          case pi:
          case gi:
          case _i:
          case vi:
          case mi:
          case wi:
            return xu(e, n);
          case Ve:
            return new i();
          case An:
          case Sn:
            return new i(e);
          case Cn:
            return Sh(e);
          case Ke:
            return new i();
          case ir:
            return Ph(e);
        }
      }
      function qh(e, t) {
        var n = t.length;
        if (!n)
          return e;
        var i = n - 1;
        return t[i] = (n > 1 ? "& " : "") + t[i], t = t.join(n > 2 ? ", " : " "), e.replace(Gl, `{
/* [wrapped with ` + t + `] */
`);
      }
      function Gh(e) {
        return H(e) || Kt(e) || !!(qs && e && e[qs]);
      }
      function ft(e, t) {
        var n = typeof e;
        return t = t == null ? yt : t, !!t && (n == "number" || n != "symbol" && nf.test(e)) && e > -1 && e % 1 == 0 && e < t;
      }
      function $e(e, t, n) {
        if (!le(n))
          return !1;
        var i = typeof t;
        return (i == "number" ? Pe(n) && ft(t, n.length) : i == "string" && t in n) ? Ze(n[t], e) : !1;
      }
      function po(e, t) {
        if (H(e))
          return !1;
        var n = typeof e;
        return n == "number" || n == "symbol" || n == "boolean" || e == null || Me(e) ? !0 : zl.test(e) || !Fl.test(e) || t != null && e in re(t);
      }
      function Vh(e) {
        var t = typeof e;
        return t == "string" || t == "number" || t == "symbol" || t == "boolean" ? e !== "__proto__" : e === null;
      }
      function go(e) {
        var t = Wr(e), n = a[t];
        if (typeof n != "function" || !(t in Y.prototype))
          return !1;
        if (e === n)
          return !0;
        var i = fo(n);
        return !!i && e === i[0];
      }
      function Kh(e) {
        return !!Fs && Fs in e;
      }
      var Yh = hr ? ct : Io;
      function Un(e) {
        var t = e && e.constructor, n = typeof t == "function" && t.prototype || un;
        return e === n;
      }
      function Fu(e) {
        return e === e && !le(e);
      }
      function zu(e, t) {
        return function(n) {
          return n == null ? !1 : n[e] === t && (t !== o || e in re(n));
        };
      }
      function Xh(e) {
        var t = Ur(e, function(i) {
          return n.size === L && n.clear(), i;
        }), n = t.cache;
        return t;
      }
      function Zh(e, t) {
        var n = e[1], i = t[1], u = n | i, l = u < (N | G | pe), f = i == pe && n == W || i == pe && n == ue && e[7].length <= t[8] || i == (pe | ue) && t[7].length <= t[8] && n == W;
        if (!(l || f))
          return e;
        i & N && (e[2] = t[2], u |= n & N ? 0 : F);
        var h = t[3];
        if (h) {
          var g = e[3];
          e[3] = g ? Tu(g, h, t[4]) : h, e[4] = g ? Tt(e[3], C) : t[4];
        }
        return h = t[5], h && (g = e[5], e[5] = g ? $u(g, h, t[6]) : h, e[6] = g ? Tt(e[5], C) : t[6]), h = t[7], h && (e[7] = h), i & pe && (e[8] = e[8] == null ? t[8] : xe(e[8], t[8])), e[9] == null && (e[9] = t[9]), e[0] = t[0], e[1] = u, e;
      }
      function Jh(e) {
        var t = [];
        if (e != null)
          for (var n in re(e))
            t.push(n);
        return t;
      }
      function Qh(e) {
        return pr.call(e);
      }
      function Uu(e, t, n) {
        return t = _e(t === o ? e.length - 1 : t, 0), function() {
          for (var i = arguments, u = -1, l = _e(i.length - t, 0), f = v(l); ++u < l; )
            f[u] = i[t + u];
          u = -1;
          for (var h = v(t + 1); ++u < t; )
            h[u] = i[u];
          return h[t] = n(f), Le(e, this, h);
        };
      }
      function ku(e, t) {
        return t.length < 2 ? e : qt(e, ke(t, 0, -1));
      }
      function jh(e, t) {
        for (var n = e.length, i = xe(t.length, n), u = Se(e); i--; ) {
          var l = t[i];
          e[i] = ft(l, n) ? u[l] : o;
        }
        return e;
      }
      function _o(e, t) {
        if (!(t === "constructor" && typeof e[t] == "function") && t != "__proto__")
          return e[t];
      }
      var qu = Vu(du), kn = pc || function(e, t) {
        return we.setTimeout(e, t);
      }, vo = Vu(bh);
      function Gu(e, t, n) {
        var i = t + "";
        return vo(e, qh(i, ed(zh(i), n)));
      }
      function Vu(e) {
        var t = 0, n = 0;
        return function() {
          var i = mc(), u = Nt - (i - n);
          if (n = i, u > 0) {
            if (++t >= Wt)
              return arguments[0];
          } else
            t = 0;
          return e.apply(o, arguments);
        };
      }
      function Br(e, t) {
        var n = -1, i = e.length, u = i - 1;
        for (t = t === o ? i : t; ++n < t; ) {
          var l = Qi(n, u), f = e[l];
          e[l] = e[n], e[n] = f;
        }
        return e.length = t, e;
      }
      var Ku = Xh(function(e) {
        var t = [];
        return e.charCodeAt(0) === 46 && t.push(""), e.replace(Ul, function(n, i, u, l) {
          t.push(u ? l.replace(Zl, "$1") : i || n);
        }), t;
      });
      function rt(e) {
        if (typeof e == "string" || Me(e))
          return e;
        var t = e + "";
        return t == "0" && 1 / e == -Bt ? "-0" : t;
      }
      function Vt(e) {
        if (e != null) {
          try {
            return dr.call(e);
          } catch {
          }
          try {
            return e + "";
          } catch {
          }
        }
        return "";
      }
      function ed(e, t) {
        return He(Cl, function(n) {
          var i = "_." + n[0];
          t & n[1] && !ar(e, i) && e.push(i);
        }), e.sort();
      }
      function Yu(e) {
        if (e instanceof Y)
          return e.clone();
        var t = new ze(e.__wrapped__, e.__chain__);
        return t.__actions__ = Se(e.__actions__), t.__index__ = e.__index__, t.__values__ = e.__values__, t;
      }
      function td(e, t, n) {
        (n ? $e(e, t, n) : t === o) ? t = 1 : t = _e(z(t), 0);
        var i = e == null ? 0 : e.length;
        if (!i || t < 1)
          return [];
        for (var u = 0, l = 0, f = v(yr(i / t)); u < i; )
          f[l++] = ke(e, u, u += t);
        return f;
      }
      function nd(e) {
        for (var t = -1, n = e == null ? 0 : e.length, i = 0, u = []; ++t < n; ) {
          var l = e[t];
          l && (u[i++] = l);
        }
        return u;
      }
      function rd() {
        var e = arguments.length;
        if (!e)
          return [];
        for (var t = v(e - 1), n = arguments[0], i = e; i--; )
          t[i - 1] = arguments[i];
        return bt(H(n) ? Se(n) : [n], ye(t, 1));
      }
      var id = q(function(e, t) {
        return he(e) ? Nn(e, ye(t, 1, he, !0)) : [];
      }), od = q(function(e, t) {
        var n = qe(t);
        return he(n) && (n = o), he(e) ? Nn(e, ye(t, 1, he, !0), I(n, 2)) : [];
      }), sd = q(function(e, t) {
        var n = qe(t);
        return he(n) && (n = o), he(e) ? Nn(e, ye(t, 1, he, !0), o, n) : [];
      });
      function ud(e, t, n) {
        var i = e == null ? 0 : e.length;
        return i ? (t = n || t === o ? 1 : z(t), ke(e, t < 0 ? 0 : t, i)) : [];
      }
      function ad(e, t, n) {
        var i = e == null ? 0 : e.length;
        return i ? (t = n || t === o ? 1 : z(t), t = i - t, ke(e, 0, t < 0 ? 0 : t)) : [];
      }
      function ld(e, t) {
        return e && e.length ? Or(e, I(t, 3), !0, !0) : [];
      }
      function fd(e, t) {
        return e && e.length ? Or(e, I(t, 3), !0) : [];
      }
      function cd(e, t, n, i) {
        var u = e == null ? 0 : e.length;
        return u ? (n && typeof n != "number" && $e(e, t, n) && (n = 0, i = u), rh(e, t, n, i)) : [];
      }
      function Xu(e, t, n) {
        var i = e == null ? 0 : e.length;
        if (!i)
          return -1;
        var u = n == null ? 0 : z(n);
        return u < 0 && (u = _e(i + u, 0)), lr(e, I(t, 3), u);
      }
      function Zu(e, t, n) {
        var i = e == null ? 0 : e.length;
        if (!i)
          return -1;
        var u = i - 1;
        return n !== o && (u = z(n), u = n < 0 ? _e(i + u, 0) : xe(u, i - 1)), lr(e, I(t, 3), u, !0);
      }
      function Ju(e) {
        var t = e == null ? 0 : e.length;
        return t ? ye(e, 1) : [];
      }
      function hd(e) {
        var t = e == null ? 0 : e.length;
        return t ? ye(e, Bt) : [];
      }
      function dd(e, t) {
        var n = e == null ? 0 : e.length;
        return n ? (t = t === o ? 1 : z(t), ye(e, t)) : [];
      }
      function pd(e) {
        for (var t = -1, n = e == null ? 0 : e.length, i = {}; ++t < n; ) {
          var u = e[t];
          i[u[0]] = u[1];
        }
        return i;
      }
      function Qu(e) {
        return e && e.length ? e[0] : o;
      }
      function gd(e, t, n) {
        var i = e == null ? 0 : e.length;
        if (!i)
          return -1;
        var u = n == null ? 0 : z(n);
        return u < 0 && (u = _e(i + u, 0)), nn(e, t, u);
      }
      function _d(e) {
        var t = e == null ? 0 : e.length;
        return t ? ke(e, 0, -1) : [];
      }
      var vd = q(function(e) {
        var t = ae(e, ro);
        return t.length && t[0] === e[0] ? Ki(t) : [];
      }), md = q(function(e) {
        var t = qe(e), n = ae(e, ro);
        return t === qe(n) ? t = o : n.pop(), n.length && n[0] === e[0] ? Ki(n, I(t, 2)) : [];
      }), wd = q(function(e) {
        var t = qe(e), n = ae(e, ro);
        return t = typeof t == "function" ? t : o, t && n.pop(), n.length && n[0] === e[0] ? Ki(n, o, t) : [];
      });
      function yd(e, t) {
        return e == null ? "" : _c.call(e, t);
      }
      function qe(e) {
        var t = e == null ? 0 : e.length;
        return t ? e[t - 1] : o;
      }
      function xd(e, t, n) {
        var i = e == null ? 0 : e.length;
        if (!i)
          return -1;
        var u = i;
        return n !== o && (u = z(n), u = u < 0 ? _e(i + u, 0) : xe(u, i - 1)), t === t ? ec(e, t, u) : lr(e, Is, u, !0);
      }
      function bd(e, t) {
        return e && e.length ? lu(e, z(t)) : o;
      }
      var Td = q(ju);
      function ju(e, t) {
        return e && e.length && t && t.length ? Ji(e, t) : e;
      }
      function $d(e, t, n) {
        return e && e.length && t && t.length ? Ji(e, t, I(n, 2)) : e;
      }
      function Ad(e, t, n) {
        return e && e.length && t && t.length ? Ji(e, t, o, n) : e;
      }
      var Cd = lt(function(e, t) {
        var n = e == null ? 0 : e.length, i = ki(e, t);
        return hu(e, ae(t, function(u) {
          return ft(u, n) ? +u : u;
        }).sort(bu)), i;
      });
      function Sd(e, t) {
        var n = [];
        if (!(e && e.length))
          return n;
        var i = -1, u = [], l = e.length;
        for (t = I(t, 3); ++i < l; ) {
          var f = e[i];
          t(f, i, e) && (n.push(f), u.push(i));
        }
        return hu(e, u), n;
      }
      function mo(e) {
        return e == null ? e : yc.call(e);
      }
      function Pd(e, t, n) {
        var i = e == null ? 0 : e.length;
        return i ? (n && typeof n != "number" && $e(e, t, n) ? (t = 0, n = i) : (t = t == null ? 0 : z(t), n = n === o ? i : z(n)), ke(e, t, n)) : [];
      }
      function Ed(e, t) {
        return Er(e, t);
      }
      function Od(e, t, n) {
        return eo(e, t, I(n, 2));
      }
      function Ld(e, t) {
        var n = e == null ? 0 : e.length;
        if (n) {
          var i = Er(e, t);
          if (i < n && Ze(e[i], t))
            return i;
        }
        return -1;
      }
      function Id(e, t) {
        return Er(e, t, !0);
      }
      function Rd(e, t, n) {
        return eo(e, t, I(n, 2), !0);
      }
      function Md(e, t) {
        var n = e == null ? 0 : e.length;
        if (n) {
          var i = Er(e, t, !0) - 1;
          if (Ze(e[i], t))
            return i;
        }
        return -1;
      }
      function Dd(e) {
        return e && e.length ? pu(e) : [];
      }
      function Wd(e, t) {
        return e && e.length ? pu(e, I(t, 2)) : [];
      }
      function Nd(e) {
        var t = e == null ? 0 : e.length;
        return t ? ke(e, 1, t) : [];
      }
      function Bd(e, t, n) {
        return e && e.length ? (t = n || t === o ? 1 : z(t), ke(e, 0, t < 0 ? 0 : t)) : [];
      }
      function Hd(e, t, n) {
        var i = e == null ? 0 : e.length;
        return i ? (t = n || t === o ? 1 : z(t), t = i - t, ke(e, t < 0 ? 0 : t, i)) : [];
      }
      function Fd(e, t) {
        return e && e.length ? Or(e, I(t, 3), !1, !0) : [];
      }
      function zd(e, t) {
        return e && e.length ? Or(e, I(t, 3)) : [];
      }
      var Ud = q(function(e) {
        return Ct(ye(e, 1, he, !0));
      }), kd = q(function(e) {
        var t = qe(e);
        return he(t) && (t = o), Ct(ye(e, 1, he, !0), I(t, 2));
      }), qd = q(function(e) {
        var t = qe(e);
        return t = typeof t == "function" ? t : o, Ct(ye(e, 1, he, !0), o, t);
      });
      function Gd(e) {
        return e && e.length ? Ct(e) : [];
      }
      function Vd(e, t) {
        return e && e.length ? Ct(e, I(t, 2)) : [];
      }
      function Kd(e, t) {
        return t = typeof t == "function" ? t : o, e && e.length ? Ct(e, o, t) : [];
      }
      function wo(e) {
        if (!(e && e.length))
          return [];
        var t = 0;
        return e = xt(e, function(n) {
          if (he(n))
            return t = _e(n.length, t), !0;
        }), Di(t, function(n) {
          return ae(e, Ii(n));
        });
      }
      function ea(e, t) {
        if (!(e && e.length))
          return [];
        var n = wo(e);
        return t == null ? n : ae(n, function(i) {
          return Le(t, o, i);
        });
      }
      var Yd = q(function(e, t) {
        return he(e) ? Nn(e, t) : [];
      }), Xd = q(function(e) {
        return no(xt(e, he));
      }), Zd = q(function(e) {
        var t = qe(e);
        return he(t) && (t = o), no(xt(e, he), I(t, 2));
      }), Jd = q(function(e) {
        var t = qe(e);
        return t = typeof t == "function" ? t : o, no(xt(e, he), o, t);
      }), Qd = q(wo);
      function jd(e, t) {
        return mu(e || [], t || [], Wn);
      }
      function ep(e, t) {
        return mu(e || [], t || [], Fn);
      }
      var tp = q(function(e) {
        var t = e.length, n = t > 1 ? e[t - 1] : o;
        return n = typeof n == "function" ? (e.pop(), n) : o, ea(e, n);
      });
      function ta(e) {
        var t = a(e);
        return t.__chain__ = !0, t;
      }
      function np(e, t) {
        return t(e), e;
      }
      function Hr(e, t) {
        return t(e);
      }
      var rp = lt(function(e) {
        var t = e.length, n = t ? e[0] : 0, i = this.__wrapped__, u = function(l) {
          return ki(l, e);
        };
        return t > 1 || this.__actions__.length || !(i instanceof Y) || !ft(n) ? this.thru(u) : (i = i.slice(n, +n + (t ? 1 : 0)), i.__actions__.push({
          func: Hr,
          args: [u],
          thisArg: o
        }), new ze(i, this.__chain__).thru(function(l) {
          return t && !l.length && l.push(o), l;
        }));
      });
      function ip() {
        return ta(this);
      }
      function op() {
        return new ze(this.value(), this.__chain__);
      }
      function sp() {
        this.__values__ === o && (this.__values__ = ga(this.value()));
        var e = this.__index__ >= this.__values__.length, t = e ? o : this.__values__[this.__index__++];
        return { done: e, value: t };
      }
      function up() {
        return this;
      }
      function ap(e) {
        for (var t, n = this; n instanceof $r; ) {
          var i = Yu(n);
          i.__index__ = 0, i.__values__ = o, t ? u.__wrapped__ = i : t = i;
          var u = i;
          n = n.__wrapped__;
        }
        return u.__wrapped__ = e, t;
      }
      function lp() {
        var e = this.__wrapped__;
        if (e instanceof Y) {
          var t = e;
          return this.__actions__.length && (t = new Y(this)), t = t.reverse(), t.__actions__.push({
            func: Hr,
            args: [mo],
            thisArg: o
          }), new ze(t, this.__chain__);
        }
        return this.thru(mo);
      }
      function fp() {
        return vu(this.__wrapped__, this.__actions__);
      }
      var cp = Lr(function(e, t, n) {
        ne.call(e, n) ? ++e[n] : ut(e, n, 1);
      });
      function hp(e, t, n) {
        var i = H(e) ? Os : nh;
        return n && $e(e, t, n) && (t = o), i(e, I(t, 3));
      }
      function dp(e, t) {
        var n = H(e) ? xt : eu;
        return n(e, I(t, 3));
      }
      var pp = Pu(Xu), gp = Pu(Zu);
      function _p(e, t) {
        return ye(Fr(e, t), 1);
      }
      function vp(e, t) {
        return ye(Fr(e, t), Bt);
      }
      function mp(e, t, n) {
        return n = n === o ? 1 : z(n), ye(Fr(e, t), n);
      }
      function na(e, t) {
        var n = H(e) ? He : At;
        return n(e, I(t, 3));
      }
      function ra(e, t) {
        var n = H(e) ? Nf : js;
        return n(e, I(t, 3));
      }
      var wp = Lr(function(e, t, n) {
        ne.call(e, n) ? e[n].push(t) : ut(e, n, [t]);
      });
      function yp(e, t, n, i) {
        e = Pe(e) ? e : gn(e), n = n && !i ? z(n) : 0;
        var u = e.length;
        return n < 0 && (n = _e(u + n, 0)), Gr(e) ? n <= u && e.indexOf(t, n) > -1 : !!u && nn(e, t, n) > -1;
      }
      var xp = q(function(e, t, n) {
        var i = -1, u = typeof t == "function", l = Pe(e) ? v(e.length) : [];
        return At(e, function(f) {
          l[++i] = u ? Le(t, f, n) : Bn(f, t, n);
        }), l;
      }), bp = Lr(function(e, t, n) {
        ut(e, n, t);
      });
      function Fr(e, t) {
        var n = H(e) ? ae : su;
        return n(e, I(t, 3));
      }
      function Tp(e, t, n, i) {
        return e == null ? [] : (H(t) || (t = t == null ? [] : [t]), n = i ? o : n, H(n) || (n = n == null ? [] : [n]), fu(e, t, n));
      }
      var $p = Lr(function(e, t, n) {
        e[n ? 0 : 1].push(t);
      }, function() {
        return [[], []];
      });
      function Ap(e, t, n) {
        var i = H(e) ? Oi : Ms, u = arguments.length < 3;
        return i(e, I(t, 4), n, u, At);
      }
      function Cp(e, t, n) {
        var i = H(e) ? Bf : Ms, u = arguments.length < 3;
        return i(e, I(t, 4), n, u, js);
      }
      function Sp(e, t) {
        var n = H(e) ? xt : eu;
        return n(e, kr(I(t, 3)));
      }
      function Pp(e) {
        var t = H(e) ? Xs : yh;
        return t(e);
      }
      function Ep(e, t, n) {
        (n ? $e(e, t, n) : t === o) ? t = 1 : t = z(t);
        var i = H(e) ? Jc : xh;
        return i(e, t);
      }
      function Op(e) {
        var t = H(e) ? Qc : Th;
        return t(e);
      }
      function Lp(e) {
        if (e == null)
          return 0;
        if (Pe(e))
          return Gr(e) ? on(e) : e.length;
        var t = be(e);
        return t == Ve || t == Ke ? e.size : Xi(e).length;
      }
      function Ip(e, t, n) {
        var i = H(e) ? Li : $h;
        return n && $e(e, t, n) && (t = o), i(e, I(t, 3));
      }
      var Rp = q(function(e, t) {
        if (e == null)
          return [];
        var n = t.length;
        return n > 1 && $e(e, t[0], t[1]) ? t = [] : n > 2 && $e(t[0], t[1], t[2]) && (t = [t[0]]), fu(e, ye(t, 1), []);
      }), zr = dc || function() {
        return we.Date.now();
      };
      function Mp(e, t) {
        if (typeof t != "function")
          throw new Fe(m);
        return e = z(e), function() {
          if (--e < 1)
            return t.apply(this, arguments);
        };
      }
      function ia(e, t, n) {
        return t = n ? o : t, t = e && t == null ? e.length : t, at(e, pe, o, o, o, o, t);
      }
      function oa(e, t) {
        var n;
        if (typeof t != "function")
          throw new Fe(m);
        return e = z(e), function() {
          return --e > 0 && (n = t.apply(this, arguments)), e <= 1 && (t = o), n;
        };
      }
      var yo = q(function(e, t, n) {
        var i = N;
        if (n.length) {
          var u = Tt(n, dn(yo));
          i |= se;
        }
        return at(e, i, t, n, u);
      }), sa = q(function(e, t, n) {
        var i = N | G;
        if (n.length) {
          var u = Tt(n, dn(sa));
          i |= se;
        }
        return at(t, i, e, n, u);
      });
      function ua(e, t, n) {
        t = n ? o : t;
        var i = at(e, W, o, o, o, o, o, t);
        return i.placeholder = ua.placeholder, i;
      }
      function aa(e, t, n) {
        t = n ? o : t;
        var i = at(e, ee, o, o, o, o, o, t);
        return i.placeholder = aa.placeholder, i;
      }
      function la(e, t, n) {
        var i, u, l, f, h, g, x = 0, b = !1, T = !1, A = !0;
        if (typeof e != "function")
          throw new Fe(m);
        t = Ge(t) || 0, le(n) && (b = !!n.leading, T = "maxWait" in n, l = T ? _e(Ge(n.maxWait) || 0, t) : l, A = "trailing" in n ? !!n.trailing : A);
        function P(de) {
          var Je = i, dt = u;
          return i = u = o, x = de, f = e.apply(dt, Je), f;
        }
        function R(de) {
          return x = de, h = kn(V, t), b ? P(de) : f;
        }
        function k(de) {
          var Je = de - g, dt = de - x, Pa = t - Je;
          return T ? xe(Pa, l - dt) : Pa;
        }
        function M(de) {
          var Je = de - g, dt = de - x;
          return g === o || Je >= t || Je < 0 || T && dt >= l;
        }
        function V() {
          var de = zr();
          if (M(de))
            return X(de);
          h = kn(V, k(de));
        }
        function X(de) {
          return h = o, A && i ? P(de) : (i = u = o, f);
        }
        function De() {
          h !== o && wu(h), x = 0, i = g = u = h = o;
        }
        function Ae() {
          return h === o ? f : X(zr());
        }
        function We() {
          var de = zr(), Je = M(de);
          if (i = arguments, u = this, g = de, Je) {
            if (h === o)
              return R(g);
            if (T)
              return wu(h), h = kn(V, t), P(g);
          }
          return h === o && (h = kn(V, t)), f;
        }
        return We.cancel = De, We.flush = Ae, We;
      }
      var Dp = q(function(e, t) {
        return Qs(e, 1, t);
      }), Wp = q(function(e, t, n) {
        return Qs(e, Ge(t) || 0, n);
      });
      function Np(e) {
        return at(e, me);
      }
      function Ur(e, t) {
        if (typeof e != "function" || t != null && typeof t != "function")
          throw new Fe(m);
        var n = function() {
          var i = arguments, u = t ? t.apply(this, i) : i[0], l = n.cache;
          if (l.has(u))
            return l.get(u);
          var f = e.apply(this, i);
          return n.cache = l.set(u, f) || l, f;
        };
        return n.cache = new (Ur.Cache || st)(), n;
      }
      Ur.Cache = st;
      function kr(e) {
        if (typeof e != "function")
          throw new Fe(m);
        return function() {
          var t = arguments;
          switch (t.length) {
            case 0:
              return !e.call(this);
            case 1:
              return !e.call(this, t[0]);
            case 2:
              return !e.call(this, t[0], t[1]);
            case 3:
              return !e.call(this, t[0], t[1], t[2]);
          }
          return !e.apply(this, t);
        };
      }
      function Bp(e) {
        return oa(2, e);
      }
      var Hp = Ah(function(e, t) {
        t = t.length == 1 && H(t[0]) ? ae(t[0], Ie(I())) : ae(ye(t, 1), Ie(I()));
        var n = t.length;
        return q(function(i) {
          for (var u = -1, l = xe(i.length, n); ++u < l; )
            i[u] = t[u].call(this, i[u]);
          return Le(e, this, i);
        });
      }), xo = q(function(e, t) {
        var n = Tt(t, dn(xo));
        return at(e, se, o, t, n);
      }), fa = q(function(e, t) {
        var n = Tt(t, dn(fa));
        return at(e, ce, o, t, n);
      }), Fp = lt(function(e, t) {
        return at(e, ue, o, o, o, t);
      });
      function zp(e, t) {
        if (typeof e != "function")
          throw new Fe(m);
        return t = t === o ? t : z(t), q(e, t);
      }
      function Up(e, t) {
        if (typeof e != "function")
          throw new Fe(m);
        return t = t == null ? 0 : _e(z(t), 0), q(function(n) {
          var i = n[t], u = Pt(n, 0, t);
          return i && bt(u, i), Le(e, this, u);
        });
      }
      function kp(e, t, n) {
        var i = !0, u = !0;
        if (typeof e != "function")
          throw new Fe(m);
        return le(n) && (i = "leading" in n ? !!n.leading : i, u = "trailing" in n ? !!n.trailing : u), la(e, t, {
          leading: i,
          maxWait: t,
          trailing: u
        });
      }
      function qp(e) {
        return ia(e, 1);
      }
      function Gp(e, t) {
        return xo(io(t), e);
      }
      function Vp() {
        if (!arguments.length)
          return [];
        var e = arguments[0];
        return H(e) ? e : [e];
      }
      function Kp(e) {
        return Ue(e, D);
      }
      function Yp(e, t) {
        return t = typeof t == "function" ? t : o, Ue(e, D, t);
      }
      function Xp(e) {
        return Ue(e, E | D);
      }
      function Zp(e, t) {
        return t = typeof t == "function" ? t : o, Ue(e, E | D, t);
      }
      function Jp(e, t) {
        return t == null || Js(e, t, ve(t));
      }
      function Ze(e, t) {
        return e === t || e !== e && t !== t;
      }
      var Qp = Dr(Vi), jp = Dr(function(e, t) {
        return e >= t;
      }), Kt = ru(function() {
        return arguments;
      }()) ? ru : function(e) {
        return fe(e) && ne.call(e, "callee") && !ks.call(e, "callee");
      }, H = v.isArray, eg = $s ? Ie($s) : ah;
      function Pe(e) {
        return e != null && qr(e.length) && !ct(e);
      }
      function he(e) {
        return fe(e) && Pe(e);
      }
      function tg(e) {
        return e === !0 || e === !1 || fe(e) && Te(e) == Tn;
      }
      var Et = gc || Io, ng = As ? Ie(As) : lh;
      function rg(e) {
        return fe(e) && e.nodeType === 1 && !qn(e);
      }
      function ig(e) {
        if (e == null)
          return !0;
        if (Pe(e) && (H(e) || typeof e == "string" || typeof e.splice == "function" || Et(e) || pn(e) || Kt(e)))
          return !e.length;
        var t = be(e);
        if (t == Ve || t == Ke)
          return !e.size;
        if (Un(e))
          return !Xi(e).length;
        for (var n in e)
          if (ne.call(e, n))
            return !1;
        return !0;
      }
      function og(e, t) {
        return Hn(e, t);
      }
      function sg(e, t, n) {
        n = typeof n == "function" ? n : o;
        var i = n ? n(e, t) : o;
        return i === o ? Hn(e, t, o, n) : !!i;
      }
      function bo(e) {
        if (!fe(e))
          return !1;
        var t = Te(e);
        return t == nr || t == Pl || typeof e.message == "string" && typeof e.name == "string" && !qn(e);
      }
      function ug(e) {
        return typeof e == "number" && Gs(e);
      }
      function ct(e) {
        if (!le(e))
          return !1;
        var t = Te(e);
        return t == rr || t == Qo || t == Sl || t == Ol;
      }
      function ca(e) {
        return typeof e == "number" && e == z(e);
      }
      function qr(e) {
        return typeof e == "number" && e > -1 && e % 1 == 0 && e <= yt;
      }
      function le(e) {
        var t = typeof e;
        return e != null && (t == "object" || t == "function");
      }
      function fe(e) {
        return e != null && typeof e == "object";
      }
      var ha = Cs ? Ie(Cs) : ch;
      function ag(e, t) {
        return e === t || Yi(e, t, co(t));
      }
      function lg(e, t, n) {
        return n = typeof n == "function" ? n : o, Yi(e, t, co(t), n);
      }
      function fg(e) {
        return da(e) && e != +e;
      }
      function cg(e) {
        if (Yh(e))
          throw new B(_);
        return iu(e);
      }
      function hg(e) {
        return e === null;
      }
      function dg(e) {
        return e == null;
      }
      function da(e) {
        return typeof e == "number" || fe(e) && Te(e) == An;
      }
      function qn(e) {
        if (!fe(e) || Te(e) != it)
          return !1;
        var t = vr(e);
        if (t === null)
          return !0;
        var n = ne.call(t, "constructor") && t.constructor;
        return typeof n == "function" && n instanceof n && dr.call(n) == lc;
      }
      var To = Ss ? Ie(Ss) : hh;
      function pg(e) {
        return ca(e) && e >= -yt && e <= yt;
      }
      var pa = Ps ? Ie(Ps) : dh;
      function Gr(e) {
        return typeof e == "string" || !H(e) && fe(e) && Te(e) == Sn;
      }
      function Me(e) {
        return typeof e == "symbol" || fe(e) && Te(e) == ir;
      }
      var pn = Es ? Ie(Es) : ph;
      function gg(e) {
        return e === o;
      }
      function _g(e) {
        return fe(e) && be(e) == Pn;
      }
      function vg(e) {
        return fe(e) && Te(e) == Il;
      }
      var mg = Dr(Zi), wg = Dr(function(e, t) {
        return e <= t;
      });
      function ga(e) {
        if (!e)
          return [];
        if (Pe(e))
          return Gr(e) ? Ye(e) : Se(e);
        if (Ln && e[Ln])
          return Jf(e[Ln]());
        var t = be(e), n = t == Ve ? Ni : t == Ke ? fr : gn;
        return n(e);
      }
      function ht(e) {
        if (!e)
          return e === 0 ? e : 0;
        if (e = Ge(e), e === Bt || e === -Bt) {
          var t = e < 0 ? -1 : 1;
          return t * Tl;
        }
        return e === e ? e : 0;
      }
      function z(e) {
        var t = ht(e), n = t % 1;
        return t === t ? n ? t - n : t : 0;
      }
      function _a(e) {
        return e ? kt(z(e), 0, et) : 0;
      }
      function Ge(e) {
        if (typeof e == "number")
          return e;
        if (Me(e))
          return er;
        if (le(e)) {
          var t = typeof e.valueOf == "function" ? e.valueOf() : e;
          e = le(t) ? t + "" : t;
        }
        if (typeof e != "string")
          return e === 0 ? e : +e;
        e = Ds(e);
        var n = jl.test(e);
        return n || tf.test(e) ? Mf(e.slice(2), n ? 2 : 8) : Ql.test(e) ? er : +e;
      }
      function va(e) {
        return nt(e, Ee(e));
      }
      function yg(e) {
        return e ? kt(z(e), -yt, yt) : e === 0 ? e : 0;
      }
      function te(e) {
        return e == null ? "" : Re(e);
      }
      var xg = cn(function(e, t) {
        if (Un(t) || Pe(t)) {
          nt(t, ve(t), e);
          return;
        }
        for (var n in t)
          ne.call(t, n) && Wn(e, n, t[n]);
      }), ma = cn(function(e, t) {
        nt(t, Ee(t), e);
      }), Vr = cn(function(e, t, n, i) {
        nt(t, Ee(t), e, i);
      }), bg = cn(function(e, t, n, i) {
        nt(t, ve(t), e, i);
      }), Tg = lt(ki);
      function $g(e, t) {
        var n = fn(e);
        return t == null ? n : Zs(n, t);
      }
      var Ag = q(function(e, t) {
        e = re(e);
        var n = -1, i = t.length, u = i > 2 ? t[2] : o;
        for (u && $e(t[0], t[1], u) && (i = 1); ++n < i; )
          for (var l = t[n], f = Ee(l), h = -1, g = f.length; ++h < g; ) {
            var x = f[h], b = e[x];
            (b === o || Ze(b, un[x]) && !ne.call(e, x)) && (e[x] = l[x]);
          }
        return e;
      }), Cg = q(function(e) {
        return e.push(o, Du), Le(wa, o, e);
      });
      function Sg(e, t) {
        return Ls(e, I(t, 3), tt);
      }
      function Pg(e, t) {
        return Ls(e, I(t, 3), Gi);
      }
      function Eg(e, t) {
        return e == null ? e : qi(e, I(t, 3), Ee);
      }
      function Og(e, t) {
        return e == null ? e : tu(e, I(t, 3), Ee);
      }
      function Lg(e, t) {
        return e && tt(e, I(t, 3));
      }
      function Ig(e, t) {
        return e && Gi(e, I(t, 3));
      }
      function Rg(e) {
        return e == null ? [] : Sr(e, ve(e));
      }
      function Mg(e) {
        return e == null ? [] : Sr(e, Ee(e));
      }
      function $o(e, t, n) {
        var i = e == null ? o : qt(e, t);
        return i === o ? n : i;
      }
      function Dg(e, t) {
        return e != null && Bu(e, t, ih);
      }
      function Ao(e, t) {
        return e != null && Bu(e, t, oh);
      }
      var Wg = Ou(function(e, t, n) {
        t != null && typeof t.toString != "function" && (t = pr.call(t)), e[t] = n;
      }, So(Oe)), Ng = Ou(function(e, t, n) {
        t != null && typeof t.toString != "function" && (t = pr.call(t)), ne.call(e, t) ? e[t].push(n) : e[t] = [n];
      }, I), Bg = q(Bn);
      function ve(e) {
        return Pe(e) ? Ys(e) : Xi(e);
      }
      function Ee(e) {
        return Pe(e) ? Ys(e, !0) : gh(e);
      }
      function Hg(e, t) {
        var n = {};
        return t = I(t, 3), tt(e, function(i, u, l) {
          ut(n, t(i, u, l), i);
        }), n;
      }
      function Fg(e, t) {
        var n = {};
        return t = I(t, 3), tt(e, function(i, u, l) {
          ut(n, u, t(i, u, l));
        }), n;
      }
      var zg = cn(function(e, t, n) {
        Pr(e, t, n);
      }), wa = cn(function(e, t, n, i) {
        Pr(e, t, n, i);
      }), Ug = lt(function(e, t) {
        var n = {};
        if (e == null)
          return n;
        var i = !1;
        t = ae(t, function(l) {
          return l = St(l, e), i || (i = l.length > 1), l;
        }), nt(e, lo(e), n), i && (n = Ue(n, E | O | D, Wh));
        for (var u = t.length; u--; )
          to(n, t[u]);
        return n;
      });
      function kg(e, t) {
        return ya(e, kr(I(t)));
      }
      var qg = lt(function(e, t) {
        return e == null ? {} : vh(e, t);
      });
      function ya(e, t) {
        if (e == null)
          return {};
        var n = ae(lo(e), function(i) {
          return [i];
        });
        return t = I(t), cu(e, n, function(i, u) {
          return t(i, u[0]);
        });
      }
      function Gg(e, t, n) {
        t = St(t, e);
        var i = -1, u = t.length;
        for (u || (u = 1, e = o); ++i < u; ) {
          var l = e == null ? o : e[rt(t[i])];
          l === o && (i = u, l = n), e = ct(l) ? l.call(e) : l;
        }
        return e;
      }
      function Vg(e, t, n) {
        return e == null ? e : Fn(e, t, n);
      }
      function Kg(e, t, n, i) {
        return i = typeof i == "function" ? i : o, e == null ? e : Fn(e, t, n, i);
      }
      var xa = Ru(ve), ba = Ru(Ee);
      function Yg(e, t, n) {
        var i = H(e), u = i || Et(e) || pn(e);
        if (t = I(t, 4), n == null) {
          var l = e && e.constructor;
          u ? n = i ? new l() : [] : le(e) ? n = ct(l) ? fn(vr(e)) : {} : n = {};
        }
        return (u ? He : tt)(e, function(f, h, g) {
          return t(n, f, h, g);
        }), n;
      }
      function Xg(e, t) {
        return e == null ? !0 : to(e, t);
      }
      function Zg(e, t, n) {
        return e == null ? e : _u(e, t, io(n));
      }
      function Jg(e, t, n, i) {
        return i = typeof i == "function" ? i : o, e == null ? e : _u(e, t, io(n), i);
      }
      function gn(e) {
        return e == null ? [] : Wi(e, ve(e));
      }
      function Qg(e) {
        return e == null ? [] : Wi(e, Ee(e));
      }
      function jg(e, t, n) {
        return n === o && (n = t, t = o), n !== o && (n = Ge(n), n = n === n ? n : 0), t !== o && (t = Ge(t), t = t === t ? t : 0), kt(Ge(e), t, n);
      }
      function e_(e, t, n) {
        return t = ht(t), n === o ? (n = t, t = 0) : n = ht(n), e = Ge(e), sh(e, t, n);
      }
      function t_(e, t, n) {
        if (n && typeof n != "boolean" && $e(e, t, n) && (t = n = o), n === o && (typeof t == "boolean" ? (n = t, t = o) : typeof e == "boolean" && (n = e, e = o)), e === o && t === o ? (e = 0, t = 1) : (e = ht(e), t === o ? (t = e, e = 0) : t = ht(t)), e > t) {
          var i = e;
          e = t, t = i;
        }
        if (n || e % 1 || t % 1) {
          var u = Vs();
          return xe(e + u * (t - e + Rf("1e-" + ((u + "").length - 1))), t);
        }
        return Qi(e, t);
      }
      var n_ = hn(function(e, t, n) {
        return t = t.toLowerCase(), e + (n ? Ta(t) : t);
      });
      function Ta(e) {
        return Co(te(e).toLowerCase());
      }
      function $a(e) {
        return e = te(e), e && e.replace(rf, Vf).replace(Tf, "");
      }
      function r_(e, t, n) {
        e = te(e), t = Re(t);
        var i = e.length;
        n = n === o ? i : kt(z(n), 0, i);
        var u = n;
        return n -= t.length, n >= 0 && e.slice(n, u) == t;
      }
      function i_(e) {
        return e = te(e), e && Nl.test(e) ? e.replace(ts, Kf) : e;
      }
      function o_(e) {
        return e = te(e), e && kl.test(e) ? e.replace(yi, "\\$&") : e;
      }
      var s_ = hn(function(e, t, n) {
        return e + (n ? "-" : "") + t.toLowerCase();
      }), u_ = hn(function(e, t, n) {
        return e + (n ? " " : "") + t.toLowerCase();
      }), a_ = Su("toLowerCase");
      function l_(e, t, n) {
        e = te(e), t = z(t);
        var i = t ? on(e) : 0;
        if (!t || i >= t)
          return e;
        var u = (t - i) / 2;
        return Mr(xr(u), n) + e + Mr(yr(u), n);
      }
      function f_(e, t, n) {
        e = te(e), t = z(t);
        var i = t ? on(e) : 0;
        return t && i < t ? e + Mr(t - i, n) : e;
      }
      function c_(e, t, n) {
        e = te(e), t = z(t);
        var i = t ? on(e) : 0;
        return t && i < t ? Mr(t - i, n) + e : e;
      }
      function h_(e, t, n) {
        return n || t == null ? t = 0 : t && (t = +t), wc(te(e).replace(xi, ""), t || 0);
      }
      function d_(e, t, n) {
        return (n ? $e(e, t, n) : t === o) ? t = 1 : t = z(t), ji(te(e), t);
      }
      function p_() {
        var e = arguments, t = te(e[0]);
        return e.length < 3 ? t : t.replace(e[1], e[2]);
      }
      var g_ = hn(function(e, t, n) {
        return e + (n ? "_" : "") + t.toLowerCase();
      });
      function __(e, t, n) {
        return n && typeof n != "number" && $e(e, t, n) && (t = n = o), n = n === o ? et : n >>> 0, n ? (e = te(e), e && (typeof t == "string" || t != null && !To(t)) && (t = Re(t), !t && rn(e)) ? Pt(Ye(e), 0, n) : e.split(t, n)) : [];
      }
      var v_ = hn(function(e, t, n) {
        return e + (n ? " " : "") + Co(t);
      });
      function m_(e, t, n) {
        return e = te(e), n = n == null ? 0 : kt(z(n), 0, e.length), t = Re(t), e.slice(n, n + t.length) == t;
      }
      function w_(e, t, n) {
        var i = a.templateSettings;
        n && $e(e, t, n) && (t = o), e = te(e), t = Vr({}, t, i, Mu);
        var u = Vr({}, t.imports, i.imports, Mu), l = ve(u), f = Wi(u, l), h, g, x = 0, b = t.interpolate || or, T = "__p += '", A = Bi(
          (t.escape || or).source + "|" + b.source + "|" + (b === ns ? Jl : or).source + "|" + (t.evaluate || or).source + "|$",
          "g"
        ), P = "//# sourceURL=" + (ne.call(t, "sourceURL") ? (t.sourceURL + "").replace(/\s/g, " ") : "lodash.templateSources[" + ++Pf + "]") + `
`;
        e.replace(A, function(M, V, X, De, Ae, We) {
          return X || (X = De), T += e.slice(x, We).replace(of, Yf), V && (h = !0, T += `' +
__e(` + V + `) +
'`), Ae && (g = !0, T += `';
` + Ae + `;
__p += '`), X && (T += `' +
((__t = (` + X + `)) == null ? '' : __t) +
'`), x = We + M.length, M;
        }), T += `';
`;
        var R = ne.call(t, "variable") && t.variable;
        if (!R)
          T = `with (obj) {
` + T + `
}
`;
        else if (Xl.test(R))
          throw new B(w);
        T = (g ? T.replace(Rl, "") : T).replace(Ml, "$1").replace(Dl, "$1;"), T = "function(" + (R || "obj") + `) {
` + (R ? "" : `obj || (obj = {});
`) + "var __t, __p = ''" + (h ? ", __e = _.escape" : "") + (g ? `, __j = Array.prototype.join;
function print() { __p += __j.call(arguments, '') }
` : `;
`) + T + `return __p
}`;
        var k = Ca(function() {
          return j(l, P + "return " + T).apply(o, f);
        });
        if (k.source = T, bo(k))
          throw k;
        return k;
      }
      function y_(e) {
        return te(e).toLowerCase();
      }
      function x_(e) {
        return te(e).toUpperCase();
      }
      function b_(e, t, n) {
        if (e = te(e), e && (n || t === o))
          return Ds(e);
        if (!e || !(t = Re(t)))
          return e;
        var i = Ye(e), u = Ye(t), l = Ws(i, u), f = Ns(i, u) + 1;
        return Pt(i, l, f).join("");
      }
      function T_(e, t, n) {
        if (e = te(e), e && (n || t === o))
          return e.slice(0, Hs(e) + 1);
        if (!e || !(t = Re(t)))
          return e;
        var i = Ye(e), u = Ns(i, Ye(t)) + 1;
        return Pt(i, 0, u).join("");
      }
      function $_(e, t, n) {
        if (e = te(e), e && (n || t === o))
          return e.replace(xi, "");
        if (!e || !(t = Re(t)))
          return e;
        var i = Ye(e), u = Ws(i, Ye(t));
        return Pt(i, u).join("");
      }
      function A_(e, t) {
        var n = wt, i = Dt;
        if (le(t)) {
          var u = "separator" in t ? t.separator : u;
          n = "length" in t ? z(t.length) : n, i = "omission" in t ? Re(t.omission) : i;
        }
        e = te(e);
        var l = e.length;
        if (rn(e)) {
          var f = Ye(e);
          l = f.length;
        }
        if (n >= l)
          return e;
        var h = n - on(i);
        if (h < 1)
          return i;
        var g = f ? Pt(f, 0, h).join("") : e.slice(0, h);
        if (u === o)
          return g + i;
        if (f && (h += g.length - h), To(u)) {
          if (e.slice(h).search(u)) {
            var x, b = g;
            for (u.global || (u = Bi(u.source, te(rs.exec(u)) + "g")), u.lastIndex = 0; x = u.exec(b); )
              var T = x.index;
            g = g.slice(0, T === o ? h : T);
          }
        } else if (e.indexOf(Re(u), h) != h) {
          var A = g.lastIndexOf(u);
          A > -1 && (g = g.slice(0, A));
        }
        return g + i;
      }
      function C_(e) {
        return e = te(e), e && Wl.test(e) ? e.replace(es, tc) : e;
      }
      var S_ = hn(function(e, t, n) {
        return e + (n ? " " : "") + t.toUpperCase();
      }), Co = Su("toUpperCase");
      function Aa(e, t, n) {
        return e = te(e), t = n ? o : t, t === o ? Zf(e) ? ic(e) : zf(e) : e.match(t) || [];
      }
      var Ca = q(function(e, t) {
        try {
          return Le(e, o, t);
        } catch (n) {
          return bo(n) ? n : new B(n);
        }
      }), P_ = lt(function(e, t) {
        return He(t, function(n) {
          n = rt(n), ut(e, n, yo(e[n], e));
        }), e;
      });
      function E_(e) {
        var t = e == null ? 0 : e.length, n = I();
        return e = t ? ae(e, function(i) {
          if (typeof i[1] != "function")
            throw new Fe(m);
          return [n(i[0]), i[1]];
        }) : [], q(function(i) {
          for (var u = -1; ++u < t; ) {
            var l = e[u];
            if (Le(l[0], this, i))
              return Le(l[1], this, i);
          }
        });
      }
      function O_(e) {
        return th(Ue(e, E));
      }
      function So(e) {
        return function() {
          return e;
        };
      }
      function L_(e, t) {
        return e == null || e !== e ? t : e;
      }
      var I_ = Eu(), R_ = Eu(!0);
      function Oe(e) {
        return e;
      }
      function Po(e) {
        return ou(typeof e == "function" ? e : Ue(e, E));
      }
      function M_(e) {
        return uu(Ue(e, E));
      }
      function D_(e, t) {
        return au(e, Ue(t, E));
      }
      var W_ = q(function(e, t) {
        return function(n) {
          return Bn(n, e, t);
        };
      }), N_ = q(function(e, t) {
        return function(n) {
          return Bn(e, n, t);
        };
      });
      function Eo(e, t, n) {
        var i = ve(t), u = Sr(t, i);
        n == null && !(le(t) && (u.length || !i.length)) && (n = t, t = e, e = this, u = Sr(t, ve(t)));
        var l = !(le(n) && "chain" in n) || !!n.chain, f = ct(e);
        return He(u, function(h) {
          var g = t[h];
          e[h] = g, f && (e.prototype[h] = function() {
            var x = this.__chain__;
            if (l || x) {
              var b = e(this.__wrapped__), T = b.__actions__ = Se(this.__actions__);
              return T.push({ func: g, args: arguments, thisArg: e }), b.__chain__ = x, b;
            }
            return g.apply(e, bt([this.value()], arguments));
          });
        }), e;
      }
      function B_() {
        return we._ === this && (we._ = fc), this;
      }
      function Oo() {
      }
      function H_(e) {
        return e = z(e), q(function(t) {
          return lu(t, e);
        });
      }
      var F_ = so(ae), z_ = so(Os), U_ = so(Li);
      function Sa(e) {
        return po(e) ? Ii(rt(e)) : mh(e);
      }
      function k_(e) {
        return function(t) {
          return e == null ? o : qt(e, t);
        };
      }
      var q_ = Lu(), G_ = Lu(!0);
      function Lo() {
        return [];
      }
      function Io() {
        return !1;
      }
      function V_() {
        return {};
      }
      function K_() {
        return "";
      }
      function Y_() {
        return !0;
      }
      function X_(e, t) {
        if (e = z(e), e < 1 || e > yt)
          return [];
        var n = et, i = xe(e, et);
        t = I(t), e -= et;
        for (var u = Di(i, t); ++n < e; )
          t(n);
        return u;
      }
      function Z_(e) {
        return H(e) ? ae(e, rt) : Me(e) ? [e] : Se(Ku(te(e)));
      }
      function J_(e) {
        var t = ++ac;
        return te(e) + t;
      }
      var Q_ = Rr(function(e, t) {
        return e + t;
      }, 0), j_ = uo("ceil"), ev = Rr(function(e, t) {
        return e / t;
      }, 1), tv = uo("floor");
      function nv(e) {
        return e && e.length ? Cr(e, Oe, Vi) : o;
      }
      function rv(e, t) {
        return e && e.length ? Cr(e, I(t, 2), Vi) : o;
      }
      function iv(e) {
        return Rs(e, Oe);
      }
      function ov(e, t) {
        return Rs(e, I(t, 2));
      }
      function sv(e) {
        return e && e.length ? Cr(e, Oe, Zi) : o;
      }
      function uv(e, t) {
        return e && e.length ? Cr(e, I(t, 2), Zi) : o;
      }
      var av = Rr(function(e, t) {
        return e * t;
      }, 1), lv = uo("round"), fv = Rr(function(e, t) {
        return e - t;
      }, 0);
      function cv(e) {
        return e && e.length ? Mi(e, Oe) : 0;
      }
      function hv(e, t) {
        return e && e.length ? Mi(e, I(t, 2)) : 0;
      }
      return a.after = Mp, a.ary = ia, a.assign = xg, a.assignIn = ma, a.assignInWith = Vr, a.assignWith = bg, a.at = Tg, a.before = oa, a.bind = yo, a.bindAll = P_, a.bindKey = sa, a.castArray = Vp, a.chain = ta, a.chunk = td, a.compact = nd, a.concat = rd, a.cond = E_, a.conforms = O_, a.constant = So, a.countBy = cp, a.create = $g, a.curry = ua, a.curryRight = aa, a.debounce = la, a.defaults = Ag, a.defaultsDeep = Cg, a.defer = Dp, a.delay = Wp, a.difference = id, a.differenceBy = od, a.differenceWith = sd, a.drop = ud, a.dropRight = ad, a.dropRightWhile = ld, a.dropWhile = fd, a.fill = cd, a.filter = dp, a.flatMap = _p, a.flatMapDeep = vp, a.flatMapDepth = mp, a.flatten = Ju, a.flattenDeep = hd, a.flattenDepth = dd, a.flip = Np, a.flow = I_, a.flowRight = R_, a.fromPairs = pd, a.functions = Rg, a.functionsIn = Mg, a.groupBy = wp, a.initial = _d, a.intersection = vd, a.intersectionBy = md, a.intersectionWith = wd, a.invert = Wg, a.invertBy = Ng, a.invokeMap = xp, a.iteratee = Po, a.keyBy = bp, a.keys = ve, a.keysIn = Ee, a.map = Fr, a.mapKeys = Hg, a.mapValues = Fg, a.matches = M_, a.matchesProperty = D_, a.memoize = Ur, a.merge = zg, a.mergeWith = wa, a.method = W_, a.methodOf = N_, a.mixin = Eo, a.negate = kr, a.nthArg = H_, a.omit = Ug, a.omitBy = kg, a.once = Bp, a.orderBy = Tp, a.over = F_, a.overArgs = Hp, a.overEvery = z_, a.overSome = U_, a.partial = xo, a.partialRight = fa, a.partition = $p, a.pick = qg, a.pickBy = ya, a.property = Sa, a.propertyOf = k_, a.pull = Td, a.pullAll = ju, a.pullAllBy = $d, a.pullAllWith = Ad, a.pullAt = Cd, a.range = q_, a.rangeRight = G_, a.rearg = Fp, a.reject = Sp, a.remove = Sd, a.rest = zp, a.reverse = mo, a.sampleSize = Ep, a.set = Vg, a.setWith = Kg, a.shuffle = Op, a.slice = Pd, a.sortBy = Rp, a.sortedUniq = Dd, a.sortedUniqBy = Wd, a.split = __, a.spread = Up, a.tail = Nd, a.take = Bd, a.takeRight = Hd, a.takeRightWhile = Fd, a.takeWhile = zd, a.tap = np, a.throttle = kp, a.thru = Hr, a.toArray = ga, a.toPairs = xa, a.toPairsIn = ba, a.toPath = Z_, a.toPlainObject = va, a.transform = Yg, a.unary = qp, a.union = Ud, a.unionBy = kd, a.unionWith = qd, a.uniq = Gd, a.uniqBy = Vd, a.uniqWith = Kd, a.unset = Xg, a.unzip = wo, a.unzipWith = ea, a.update = Zg, a.updateWith = Jg, a.values = gn, a.valuesIn = Qg, a.without = Yd, a.words = Aa, a.wrap = Gp, a.xor = Xd, a.xorBy = Zd, a.xorWith = Jd, a.zip = Qd, a.zipObject = jd, a.zipObjectDeep = ep, a.zipWith = tp, a.entries = xa, a.entriesIn = ba, a.extend = ma, a.extendWith = Vr, Eo(a, a), a.add = Q_, a.attempt = Ca, a.camelCase = n_, a.capitalize = Ta, a.ceil = j_, a.clamp = jg, a.clone = Kp, a.cloneDeep = Xp, a.cloneDeepWith = Zp, a.cloneWith = Yp, a.conformsTo = Jp, a.deburr = $a, a.defaultTo = L_, a.divide = ev, a.endsWith = r_, a.eq = Ze, a.escape = i_, a.escapeRegExp = o_, a.every = hp, a.find = pp, a.findIndex = Xu, a.findKey = Sg, a.findLast = gp, a.findLastIndex = Zu, a.findLastKey = Pg, a.floor = tv, a.forEach = na, a.forEachRight = ra, a.forIn = Eg, a.forInRight = Og, a.forOwn = Lg, a.forOwnRight = Ig, a.get = $o, a.gt = Qp, a.gte = jp, a.has = Dg, a.hasIn = Ao, a.head = Qu, a.identity = Oe, a.includes = yp, a.indexOf = gd, a.inRange = e_, a.invoke = Bg, a.isArguments = Kt, a.isArray = H, a.isArrayBuffer = eg, a.isArrayLike = Pe, a.isArrayLikeObject = he, a.isBoolean = tg, a.isBuffer = Et, a.isDate = ng, a.isElement = rg, a.isEmpty = ig, a.isEqual = og, a.isEqualWith = sg, a.isError = bo, a.isFinite = ug, a.isFunction = ct, a.isInteger = ca, a.isLength = qr, a.isMap = ha, a.isMatch = ag, a.isMatchWith = lg, a.isNaN = fg, a.isNative = cg, a.isNil = dg, a.isNull = hg, a.isNumber = da, a.isObject = le, a.isObjectLike = fe, a.isPlainObject = qn, a.isRegExp = To, a.isSafeInteger = pg, a.isSet = pa, a.isString = Gr, a.isSymbol = Me, a.isTypedArray = pn, a.isUndefined = gg, a.isWeakMap = _g, a.isWeakSet = vg, a.join = yd, a.kebabCase = s_, a.last = qe, a.lastIndexOf = xd, a.lowerCase = u_, a.lowerFirst = a_, a.lt = mg, a.lte = wg, a.max = nv, a.maxBy = rv, a.mean = iv, a.meanBy = ov, a.min = sv, a.minBy = uv, a.stubArray = Lo, a.stubFalse = Io, a.stubObject = V_, a.stubString = K_, a.stubTrue = Y_, a.multiply = av, a.nth = bd, a.noConflict = B_, a.noop = Oo, a.now = zr, a.pad = l_, a.padEnd = f_, a.padStart = c_, a.parseInt = h_, a.random = t_, a.reduce = Ap, a.reduceRight = Cp, a.repeat = d_, a.replace = p_, a.result = Gg, a.round = lv, a.runInContext = p, a.sample = Pp, a.size = Lp, a.snakeCase = g_, a.some = Ip, a.sortedIndex = Ed, a.sortedIndexBy = Od, a.sortedIndexOf = Ld, a.sortedLastIndex = Id, a.sortedLastIndexBy = Rd, a.sortedLastIndexOf = Md, a.startCase = v_, a.startsWith = m_, a.subtract = fv, a.sum = cv, a.sumBy = hv, a.template = w_, a.times = X_, a.toFinite = ht, a.toInteger = z, a.toLength = _a, a.toLower = y_, a.toNumber = Ge, a.toSafeInteger = yg, a.toString = te, a.toUpper = x_, a.trim = b_, a.trimEnd = T_, a.trimStart = $_, a.truncate = A_, a.unescape = C_, a.uniqueId = J_, a.upperCase = S_, a.upperFirst = Co, a.each = na, a.eachRight = ra, a.first = Qu, Eo(a, function() {
        var e = {};
        return tt(a, function(t, n) {
          ne.call(a.prototype, n) || (e[n] = t);
        }), e;
      }(), { chain: !1 }), a.VERSION = c, He(["bind", "bindKey", "curry", "curryRight", "partial", "partialRight"], function(e) {
        a[e].placeholder = a;
      }), He(["drop", "take"], function(e, t) {
        Y.prototype[e] = function(n) {
          n = n === o ? 1 : _e(z(n), 0);
          var i = this.__filtered__ && !t ? new Y(this) : this.clone();
          return i.__filtered__ ? i.__takeCount__ = xe(n, i.__takeCount__) : i.__views__.push({
            size: xe(n, et),
            type: e + (i.__dir__ < 0 ? "Right" : "")
          }), i;
        }, Y.prototype[e + "Right"] = function(n) {
          return this.reverse()[e](n).reverse();
        };
      }), He(["filter", "map", "takeWhile"], function(e, t) {
        var n = t + 1, i = n == Ne || n == bl;
        Y.prototype[e] = function(u) {
          var l = this.clone();
          return l.__iteratees__.push({
            iteratee: I(u, 3),
            type: n
          }), l.__filtered__ = l.__filtered__ || i, l;
        };
      }), He(["head", "last"], function(e, t) {
        var n = "take" + (t ? "Right" : "");
        Y.prototype[e] = function() {
          return this[n](1).value()[0];
        };
      }), He(["initial", "tail"], function(e, t) {
        var n = "drop" + (t ? "" : "Right");
        Y.prototype[e] = function() {
          return this.__filtered__ ? new Y(this) : this[n](1);
        };
      }), Y.prototype.compact = function() {
        return this.filter(Oe);
      }, Y.prototype.find = function(e) {
        return this.filter(e).head();
      }, Y.prototype.findLast = function(e) {
        return this.reverse().find(e);
      }, Y.prototype.invokeMap = q(function(e, t) {
        return typeof e == "function" ? new Y(this) : this.map(function(n) {
          return Bn(n, e, t);
        });
      }), Y.prototype.reject = function(e) {
        return this.filter(kr(I(e)));
      }, Y.prototype.slice = function(e, t) {
        e = z(e);
        var n = this;
        return n.__filtered__ && (e > 0 || t < 0) ? new Y(n) : (e < 0 ? n = n.takeRight(-e) : e && (n = n.drop(e)), t !== o && (t = z(t), n = t < 0 ? n.dropRight(-t) : n.take(t - e)), n);
      }, Y.prototype.takeRightWhile = function(e) {
        return this.reverse().takeWhile(e).reverse();
      }, Y.prototype.toArray = function() {
        return this.take(et);
      }, tt(Y.prototype, function(e, t) {
        var n = /^(?:filter|find|map|reject)|While$/.test(t), i = /^(?:head|last)$/.test(t), u = a[i ? "take" + (t == "last" ? "Right" : "") : t], l = i || /^find/.test(t);
        !u || (a.prototype[t] = function() {
          var f = this.__wrapped__, h = i ? [1] : arguments, g = f instanceof Y, x = h[0], b = g || H(f), T = function(V) {
            var X = u.apply(a, bt([V], h));
            return i && A ? X[0] : X;
          };
          b && n && typeof x == "function" && x.length != 1 && (g = b = !1);
          var A = this.__chain__, P = !!this.__actions__.length, R = l && !A, k = g && !P;
          if (!l && b) {
            f = k ? f : new Y(this);
            var M = e.apply(f, h);
            return M.__actions__.push({ func: Hr, args: [T], thisArg: o }), new ze(M, A);
          }
          return R && k ? e.apply(this, h) : (M = this.thru(T), R ? i ? M.value()[0] : M.value() : M);
        });
      }), He(["pop", "push", "shift", "sort", "splice", "unshift"], function(e) {
        var t = cr[e], n = /^(?:push|sort|unshift)$/.test(e) ? "tap" : "thru", i = /^(?:pop|shift)$/.test(e);
        a.prototype[e] = function() {
          var u = arguments;
          if (i && !this.__chain__) {
            var l = this.value();
            return t.apply(H(l) ? l : [], u);
          }
          return this[n](function(f) {
            return t.apply(H(f) ? f : [], u);
          });
        };
      }), tt(Y.prototype, function(e, t) {
        var n = a[t];
        if (n) {
          var i = n.name + "";
          ne.call(ln, i) || (ln[i] = []), ln[i].push({ name: t, func: n });
        }
      }), ln[Ir(o, G).name] = [{
        name: "wrapper",
        func: o
      }], Y.prototype.clone = Cc, Y.prototype.reverse = Sc, Y.prototype.value = Pc, a.prototype.at = rp, a.prototype.chain = ip, a.prototype.commit = op, a.prototype.next = sp, a.prototype.plant = ap, a.prototype.reverse = lp, a.prototype.toJSON = a.prototype.valueOf = a.prototype.value = fp, a.prototype.first = a.prototype.head, Ln && (a.prototype[Ln] = up), a;
    }, sn = oc();
    Ht ? ((Ht.exports = sn)._ = sn, Si._ = sn) : we._ = sn;
  }).call(_n);
})(Fo, Fo.exports);
const Ea = Fo.exports, pm = {
  computed: {
    $attrsWithoutClassStyleId() {
      return Ea.omit(this.$attrs, ["class", "style", "id"]);
    },
    $attrsClassStyleIdOnly() {
      return Ea.pick(this.$attrs, ["class", "style", "id"]);
    }
  }
};
var Ja = { exports: {} };
(function(r, s) {
  (function(o, c) {
    r.exports = c();
  })(_n, function() {
    var o = "__v-click-outside", c = typeof window < "u", d = typeof navigator < "u", _ = c && ("ontouchstart" in window || d && navigator.msMaxTouchPoints > 0) ? ["touchstart"] : ["click"], m = function(C) {
      var E = C.event, O = C.handler;
      (0, C.middleware)(E) && O(E);
    }, w = function(C, E) {
      var O = function(F) {
        var W = typeof F == "function";
        if (!W && typeof F != "object")
          throw new Error("v-click-outside: Binding value must be a function or an object");
        return { handler: W ? F : F.handler, middleware: F.middleware || function(ee) {
          return ee;
        }, events: F.events || _, isActive: F.isActive !== !1, detectIframe: F.detectIframe !== !1, capture: Boolean(F.capture) };
      }(E.value), D = O.handler, U = O.middleware, Q = O.detectIframe, N = O.capture;
      if (O.isActive) {
        if (C[o] = O.events.map(function(F) {
          return { event: F, srcTarget: document.documentElement, handler: function(W) {
            return function(ee) {
              var se = ee.el, ce = ee.event, pe = ee.handler, ue = ee.middleware, me = ce.path || ce.composedPath && ce.composedPath();
              (me ? me.indexOf(se) < 0 : !se.contains(ce.target)) && m({ event: ce, handler: pe, middleware: ue });
            }({ el: C, event: W, handler: D, middleware: U });
          }, capture: N };
        }), Q) {
          var G = { event: "blur", srcTarget: window, handler: function(F) {
            return function(W) {
              var ee = W.el, se = W.event, ce = W.handler, pe = W.middleware;
              setTimeout(function() {
                var ue = document.activeElement;
                ue && ue.tagName === "IFRAME" && !ee.contains(ue) && m({ event: se, handler: ce, middleware: pe });
              }, 0);
            }({ el: C, event: F, handler: D, middleware: U });
          }, capture: N };
          C[o] = [].concat(C[o], [G]);
        }
        C[o].forEach(function(F) {
          var W = F.event, ee = F.srcTarget, se = F.handler;
          return setTimeout(function() {
            C[o] && ee.addEventListener(W, se, N);
          }, 0);
        });
      }
    }, $ = function(C) {
      (C[o] || []).forEach(function(E) {
        return E.srcTarget.removeEventListener(E.event, E.handler, E.capture);
      }), delete C[o];
    }, L = c ? { beforeMount: w, updated: function(C, E) {
      var O = E.value, D = E.oldValue;
      JSON.stringify(O) !== JSON.stringify(D) && ($(C), w(C, { value: O }));
    }, unmounted: $ } : {};
    return { install: function(C) {
      C.directive("click-outside", L);
    }, directive: L };
  });
})(Ja);
const gm = Ja.exports, Qa = {
  directive: "wave",
  color: "currentColor",
  initialOpacity: 0.2,
  finalOpacity: 0.1,
  duration: 0.4,
  dissolveDuration: 0.15,
  easing: "ease-out",
  cancellationPeriod: 75,
  trigger: "auto",
  tagName: "div"
}, _m = (r) => "config" in r && "globalProperties" in r.config, vm = (r) => {
  let s;
  return r === "vue2" ? s = !1 : r === "vue3" ? s = !0 : s = _m(r), s ? {
    mounted: "mounted",
    updated: "updated"
  } : {
    mounted: "inserted",
    updated: "componentUpdated"
  };
}, ja = (r) => typeof r == "string" && r !== "auto", Oa = (r, s) => {
  r.dataset.vWaveBoundary = ja(s) ? s : "true";
}, mm = ({ borderTopLeftRadius: r, borderTopRightRadius: s, borderBottomLeftRadius: o, borderBottomRightRadius: c }, d) => {
  const _ = document.createElement(d);
  return _.style.top = "0", _.style.left = "0", _.style.width = "100%", _.style.height = "100%", _.style.display = "block", _.style.position = "absolute", _.style.borderRadius = `${r} ${s} ${c} ${o}`, _.style.overflow = "hidden", _.style.pointerEvents = "none", _.style.webkitMaskImage = "-webkit-radial-gradient(white, black)", _;
}, wm = (r, s, o, c) => {
  const d = document.createElement("div");
  return d.style.position = "absolute", d.style.width = `${o}px`, d.style.height = `${o}px`, d.style.top = `${s}px`, d.style.left = `${r}px`, d.style.background = c.color, d.style.borderRadius = "50%", d.style.opacity = `${c.initialOpacity}`, d.style.transform = "translate(-50%,-50%) scale(0)", d.style.transition = `transform ${c.duration}s ${c.easing}, opacity ${c.duration}s ${c.easing}`, d;
};
function Kr(r, s, o, c) {
  const d = r - o, _ = s - c;
  return Math.sqrt(d * d + _ * _);
}
function ym(r, s, { width: o, height: c }) {
  const d = Kr(r, s, 0, 0), _ = Kr(r, s, o, 0), m = Kr(r, s, 0, c), w = Kr(r, s, o, c);
  return Math.max(d, _, m, w);
}
const xm = ({ x: r, y: s }, { top: o, left: c }) => ({
  x: r - c,
  y: s - o
}), Ko = "vWaveCountInternal";
function bm(r) {
  const s = Yo(r);
  el(r, s + 1);
}
function Tm(r) {
  const s = Yo(r);
  el(r, s - 1);
}
function el(r, s) {
  r.dataset[Ko] = s.toString();
}
function Yo(r) {
  var s;
  return parseInt((s = r.dataset[Ko]) !== null && s !== void 0 ? s : "0", 10);
}
function $m(r) {
  delete r.dataset[Ko];
}
const Do = (r, s, o) => {
  const c = s.getBoundingClientRect(), d = window.getComputedStyle(s), { x: _, y: m } = xm(r, c), w = 2.05 * ym(_, m, c), $ = mm(d, o.tagName), L = wm(_, m, w, o);
  bm(s);
  let C = "";
  d.position === "static" && (s.style.position && (C = s.style.position), s.style.position = "relative"), $.appendChild(L), s.appendChild($);
  let E = !1;
  const O = (N) => {
    typeof N < "u" && (document.removeEventListener("pointerup", O), document.removeEventListener("pointercancel", O)), E ? D() : E = !0;
  }, D = () => {
    L.style.transition = `opacity ${o.dissolveDuration}s linear`, L.style.opacity = "0", setTimeout(() => {
      $.remove(), Tm(s), Yo(s) === 0 && ($m(s), s.style.position = C);
    }, o.dissolveDuration * 1e3);
  };
  document.addEventListener("pointerup", O), document.addEventListener("pointercancel", O);
  const U = setTimeout(() => {
    document.removeEventListener("pointercancel", Q), requestAnimationFrame(() => {
      L.style.transform = "translate(-50%,-50%) scale(1)", L.style.opacity = `${o.finalOpacity}`, setTimeout(() => O(), o.duration * 1e3);
    });
  }, o.cancellationPeriod), Q = () => {
    clearTimeout(U), $.remove(), document.removeEventListener("pointerup", O), document.removeEventListener("pointercancel", O), document.removeEventListener("pointercancel", Q);
  };
  document.addEventListener("pointercancel", Q);
}, Gn = /* @__PURE__ */ new WeakMap(), La = (r = {}, s = "vue3") => {
  const o = Object.assign(Object.assign({}, Qa), r), c = vm(s), d = (w) => {
    const $ = w.currentTarget.dataset.vWaveTrigger;
    document.querySelectorAll(`[data-v-wave-boundary="${$}"]`).forEach((C) => Do(w, C, Object.assign(Object.assign({}, o), Gn.get(C))));
  }, _ = {
    [c.mounted](w, { value: $ = {} }) {
      var L;
      Gn.set(w, $), Oa(w, (L = $ && $.trigger) !== null && L !== void 0 ? L : o.trigger), w.addEventListener("pointerdown", (C) => {
        if (Gn.get(w) === !1)
          return;
        const E = Object.assign(Object.assign({}, o), Gn.get(w));
        if (E.trigger === !1)
          return Do(C, w, E);
        if (ja(E.trigger))
          return;
        const O = w.querySelector('[data-v-wave-trigger="true"]');
        !O && E.trigger === !0 || O && !C.composedPath().includes(O) || Do(C, w, E);
      });
    },
    [c.updated](w, { value: $ = {} }) {
      var L;
      Gn.set(w, $), Oa(w, (L = $ && $.trigger) !== null && L !== void 0 ? L : o.trigger);
    }
  }, m = {
    [c.mounted](w, { arg: $ = "true" }) {
      w.dataset.vWaveTrigger = $, $ !== "true" && w.addEventListener("pointerdown", d);
    },
    [c.updated](w, { arg: $ = "true" }) {
      w.dataset.vWaveTrigger = $, $ === "true" ? w.removeEventListener("pointerdown", d) : w.addEventListener("pointerdown", d);
    }
  };
  return {
    wave: _,
    vWave: _,
    waveTrigger: m,
    vWaveTrigger: m
  };
}, Am = {
  install(r, s = {}) {
    if (this.installed)
      return;
    this.installed = !0;
    const o = Object.assign(Object.assign({}, Qa), s), { vWave: c, vWaveTrigger: d } = La(o, r);
    r.directive(o.directive, c), r.directive(`${o.directive}-trigger`, d);
  },
  installed: !1,
  createLocalWaveDirective: La
};
function mt(r) {
  return r.split("-")[0];
}
function vn(r) {
  return r.split("-")[1];
}
function Qn(r) {
  return ["top", "bottom"].includes(mt(r)) ? "x" : "y";
}
function Xo(r) {
  return r === "y" ? "height" : "width";
}
function Ia(r) {
  let {
    reference: s,
    floating: o,
    placement: c
  } = r;
  const d = s.x + s.width / 2 - o.width / 2, _ = s.y + s.height / 2 - o.height / 2;
  let m;
  switch (mt(c)) {
    case "top":
      m = {
        x: d,
        y: s.y - o.height
      };
      break;
    case "bottom":
      m = {
        x: d,
        y: s.y + s.height
      };
      break;
    case "right":
      m = {
        x: s.x + s.width,
        y: _
      };
      break;
    case "left":
      m = {
        x: s.x - o.width,
        y: _
      };
      break;
    default:
      m = {
        x: s.x,
        y: s.y
      };
  }
  const w = Qn(c), $ = Xo(w);
  switch (vn(c)) {
    case "start":
      m[w] = m[w] - (s[$] / 2 - o[$] / 2);
      break;
    case "end":
      m[w] = m[w] + (s[$] / 2 - o[$] / 2);
      break;
  }
  return m;
}
const Cm = async (r, s, o) => {
  const {
    placement: c = "bottom",
    strategy: d = "absolute",
    middleware: _ = [],
    platform: m
  } = o;
  if (process.env.NODE_ENV !== "production" && (m == null && console.error(["Floating UI: `platform` property was not passed to config. If you", "want to use Floating UI on the web, install @floating-ui/dom", "instead of the /core package. Otherwise, you can create your own", "`platform`: https://floating-ui.com/docs/platform"].join(" ")), _.filter((D) => {
    let {
      name: U
    } = D;
    return U === "autoPlacement" || U === "flip";
  }).length > 1))
    throw new Error(["Floating UI: duplicate `flip` and/or `autoPlacement`", "middleware detected. This will lead to an infinite loop. Ensure only", "one of either has been passed to the `middleware` array."].join(" "));
  let w = await m.getElementRects({
    reference: r,
    floating: s,
    strategy: d
  }), {
    x: $,
    y: L
  } = Ia({
    ...w,
    placement: c
  }), C = c, E = {}, O = 0;
  for (let D = 0; D < _.length; D++) {
    if (process.env.NODE_ENV !== "production" && (O++, O > 100))
      throw new Error(["Floating UI: The middleware lifecycle appears to be", "running in an infinite loop. This is usually caused by a `reset`", "continually being returned without a break condition."].join(" "));
    const {
      name: U,
      fn: Q
    } = _[D], {
      x: N,
      y: G,
      data: F,
      reset: W
    } = await Q({
      x: $,
      y: L,
      initialPlacement: c,
      placement: C,
      strategy: d,
      middlewareData: E,
      rects: w,
      platform: m,
      elements: {
        reference: r,
        floating: s
      }
    });
    if ($ = N != null ? N : $, L = G != null ? G : L, E = {
      ...E,
      [U]: F != null ? F : {}
    }, W) {
      typeof W == "object" && (W.placement && (C = W.placement), W.rects && (w = W.rects === !0 ? await m.getElementRects({
        reference: r,
        floating: s,
        strategy: d
      }) : W.rects), {
        x: $,
        y: L
      } = Ia({
        ...w,
        placement: C
      })), D = -1;
      continue;
    }
  }
  return {
    x: $,
    y: L,
    placement: C,
    strategy: d,
    middlewareData: E
  };
};
function Sm(r) {
  return {
    top: 0,
    right: 0,
    bottom: 0,
    left: 0,
    ...r
  };
}
function tl(r) {
  return typeof r != "number" ? Sm(r) : {
    top: r,
    right: r,
    bottom: r,
    left: r
  };
}
function zo(r) {
  return {
    ...r,
    top: r.y,
    left: r.x,
    right: r.x + r.width,
    bottom: r.y + r.height
  };
}
async function ii(r, s) {
  s === void 0 && (s = {});
  const {
    x: o,
    y: c,
    platform: d,
    rects: _,
    elements: m,
    strategy: w
  } = r, {
    boundary: $ = "clippingParents",
    rootBoundary: L = "viewport",
    elementContext: C = "floating",
    altBoundary: E = !1,
    padding: O = 0
  } = s, D = tl(O), Q = m[E ? C === "floating" ? "reference" : "floating" : C], N = await d.getClippingClientRect({
    element: await d.isElement(Q) ? Q : Q.contextElement || await d.getDocumentElement({
      element: m.floating
    }),
    boundary: $,
    rootBoundary: L
  }), G = zo(await d.convertOffsetParentRelativeRectToViewportRelativeRect({
    rect: C === "floating" ? {
      ..._.floating,
      x: o,
      y: c
    } : _.reference,
    offsetParent: await d.getOffsetParent({
      element: m.floating
    }),
    strategy: w
  }));
  return {
    top: N.top - G.top + D.top,
    bottom: G.bottom - N.bottom + D.bottom,
    left: N.left - G.left + D.left,
    right: G.right - N.right + D.right
  };
}
const Pm = Math.min, Xt = Math.max;
function Uo(r, s, o) {
  return Xt(r, Pm(s, o));
}
const Em = (r) => ({
  name: "arrow",
  options: r,
  async fn(s) {
    const {
      element: o,
      padding: c = 0
    } = r != null ? r : {}, {
      x: d,
      y: _,
      placement: m,
      rects: w,
      platform: $
    } = s;
    if (o == null)
      return process.env.NODE_ENV !== "production" && console.warn("Floating UI: No `element` was passed to the `arrow` middleware."), {};
    const L = tl(c), C = {
      x: d,
      y: _
    }, E = mt(m), O = Qn(E), D = Xo(O), U = await $.getDimensions({
      element: o
    }), Q = O === "y" ? "top" : "left", N = O === "y" ? "bottom" : "right", G = w.reference[D] + w.reference[O] - C[O] - w.floating[D], F = C[O] - w.reference[O], W = await $.getOffsetParent({
      element: o
    }), ee = W ? O === "y" ? W.clientHeight || 0 : W.clientWidth || 0 : 0, se = G / 2 - F / 2, ce = L[Q], pe = ee - U[D] - L[N], ue = ee / 2 - U[D] / 2 + se, me = Uo(ce, ue, pe);
    return {
      data: {
        [O]: me,
        centerOffset: ue - me
      }
    };
  }
}), Om = {
  left: "right",
  right: "left",
  bottom: "top",
  top: "bottom"
};
function Jr(r) {
  return r.replace(/left|right|bottom|top/g, (s) => Om[s]);
}
function nl(r, s) {
  const o = vn(r) === "start", c = Qn(r), d = Xo(c);
  let _ = c === "x" ? o ? "right" : "left" : o ? "bottom" : "top";
  return s.reference[d] > s.floating[d] && (_ = Jr(_)), {
    main: _,
    cross: Jr(_)
  };
}
const Lm = {
  start: "end",
  end: "start"
};
function ko(r) {
  return r.replace(/start|end/g, (s) => Lm[s]);
}
const Im = ["top", "right", "bottom", "left"], Rm = /* @__PURE__ */ Im.reduce((r, s) => r.concat(s, s + "-start", s + "-end"), []);
function Mm(r, s, o) {
  return (r ? [...o.filter((d) => vn(d) === r), ...o.filter((d) => vn(d) !== r)] : o.filter((d) => mt(d) === d)).filter((d) => r ? vn(d) === r || (s ? ko(d) !== d : !1) : !0);
}
const Dm = function(r) {
  return r === void 0 && (r = {}), {
    name: "autoPlacement",
    options: r,
    async fn(s) {
      var o, c, d, _, m, w;
      const {
        x: $,
        y: L,
        rects: C,
        middlewareData: E,
        placement: O
      } = s, {
        alignment: D = null,
        allowedPlacements: U = Rm,
        autoAlignment: Q = !0,
        ...N
      } = r;
      if ((o = E.autoPlacement) != null && o.skip)
        return {};
      const G = Mm(D, Q, U), F = await ii(s, N), W = (c = (d = E.autoPlacement) == null ? void 0 : d.index) != null ? c : 0, ee = G[W], {
        main: se,
        cross: ce
      } = nl(ee, C);
      if (O !== ee)
        return {
          x: $,
          y: L,
          reset: {
            placement: G[0]
          }
        };
      const pe = [F[mt(ee)], F[se], F[ce]], ue = [...(_ = (m = E.autoPlacement) == null ? void 0 : m.overflows) != null ? _ : [], {
        placement: ee,
        overflows: pe
      }], me = G[W + 1];
      if (me)
        return {
          data: {
            index: W + 1,
            overflows: ue
          },
          reset: {
            placement: me
          }
        };
      const wt = ue.slice().sort((Wt, Nt) => Wt.overflows[0] - Nt.overflows[0]), Dt = (w = wt.find((Wt) => {
        let {
          overflows: Nt
        } = Wt;
        return Nt.every((Ne) => Ne <= 0);
      })) == null ? void 0 : w.placement;
      return {
        data: {
          skip: !0
        },
        reset: {
          placement: Dt != null ? Dt : wt[0].placement
        }
      };
    }
  };
};
function Wm(r) {
  const s = Jr(r);
  return [ko(r), s, ko(s)];
}
const Nm = function(r) {
  return r === void 0 && (r = {}), {
    name: "flip",
    options: r,
    async fn(s) {
      var o, c;
      const {
        placement: d,
        middlewareData: _,
        rects: m,
        initialPlacement: w
      } = s;
      if ((o = _.flip) != null && o.skip)
        return {};
      const {
        mainAxis: $ = !0,
        crossAxis: L = !0,
        fallbackPlacements: C,
        fallbackStrategy: E = "bestFit",
        flipAlignment: O = !0,
        ...D
      } = r, U = mt(d), N = C || (U === w || !O ? [Jr(w)] : Wm(w)), G = [w, ...N], F = await ii(s, D), W = [];
      let ee = ((c = _.flip) == null ? void 0 : c.overflows) || [];
      if ($ && W.push(F[U]), L) {
        const {
          main: ue,
          cross: me
        } = nl(d, m);
        W.push(F[ue], F[me]);
      }
      if (ee = [...ee, {
        placement: d,
        overflows: W
      }], !W.every((ue) => ue <= 0)) {
        var se, ce;
        const ue = ((se = (ce = _.flip) == null ? void 0 : ce.index) != null ? se : 0) + 1, me = G[ue];
        if (me)
          return {
            data: {
              index: ue,
              overflows: ee
            },
            reset: {
              placement: me
            }
          };
        let wt = "bottom";
        switch (E) {
          case "bestFit": {
            var pe;
            const Dt = (pe = ee.slice().sort((Wt, Nt) => Wt.overflows.filter((Ne) => Ne > 0).reduce((Ne, bn) => Ne + bn, 0) - Nt.overflows.filter((Ne) => Ne > 0).reduce((Ne, bn) => Ne + bn, 0))[0]) == null ? void 0 : pe.placement;
            Dt && (wt = Dt);
            break;
          }
          case "initialPlacement":
            wt = w;
            break;
        }
        return {
          data: {
            skip: !0
          },
          reset: {
            placement: wt
          }
        };
      }
      return {};
    }
  };
};
function Bm(r) {
  let {
    placement: s,
    rects: o,
    value: c
  } = r;
  const d = mt(s), _ = ["left", "top"].includes(d) ? -1 : 1, m = typeof c == "function" ? c({
    ...o,
    placement: s
  }) : c, {
    mainAxis: w,
    crossAxis: $
  } = typeof m == "number" ? {
    mainAxis: m,
    crossAxis: 0
  } : {
    mainAxis: 0,
    crossAxis: 0,
    ...m
  };
  return Qn(d) === "x" ? {
    x: $,
    y: w * _
  } : {
    x: w * _,
    y: $
  };
}
const Hm = function(r) {
  return r === void 0 && (r = 0), {
    name: "offset",
    options: r,
    fn(s) {
      const {
        x: o,
        y: c,
        placement: d,
        rects: _
      } = s, m = Bm({
        placement: d,
        rects: _,
        value: r
      });
      return {
        x: o + m.x,
        y: c + m.y,
        data: m
      };
    }
  };
};
function Fm(r) {
  return r === "x" ? "y" : "x";
}
const zm = function(r) {
  return r === void 0 && (r = {}), {
    name: "shift",
    options: r,
    async fn(s) {
      const {
        x: o,
        y: c,
        placement: d
      } = s, {
        mainAxis: _ = !0,
        crossAxis: m = !1,
        limiter: w = {
          fn: (N) => {
            let {
              x: G,
              y: F
            } = N;
            return {
              x: G,
              y: F
            };
          }
        },
        ...$
      } = r, L = {
        x: o,
        y: c
      }, C = await ii(s, $), E = Qn(mt(d)), O = Fm(E);
      let D = L[E], U = L[O];
      if (_) {
        const N = E === "y" ? "top" : "left", G = E === "y" ? "bottom" : "right", F = D + C[N], W = D - C[G];
        D = Uo(F, D, W);
      }
      if (m) {
        const N = O === "y" ? "top" : "left", G = O === "y" ? "bottom" : "right", F = U + C[N], W = U - C[G];
        U = Uo(F, U, W);
      }
      const Q = w.fn({
        ...s,
        [E]: D,
        [O]: U
      });
      return {
        ...Q,
        data: {
          x: Q.x - o,
          y: Q.y - c
        }
      };
    }
  };
}, Um = function(r) {
  return r === void 0 && (r = {}), {
    name: "size",
    options: r,
    async fn(s) {
      var o;
      const {
        placement: c,
        rects: d,
        middlewareData: _
      } = s, {
        apply: m,
        ...w
      } = r;
      if ((o = _.size) != null && o.skip)
        return {};
      const $ = await ii(s, w), L = mt(c), C = vn(c) === "end";
      let E, O;
      L === "top" || L === "bottom" ? (E = L, O = C ? "left" : "right") : (O = L, E = C ? "top" : "bottom");
      const D = Xt($.left, 0), U = Xt($.right, 0), Q = Xt($.top, 0), N = Xt($.bottom, 0), G = {
        height: d.floating.height - (["left", "right"].includes(c) ? 2 * (Q !== 0 || N !== 0 ? Q + N : Xt($.top, $.bottom)) : $[E]),
        width: d.floating.width - (["top", "bottom"].includes(c) ? 2 * (D !== 0 || U !== 0 ? D + U : Xt($.left, $.right)) : $[O])
      };
      return m == null || m({
        ...G,
        ...d
      }), {
        data: {
          skip: !0
        },
        reset: {
          rects: !0
        }
      };
    }
  };
};
function Zo(r) {
  return (r == null ? void 0 : r.toString()) === "[object Window]";
}
function Rt(r) {
  if (r == null)
    return window;
  if (!Zo(r)) {
    const s = r.ownerDocument;
    return s && s.defaultView || window;
  }
  return r;
}
function oi(r) {
  return Rt(r).getComputedStyle(r);
}
function _t(r) {
  return Zo(r) ? "" : r ? (r.nodeName || "").toLowerCase() : "";
}
function vt(r) {
  return r instanceof Rt(r).HTMLElement;
}
function Qr(r) {
  return r instanceof Rt(r).Element;
}
function km(r) {
  return r instanceof Rt(r).Node;
}
function rl(r) {
  const s = Rt(r).ShadowRoot;
  return r instanceof s || r instanceof ShadowRoot;
}
function si(r) {
  const {
    overflow: s,
    overflowX: o,
    overflowY: c
  } = oi(r);
  return /auto|scroll|overlay|hidden/.test(s + c + o);
}
function qm(r) {
  return ["table", "td", "th"].includes(_t(r));
}
function il(r) {
  const s = navigator.userAgent.toLowerCase().includes("firefox"), o = oi(r);
  return o.transform !== "none" || o.perspective !== "none" || o.contain === "paint" || ["transform", "perspective"].includes(o.willChange) || s && o.willChange === "filter" || s && (o.filter ? o.filter !== "none" : !1);
}
const Ra = Math.min, Vn = Math.max, jr = Math.round;
function yn(r, s) {
  s === void 0 && (s = !1);
  const o = r.getBoundingClientRect();
  let c = 1, d = 1;
  return s && vt(r) && (c = r.offsetWidth > 0 && jr(o.width) / r.offsetWidth || 1, d = r.offsetHeight > 0 && jr(o.height) / r.offsetHeight || 1), {
    width: o.width / c,
    height: o.height / d,
    top: o.top / d,
    right: o.right / c,
    bottom: o.bottom / d,
    left: o.left / c,
    x: o.left / c,
    y: o.top / d
  };
}
function Mt(r) {
  return ((km(r) ? r.ownerDocument : r.document) || window.document).documentElement;
}
function ui(r) {
  return Zo(r) ? {
    scrollLeft: r.pageXOffset,
    scrollTop: r.pageYOffset
  } : {
    scrollLeft: r.scrollLeft,
    scrollTop: r.scrollTop
  };
}
function ol(r) {
  return yn(Mt(r)).left + ui(r).scrollLeft;
}
function Gm(r) {
  const s = yn(r);
  return jr(s.width) !== r.offsetWidth || jr(s.height) !== r.offsetHeight;
}
function Vm(r, s, o) {
  const c = vt(s), d = Mt(s), _ = yn(r, c && Gm(s));
  let m = {
    scrollLeft: 0,
    scrollTop: 0
  };
  const w = {
    x: 0,
    y: 0
  };
  if (c || !c && o !== "fixed")
    if ((_t(s) !== "body" || si(d)) && (m = ui(s)), vt(s)) {
      const $ = yn(s, !0);
      w.x = $.x + s.clientLeft, w.y = $.y + s.clientTop;
    } else
      d && (w.x = ol(d));
  return {
    x: _.left + m.scrollLeft - w.x,
    y: _.top + m.scrollTop - w.y,
    width: _.width,
    height: _.height
  };
}
function ai(r) {
  return _t(r) === "html" ? r : r.assignedSlot || r.parentNode || (rl(r) ? r.host : null) || Mt(r);
}
function Ma(r) {
  return !vt(r) || getComputedStyle(r).position === "fixed" ? null : r.offsetParent;
}
function Km(r) {
  let s = ai(r);
  for (; vt(s) && !["html", "body"].includes(_t(s)); ) {
    if (il(s))
      return s;
    s = s.parentNode;
  }
  return null;
}
function qo(r) {
  const s = Rt(r);
  let o = Ma(r);
  for (; o && qm(o) && getComputedStyle(o).position === "static"; )
    o = Ma(o);
  return o && (_t(o) === "html" || _t(o) === "body" && getComputedStyle(o).position === "static" && !il(o)) ? s : o || Km(r) || s;
}
function Da(r) {
  return {
    width: r.offsetWidth,
    height: r.offsetHeight
  };
}
function Ym(r) {
  let {
    rect: s,
    offsetParent: o,
    strategy: c
  } = r;
  const d = vt(o), _ = Mt(o);
  if (o === _)
    return s;
  let m = {
    scrollLeft: 0,
    scrollTop: 0
  };
  const w = {
    x: 0,
    y: 0
  };
  if ((d || !d && c !== "fixed") && ((_t(o) !== "body" || si(_)) && (m = ui(o)), vt(o))) {
    const $ = yn(o, !0);
    w.x = $.x + o.clientLeft, w.y = $.y + o.clientTop;
  }
  return {
    ...s,
    x: s.x - m.scrollLeft + w.x,
    y: s.y - m.scrollTop + w.y
  };
}
function Xm(r) {
  const s = Rt(r), o = Mt(r), c = s.visualViewport;
  let d = o.clientWidth, _ = o.clientHeight, m = 0, w = 0;
  return c && (d = c.width, _ = c.height, Math.abs(s.innerWidth / c.scale - c.width) < 0.01 && (m = c.offsetLeft, w = c.offsetTop)), {
    width: d,
    height: _,
    x: m,
    y: w
  };
}
function Zm(r) {
  var s;
  const o = Mt(r), c = ui(r), d = (s = r.ownerDocument) == null ? void 0 : s.body, _ = Vn(o.scrollWidth, o.clientWidth, d ? d.scrollWidth : 0, d ? d.clientWidth : 0), m = Vn(o.scrollHeight, o.clientHeight, d ? d.scrollHeight : 0, d ? d.clientHeight : 0);
  let w = -c.scrollLeft + ol(r);
  const $ = -c.scrollTop;
  return oi(d || o).direction === "rtl" && (w += Vn(o.clientWidth, d ? d.clientWidth : 0) - _), {
    width: _,
    height: m,
    x: w,
    y: $
  };
}
function sl(r) {
  return ["html", "body", "#document"].includes(_t(r)) ? r.ownerDocument.body : vt(r) && si(r) ? r : sl(ai(r));
}
function ei(r, s) {
  var o;
  s === void 0 && (s = []);
  const c = sl(r), d = c === ((o = r.ownerDocument) == null ? void 0 : o.body), _ = Rt(c), m = d ? [_].concat(_.visualViewport || [], si(c) ? c : []) : c, w = s.concat(m);
  return d ? w : w.concat(ei(ai(m)));
}
function Jm(r, s) {
  const o = s.getRootNode == null ? void 0 : s.getRootNode();
  if (r.contains(s))
    return !0;
  if (o && rl(o)) {
    let c = s;
    do {
      if (c && r === c)
        return !0;
      c = c.parentNode || c.host;
    } while (c);
  }
  return !1;
}
function Qm(r) {
  const s = yn(r), o = s.top + r.clientTop, c = s.left + r.clientLeft;
  return {
    top: o,
    left: c,
    x: c,
    y: o,
    right: c + r.clientWidth,
    bottom: o + r.clientHeight,
    width: r.clientWidth,
    height: r.clientHeight
  };
}
function Wa(r, s) {
  return s === "viewport" ? zo(Xm(r)) : Qr(s) ? Qm(s) : zo(Zm(Mt(r)));
}
function jm(r) {
  const s = ei(ai(r)), c = ["absolute", "fixed"].includes(oi(r).position) && vt(r) ? qo(r) : r;
  return Qr(c) ? s.filter((d) => Qr(d) && Jm(d, c) && _t(d) !== "body") : [];
}
function e0(r) {
  let {
    element: s,
    boundary: o,
    rootBoundary: c
  } = r;
  const _ = [...o === "clippingParents" ? jm(s) : [].concat(o), c], m = _[0], w = _.reduce(($, L) => {
    const C = Wa(s, L);
    return $.top = Vn(C.top, $.top), $.right = Ra(C.right, $.right), $.bottom = Ra(C.bottom, $.bottom), $.left = Vn(C.left, $.left), $;
  }, Wa(s, m));
  return w.width = w.right - w.left, w.height = w.bottom - w.top, w.x = w.left, w.y = w.top, w;
}
const t0 = {
  getElementRects: (r) => {
    let {
      reference: s,
      floating: o,
      strategy: c
    } = r;
    return {
      reference: Vm(s, qo(o), c),
      floating: {
        ...Da(o),
        x: 0,
        y: 0
      }
    };
  },
  convertOffsetParentRelativeRectToViewportRelativeRect: (r) => Ym(r),
  getOffsetParent: (r) => {
    let {
      element: s
    } = r;
    return qo(s);
  },
  isElement: (r) => Qr(r),
  getDocumentElement: (r) => {
    let {
      element: s
    } = r;
    return Mt(s);
  },
  getClippingClientRect: (r) => e0(r),
  getDimensions: (r) => {
    let {
      element: s
    } = r;
    return Da(s);
  },
  getClientRects: (r) => {
    let {
      element: s
    } = r;
    return s.getClientRects();
  }
}, n0 = (r, s, o) => Cm(r, s, {
  platform: t0,
  ...o
});
var r0 = Object.defineProperty, i0 = Object.defineProperties, o0 = Object.getOwnPropertyDescriptors, Na = Object.getOwnPropertySymbols, s0 = Object.prototype.hasOwnProperty, u0 = Object.prototype.propertyIsEnumerable, Ba = (r, s, o) => s in r ? r0(r, s, { enumerable: !0, configurable: !0, writable: !0, value: o }) : r[s] = o, pt = (r, s) => {
  for (var o in s || (s = {}))
    s0.call(s, o) && Ba(r, o, s[o]);
  if (Na)
    for (var o of Na(s))
      u0.call(s, o) && Ba(r, o, s[o]);
  return r;
}, jn = (r, s) => i0(r, o0(s));
function ul(r, s) {
  for (const o in s)
    Object.prototype.hasOwnProperty.call(s, o) && (typeof s[o] == "object" && r[o] ? ul(r[o], s[o]) : r[o] = s[o]);
}
const gt = {
  disabled: !1,
  distance: 5,
  skidding: 0,
  container: "body",
  boundary: void 0,
  instantMove: !1,
  disposeTimeout: 5e3,
  popperTriggers: [],
  strategy: "absolute",
  preventOverflow: !0,
  flip: !0,
  shift: !0,
  overflowPadding: 0,
  arrowPadding: 0,
  arrowOverflow: !0,
  themes: {
    tooltip: {
      placement: "top",
      triggers: ["hover", "focus", "touch"],
      hideTriggers: (r) => [...r, "click"],
      delay: {
        show: 200,
        hide: 0
      },
      handleResize: !1,
      html: !1,
      loadingContent: "..."
    },
    dropdown: {
      placement: "bottom",
      triggers: ["click"],
      delay: 0,
      handleResize: !0,
      autoHide: !0
    },
    menu: {
      $extend: "dropdown",
      triggers: ["hover", "focus"],
      popperTriggers: ["hover", "focus"],
      delay: {
        show: 0,
        hide: 400
      }
    }
  }
};
function xn(r, s) {
  let o = gt.themes[r] || {}, c;
  do
    c = o[s], typeof c > "u" ? o.$extend ? o = gt.themes[o.$extend] || {} : (o = null, c = gt[s]) : o = null;
  while (o);
  return c;
}
function a0(r) {
  const s = [r];
  let o = gt.themes[r] || {};
  do
    o.$extend && !o.$resetCss ? (s.push(o.$extend), o = gt.themes[o.$extend] || {}) : o = null;
  while (o);
  return s.map((c) => `v-popper--theme-${c}`);
}
function Ha(r) {
  const s = [r];
  let o = gt.themes[r] || {};
  do
    o.$extend ? (s.push(o.$extend), o = gt.themes[o.$extend] || {}) : o = null;
  while (o);
  return s;
}
let Jt = !1;
if (typeof window < "u") {
  Jt = !1;
  try {
    const r = Object.defineProperty({}, "passive", {
      get() {
        Jt = !0;
      }
    });
    window.addEventListener("test", null, r);
  } catch {
  }
}
let al = !1;
typeof window < "u" && typeof navigator < "u" && (al = /iPad|iPhone|iPod/.test(navigator.userAgent) && !window.MSStream);
const ll = ["auto", "top", "bottom", "left", "right"].reduce((r, s) => r.concat([
  s,
  `${s}-start`,
  `${s}-end`
]), []), Fa = {
  hover: "mouseenter",
  focus: "focus",
  click: "click",
  touch: "touchstart"
}, za = {
  hover: "mouseleave",
  focus: "blur",
  click: "click",
  touch: "touchend"
};
function Ua(r, s) {
  const o = r.indexOf(s);
  o !== -1 && r.splice(o, 1);
}
function Wo() {
  return new Promise((r) => requestAnimationFrame(() => {
    requestAnimationFrame(r);
  }));
}
const Qe = [];
let Yt = null;
const ka = {};
function qa(r) {
  let s = ka[r];
  return s || (s = ka[r] = []), s;
}
let Go = function() {
};
typeof window < "u" && (Go = window.Element);
function Z(r) {
  return function(s) {
    return xn(s.theme, r);
  };
}
const No = "__floating-vue__popper";
var fl = () => Qt({
  name: "VPopper",
  provide() {
    return {
      [No]: {
        parentPopper: this
      }
    };
  },
  inject: {
    [No]: { default: null }
  },
  props: {
    theme: {
      type: String,
      required: !0
    },
    targetNodes: {
      type: Function,
      required: !0
    },
    referenceNode: {
      type: Function,
      default: null
    },
    popperNode: {
      type: Function,
      required: !0
    },
    shown: {
      type: Boolean,
      default: !1
    },
    showGroup: {
      type: String,
      default: null
    },
    ariaId: {
      default: null
    },
    disabled: {
      type: Boolean,
      default: Z("disabled")
    },
    positioningDisabled: {
      type: Boolean,
      default: Z("positioningDisabled")
    },
    placement: {
      type: String,
      default: Z("placement"),
      validator: (r) => ll.includes(r)
    },
    delay: {
      type: [String, Number, Object],
      default: Z("delay")
    },
    distance: {
      type: [Number, String],
      default: Z("distance")
    },
    skidding: {
      type: [Number, String],
      default: Z("skidding")
    },
    triggers: {
      type: Array,
      default: Z("triggers")
    },
    showTriggers: {
      type: [Array, Function],
      default: Z("showTriggers")
    },
    hideTriggers: {
      type: [Array, Function],
      default: Z("hideTriggers")
    },
    popperTriggers: {
      type: Array,
      default: Z("popperTriggers")
    },
    popperShowTriggers: {
      type: [Array, Function],
      default: Z("popperShowTriggers")
    },
    popperHideTriggers: {
      type: [Array, Function],
      default: Z("popperHideTriggers")
    },
    container: {
      type: [String, Object, Go, Boolean],
      default: Z("container")
    },
    boundary: {
      type: [String, Go],
      default: Z("boundary")
    },
    strategy: {
      type: String,
      validator: (r) => ["absolute", "fixed"].includes(r),
      default: Z("strategy")
    },
    autoHide: {
      type: [Boolean, Function],
      default: Z("autoHide")
    },
    handleResize: {
      type: Boolean,
      default: Z("handleResize")
    },
    instantMove: {
      type: Boolean,
      default: Z("instantMove")
    },
    eagerMount: {
      type: Boolean,
      default: Z("eagerMount")
    },
    popperClass: {
      type: [String, Array, Object],
      default: Z("popperClass")
    },
    computeTransformOrigin: {
      type: Boolean,
      default: Z("computeTransformOrigin")
    },
    autoMinSize: {
      type: Boolean,
      default: Z("autoMinSize")
    },
    autoSize: {
      type: [Boolean, String],
      default: Z("autoSize")
    },
    autoMaxSize: {
      type: Boolean,
      default: Z("autoMaxSize")
    },
    autoBoundaryMaxSize: {
      type: Boolean,
      default: Z("autoBoundaryMaxSize")
    },
    preventOverflow: {
      type: Boolean,
      default: Z("preventOverflow")
    },
    overflowPadding: {
      type: [Number, String],
      default: Z("overflowPadding")
    },
    arrowPadding: {
      type: [Number, String],
      default: Z("arrowPadding")
    },
    arrowOverflow: {
      type: Boolean,
      default: Z("arrowOverflow")
    },
    flip: {
      type: Boolean,
      default: Z("flip")
    },
    shift: {
      type: Boolean,
      default: Z("shift")
    },
    shiftCrossAxis: {
      type: Boolean,
      default: Z("shiftCrossAxis")
    },
    noAutoFocus: {
      type: Boolean,
      default: Z("noAutoFocus")
    }
  },
  emits: [
    "show",
    "hide",
    "update:shown",
    "apply-show",
    "apply-hide",
    "close-group",
    "close-directive",
    "auto-hide",
    "resize",
    "dispose"
  ],
  data() {
    return {
      isShown: !1,
      isMounted: !1,
      skipTransition: !1,
      classes: {
        showFrom: !1,
        showTo: !1,
        hideFrom: !1,
        hideTo: !0
      },
      result: {
        x: 0,
        y: 0,
        placement: "",
        strategy: this.strategy,
        arrow: {
          x: 0,
          y: 0,
          centerOffset: 0
        },
        transformOrigin: null
      },
      shownChildren: /* @__PURE__ */ new Set(),
      lastAutoHide: !0
    };
  },
  computed: {
    popperId() {
      return this.ariaId != null ? this.ariaId : this.randomId;
    },
    shouldMountContent() {
      return this.eagerMount || this.isMounted;
    },
    slotData() {
      return {
        popperId: this.popperId,
        isShown: this.isShown,
        shouldMountContent: this.shouldMountContent,
        skipTransition: this.skipTransition,
        autoHide: typeof this.autoHide == "function" ? this.lastAutoHide : this.autoHide,
        show: this.show,
        hide: this.hide,
        handleResize: this.handleResize,
        onResize: this.onResize,
        classes: jn(pt({}, this.classes), {
          popperClass: this.popperClass
        }),
        result: this.positioningDisabled ? null : this.result,
        attrs: this.$attrs
      };
    },
    parentPopper() {
      var r;
      return (r = this[No]) == null ? void 0 : r.parentPopper;
    },
    hasPopperShowTriggerHover() {
      var r, s;
      return ((r = this.popperTriggers) == null ? void 0 : r.includes("hover")) || ((s = this.popperShowTriggers) == null ? void 0 : s.includes("hover"));
    }
  },
  watch: pt(pt({
    shown: "$_autoShowHide",
    disabled(r) {
      r ? this.dispose() : this.init();
    },
    async container() {
      this.isShown && (this.$_ensureTeleport(), await this.$_computePosition());
    }
  }, [
    "triggers",
    "positioningDisabled"
  ].reduce((r, s) => (r[s] = "$_refreshListeners", r), {})), [
    "placement",
    "distance",
    "skidding",
    "boundary",
    "strategy",
    "overflowPadding",
    "arrowPadding",
    "preventOverflow",
    "shift",
    "shiftCrossAxis",
    "flip"
  ].reduce((r, s) => (r[s] = "$_computePosition", r), {})),
  created() {
    this.$_isDisposed = !0, this.randomId = `popper_${[Math.random(), Date.now()].map((r) => r.toString(36).substring(2, 10)).join("_")}`, this.autoMinSize && console.warn('[floating-vue] `autoMinSize` option is deprecated. Use `autoSize="min"` instead.'), this.autoMaxSize && console.warn("[floating-vue] `autoMaxSize` option is deprecated. Use `autoBoundaryMaxSize` instead.");
  },
  mounted() {
    this.init(), this.$_detachPopperNode();
  },
  activated() {
    this.$_autoShowHide();
  },
  deactivated() {
    this.hide();
  },
  beforeUnmount() {
    this.dispose();
  },
  methods: {
    show({ event: r = null, skipDelay: s = !1, force: o = !1 } = {}) {
      var c, d;
      ((c = this.parentPopper) == null ? void 0 : c.lockedChild) && this.parentPopper.lockedChild !== this || (this.$_pendingHide = !1, (o || !this.disabled) && (((d = this.parentPopper) == null ? void 0 : d.lockedChild) === this && (this.parentPopper.lockedChild = null), this.$_scheduleShow(r, s), this.$emit("show"), this.$_showFrameLocked = !0, requestAnimationFrame(() => {
        this.$_showFrameLocked = !1;
      })), this.$emit("update:shown", !0));
    },
    hide({ event: r = null, skipDelay: s = !1 } = {}) {
      var o;
      if (!this.$_hideInProgress) {
        if (this.shownChildren.size > 0) {
          this.$_pendingHide = !0;
          return;
        }
        if (this.hasPopperShowTriggerHover && this.$_isAimingPopper()) {
          this.parentPopper && (this.parentPopper.lockedChild = this, clearTimeout(this.parentPopper.lockedChildTimer), this.parentPopper.lockedChildTimer = setTimeout(() => {
            this.parentPopper.lockedChild === this && (this.parentPopper.lockedChild.hide({ skipDelay: s }), this.parentPopper.lockedChild = null);
          }, 1e3));
          return;
        }
        ((o = this.parentPopper) == null ? void 0 : o.lockedChild) === this && (this.parentPopper.lockedChild = null), this.$_pendingHide = !1, this.$_scheduleHide(r, s), this.$emit("hide"), this.$emit("update:shown", !1);
      }
    },
    init() {
      var r, s;
      !this.$_isDisposed || (this.$_isDisposed = !1, this.isMounted = !1, this.$_events = [], this.$_preventShow = !1, this.$_referenceNode = (s = (r = this.referenceNode) == null ? void 0 : r.call(this)) != null ? s : this.$el, this.$_targetNodes = this.targetNodes().filter((o) => o.nodeType === o.ELEMENT_NODE), this.$_popperNode = this.popperNode(), this.$_innerNode = this.$_popperNode.querySelector(".v-popper__inner"), this.$_arrowNode = this.$_popperNode.querySelector(".v-popper__arrow-container"), this.$_swapTargetAttrs("title", "data-original-title"), this.$_detachPopperNode(), this.triggers.length && this.$_addEventListeners(), this.shown && this.show());
    },
    dispose() {
      this.$_isDisposed || (this.$_isDisposed = !0, this.$_removeEventListeners(), this.hide({ skipDelay: !0 }), this.$_detachPopperNode(), this.isMounted = !1, this.isShown = !1, this.$_updateParentShownChildren(!1), this.$_swapTargetAttrs("data-original-title", "title"), this.$emit("dispose"));
    },
    async onResize() {
      this.isShown && (await this.$_computePosition(), this.$emit("resize"));
    },
    async $_computePosition() {
      var r;
      if (this.$_isDisposed || this.positioningDisabled)
        return;
      const s = {
        strategy: this.strategy,
        middleware: []
      };
      (this.distance || this.skidding) && s.middleware.push(Hm({
        mainAxis: this.distance,
        crossAxis: this.skidding
      }));
      const o = this.placement.startsWith("auto");
      if (o ? s.middleware.push(Dm({
        alignment: (r = this.placement.split("-")[1]) != null ? r : ""
      })) : s.placement = this.placement, this.preventOverflow && (this.shift && s.middleware.push(zm({
        padding: this.overflowPadding,
        boundary: this.boundary,
        crossAxis: this.shiftCrossAxis
      })), !o && this.flip && s.middleware.push(Nm({
        padding: this.overflowPadding,
        boundary: this.boundary
      }))), s.middleware.push(Em({
        element: this.$_arrowNode,
        padding: this.arrowPadding
      })), this.arrowOverflow && s.middleware.push({
        name: "arrowOverflow",
        fn: ({ placement: d, rects: _, middlewareData: m }) => {
          let w;
          const { centerOffset: $ } = m.arrow;
          return d.startsWith("top") || d.startsWith("bottom") ? w = Math.abs($) > _.reference.width / 2 : w = Math.abs($) > _.reference.height / 2, {
            data: {
              overflow: w
            }
          };
        }
      }), this.autoMinSize || this.autoSize) {
        const d = this.autoSize ? this.autoSize : this.autoMinSize ? "min" : null;
        s.middleware.push({
          name: "autoSize",
          fn: ({ rects: _, placement: m, middlewareData: w }) => {
            var $;
            if (($ = w.autoSize) != null && $.skip)
              return {};
            let L, C;
            return m.startsWith("top") || m.startsWith("bottom") ? L = _.reference.width : C = _.reference.height, this.$_innerNode.style[d === "min" ? "minWidth" : d === "max" ? "maxWidth" : "width"] = L != null ? `${L}px` : null, this.$_innerNode.style[d === "min" ? "minHeight" : d === "max" ? "maxHeight" : "height"] = C != null ? `${C}px` : null, {
              data: {
                skip: !0
              },
              reset: {
                rects: !0
              }
            };
          }
        });
      }
      (this.autoMaxSize || this.autoBoundaryMaxSize) && (this.$_innerNode.style.maxWidth = null, this.$_innerNode.style.maxHeight = null, s.middleware.push(Um({
        boundary: this.boundary,
        padding: this.overflowPadding,
        apply: ({ width: d, height: _ }) => {
          this.$_innerNode.style.maxWidth = d != null ? `${d}px` : null, this.$_innerNode.style.maxHeight = _ != null ? `${_}px` : null;
        }
      })));
      const c = await n0(this.$_referenceNode, this.$_popperNode, s);
      Object.assign(this.result, {
        x: c.x,
        y: c.y,
        placement: c.placement,
        strategy: c.strategy,
        arrow: pt(pt({}, c.middlewareData.arrow), c.middlewareData.arrowOverflow)
      });
    },
    $_scheduleShow(r = null, s = !1) {
      if (this.$_updateParentShownChildren(!0), this.$_hideInProgress = !1, clearTimeout(this.$_scheduleTimer), Yt && this.instantMove && Yt.instantMove && Yt !== this.parentPopper) {
        Yt.$_applyHide(!0), this.$_applyShow(!0);
        return;
      }
      s ? this.$_applyShow() : this.$_scheduleTimer = setTimeout(this.$_applyShow.bind(this), this.$_computeDelay("show"));
    },
    $_scheduleHide(r = null, s = !1) {
      if (this.shownChildren.size > 0) {
        this.$_pendingHide = !0;
        return;
      }
      this.$_updateParentShownChildren(!1), this.$_hideInProgress = !0, clearTimeout(this.$_scheduleTimer), this.isShown && (Yt = this), s ? this.$_applyHide() : this.$_scheduleTimer = setTimeout(this.$_applyHide.bind(this), this.$_computeDelay("hide"));
    },
    $_computeDelay(r) {
      const s = this.delay;
      return parseInt(s && s[r] || s || 0);
    },
    async $_applyShow(r = !1) {
      clearTimeout(this.$_disposeTimer), clearTimeout(this.$_scheduleTimer), this.skipTransition = r, !this.isShown && (this.$_ensureTeleport(), await Wo(), await this.$_computePosition(), await this.$_applyShowEffect(), this.positioningDisabled || this.$_registerEventListeners([
        ...ei(this.$_referenceNode),
        ...ei(this.$_popperNode)
      ], "scroll", () => {
        this.$_computePosition();
      }));
    },
    async $_applyShowEffect() {
      if (this.$_hideInProgress)
        return;
      if (this.computeTransformOrigin) {
        const s = this.$_referenceNode.getBoundingClientRect(), o = this.$_popperNode.querySelector(".v-popper__wrapper"), c = o.parentNode.getBoundingClientRect(), d = s.x + s.width / 2 - (c.left + o.offsetLeft), _ = s.y + s.height / 2 - (c.top + o.offsetTop);
        this.result.transformOrigin = `${d}px ${_}px`;
      }
      this.isShown = !0, this.$_applyAttrsToTarget({
        "aria-describedby": this.popperId,
        "data-popper-shown": ""
      });
      const r = this.showGroup;
      if (r) {
        let s;
        for (let o = 0; o < Qe.length; o++)
          s = Qe[o], s.showGroup !== r && (s.hide(), s.$emit("close-group"));
      }
      Qe.push(this), document.body.classList.add("v-popper--some-open");
      for (const s of Ha(this.theme))
        qa(s).push(this), document.body.classList.add(`v-popper--some-open--${s}`);
      this.$emit("apply-show"), this.classes.showFrom = !0, this.classes.showTo = !1, this.classes.hideFrom = !1, this.classes.hideTo = !1, await Wo(), this.classes.showFrom = !1, this.classes.showTo = !0, this.noAutoFocus || this.$_popperNode.focus();
    },
    async $_applyHide(r = !1) {
      if (this.shownChildren.size > 0) {
        this.$_pendingHide = !0, this.$_hideInProgress = !1;
        return;
      }
      if (clearTimeout(this.$_scheduleTimer), !this.isShown)
        return;
      this.skipTransition = r, Ua(Qe, this), Qe.length === 0 && document.body.classList.remove("v-popper--some-open");
      for (const o of Ha(this.theme)) {
        const c = qa(o);
        Ua(c, this), c.length === 0 && document.body.classList.remove(`v-popper--some-open--${o}`);
      }
      Yt === this && (Yt = null), this.isShown = !1, this.$_applyAttrsToTarget({
        "aria-describedby": void 0,
        "data-popper-shown": void 0
      }), clearTimeout(this.$_disposeTimer);
      const s = xn(this.theme, "disposeTimeout");
      s !== null && (this.$_disposeTimer = setTimeout(() => {
        this.$_popperNode && (this.$_detachPopperNode(), this.isMounted = !1);
      }, s)), this.$_removeEventListeners("scroll"), this.$emit("apply-hide"), this.classes.showFrom = !1, this.classes.showTo = !1, this.classes.hideFrom = !0, this.classes.hideTo = !1, await Wo(), this.classes.hideFrom = !1, this.classes.hideTo = !0;
    },
    $_autoShowHide() {
      this.shown ? this.show() : this.hide();
    },
    $_ensureTeleport() {
      if (this.$_isDisposed)
        return;
      let r = this.container;
      if (typeof r == "string" ? r = window.document.querySelector(r) : r === !1 && (r = this.$_targetNodes[0].parentNode), !r)
        throw new Error("No container for popover: " + this.container);
      r.appendChild(this.$_popperNode), this.isMounted = !0;
    },
    $_addEventListeners() {
      const r = (o) => {
        this.isShown && !this.$_hideInProgress || (o.usedByTooltip = !0, !this.$_preventShow && this.show({ event: o }));
      };
      this.$_registerTriggerListeners(this.$_targetNodes, Fa, this.triggers, this.showTriggers, r), this.$_registerTriggerListeners([this.$_popperNode], Fa, this.popperTriggers, this.popperShowTriggers, r);
      const s = (o) => {
        o.usedByTooltip || this.hide({ event: o });
      };
      this.$_registerTriggerListeners(this.$_targetNodes, za, this.triggers, this.hideTriggers, s), this.$_registerTriggerListeners([this.$_popperNode], za, this.popperTriggers, this.popperHideTriggers, s);
    },
    $_registerEventListeners(r, s, o) {
      this.$_events.push({ targetNodes: r, eventType: s, handler: o }), r.forEach((c) => c.addEventListener(s, o, Jt ? {
        passive: !0
      } : void 0));
    },
    $_registerTriggerListeners(r, s, o, c, d) {
      let _ = o;
      c != null && (_ = typeof c == "function" ? c(_) : c), _.forEach((m) => {
        const w = s[m];
        w && this.$_registerEventListeners(r, w, d);
      });
    },
    $_removeEventListeners(r) {
      const s = [];
      this.$_events.forEach((o) => {
        const { targetNodes: c, eventType: d, handler: _ } = o;
        !r || r === d ? c.forEach((m) => m.removeEventListener(d, _)) : s.push(o);
      }), this.$_events = s;
    },
    $_refreshListeners() {
      this.$_isDisposed || (this.$_removeEventListeners(), this.$_addEventListeners());
    },
    $_handleGlobalClose(r, s = !1) {
      this.$_showFrameLocked || (this.hide({ event: r }), r.closePopover ? this.$emit("close-directive") : this.$emit("auto-hide"), s && (this.$_preventShow = !0, setTimeout(() => {
        this.$_preventShow = !1;
      }, 300)));
    },
    $_detachPopperNode() {
      this.$_popperNode.parentNode && this.$_popperNode.parentNode.removeChild(this.$_popperNode);
    },
    $_swapTargetAttrs(r, s) {
      for (const o of this.$_targetNodes) {
        const c = o.getAttribute(r);
        c && (o.removeAttribute(r), o.setAttribute(s, c));
      }
    },
    $_applyAttrsToTarget(r) {
      for (const s of this.$_targetNodes)
        for (const o in r) {
          const c = r[o];
          c == null ? s.removeAttribute(o) : s.setAttribute(o, c);
        }
    },
    $_updateParentShownChildren(r) {
      let s = this.parentPopper;
      for (; s; )
        r ? s.shownChildren.add(this.randomId) : (s.shownChildren.delete(this.randomId), s.$_pendingHide && s.hide()), s = s.parentPopper;
    },
    $_isAimingPopper() {
      const r = this.$_referenceNode.getBoundingClientRect();
      if (Kn >= r.left && Kn <= r.right && Yn >= r.top && Yn <= r.bottom) {
        const s = this.$_popperNode.getBoundingClientRect(), o = Kn - Ot, c = Yn - Lt, _ = s.left + s.width / 2 - Ot + (s.top + s.height / 2) - Lt + s.width + s.height, m = Ot + o * _, w = Lt + c * _;
        return Yr(Ot, Lt, m, w, s.left, s.top, s.left, s.bottom) || Yr(Ot, Lt, m, w, s.left, s.top, s.right, s.top) || Yr(Ot, Lt, m, w, s.right, s.top, s.right, s.bottom) || Yr(Ot, Lt, m, w, s.left, s.bottom, s.right, s.bottom);
      }
      return !1;
    }
  },
  render() {
    return this.$slots.default(this.slotData);
  }
});
typeof document < "u" && typeof window < "u" && (al ? (document.addEventListener("touchstart", Ga, Jt ? {
  passive: !0,
  capture: !0
} : !0), document.addEventListener("touchend", f0, Jt ? {
  passive: !0,
  capture: !0
} : !0)) : (window.addEventListener("mousedown", Ga, !0), window.addEventListener("click", l0, !0)), window.addEventListener("resize", d0));
function Ga(r) {
  for (let s = 0; s < Qe.length; s++) {
    const o = Qe[s];
    try {
      const c = o.popperNode();
      o.$_mouseDownContains = c.contains(r.target);
    } catch {
    }
  }
}
function l0(r) {
  cl(r);
}
function f0(r) {
  cl(r, !0);
}
function cl(r, s = !1) {
  const o = {};
  for (let c = Qe.length - 1; c >= 0; c--) {
    const d = Qe[c];
    try {
      const _ = d.$_containsGlobalTarget = c0(d, r);
      d.$_pendingHide = !1, requestAnimationFrame(() => {
        if (d.$_pendingHide = !1, !o[d.randomId] && Va(d, _, r)) {
          if (d.$_handleGlobalClose(r, s), !r.closeAllPopover && r.closePopover && _) {
            let w = d.parentPopper;
            for (; w; )
              o[w.randomId] = !0, w = w.parentPopper;
            return;
          }
          let m = d.parentPopper;
          for (; m && Va(m, m.$_containsGlobalTarget, r); ) {
            m.$_handleGlobalClose(r, s);
            m = m.parentPopper;
          }
        }
      });
    } catch {
    }
  }
}
function c0(r, s) {
  const o = r.popperNode();
  return r.$_mouseDownContains || o.contains(s.target);
}
function Va(r, s, o) {
  return o.closeAllPopover || o.closePopover && s || h0(r, o) && !s;
}
function h0(r, s) {
  if (typeof r.autoHide == "function") {
    const o = r.autoHide(s);
    return r.lastAutoHide = o, o;
  }
  return r.autoHide;
}
function d0(r) {
  for (let s = 0; s < Qe.length; s++)
    Qe[s].$_computePosition(r);
}
let Ot = 0, Lt = 0, Kn = 0, Yn = 0;
typeof window < "u" && window.addEventListener("mousemove", (r) => {
  Ot = Kn, Lt = Yn, Kn = r.clientX, Yn = r.clientY;
}, Jt ? {
  passive: !0
} : void 0);
function Yr(r, s, o, c, d, _, m, w) {
  const $ = ((m - d) * (s - _) - (w - _) * (r - d)) / ((w - _) * (o - r) - (m - d) * (c - s)), L = ((o - r) * (s - _) - (c - s) * (r - d)) / ((w - _) * (o - r) - (m - d) * (c - s));
  return $ >= 0 && $ <= 1 && L >= 0 && L <= 1;
}
var li = (r, s) => {
  const o = r.__vccOpts || r;
  for (const [c, d] of s)
    o[c] = d;
  return o;
};
const p0 = {
  extends: fl()
};
function g0(r, s, o, c, d, _) {
  return K(), J("div", {
    ref: "reference",
    class: Jn(["v-popper", {
      "v-popper--shown": r.slotData.isShown
    }])
  }, [
    wn(r.$slots, "default", yv(xv(r.slotData)))
  ], 2);
}
var _0 = /* @__PURE__ */ li(p0, [["render", g0]]);
function v0() {
  var r = window.navigator.userAgent, s = r.indexOf("MSIE ");
  if (s > 0)
    return parseInt(r.substring(s + 5, r.indexOf(".", s)), 10);
  var o = r.indexOf("Trident/");
  if (o > 0) {
    var c = r.indexOf("rv:");
    return parseInt(r.substring(c + 3, r.indexOf(".", c)), 10);
  }
  var d = r.indexOf("Edge/");
  return d > 0 ? parseInt(r.substring(d + 5, r.indexOf(".", d)), 10) : -1;
}
let Xr;
function Vo() {
  Vo.init || (Vo.init = !0, Xr = v0() !== -1);
}
var fi = {
  name: "ResizeObserver",
  props: {
    emitOnMount: {
      type: Boolean,
      default: !1
    },
    ignoreWidth: {
      type: Boolean,
      default: !1
    },
    ignoreHeight: {
      type: Boolean,
      default: !1
    }
  },
  emits: [
    "notify"
  ],
  mounted() {
    Vo(), wv(() => {
      this._w = this.$el.offsetWidth, this._h = this.$el.offsetHeight, this.emitOnMount && this.emitSize();
    });
    const r = document.createElement("object");
    this._resizeObject = r, r.setAttribute("aria-hidden", "true"), r.setAttribute("tabindex", -1), r.onload = this.addResizeHandlers, r.type = "text/html", Xr && this.$el.appendChild(r), r.data = "about:blank", Xr || this.$el.appendChild(r);
  },
  beforeUnmount() {
    this.removeResizeHandlers();
  },
  methods: {
    compareAndNotify() {
      (!this.ignoreWidth && this._w !== this.$el.offsetWidth || !this.ignoreHeight && this._h !== this.$el.offsetHeight) && (this._w = this.$el.offsetWidth, this._h = this.$el.offsetHeight, this.emitSize());
    },
    emitSize() {
      this.$emit("notify", {
        width: this._w,
        height: this._h
      });
    },
    addResizeHandlers() {
      this._resizeObject.contentDocument.defaultView.addEventListener("resize", this.compareAndNotify), this.compareAndNotify();
    },
    removeResizeHandlers() {
      this._resizeObject && this._resizeObject.onload && (!Xr && this._resizeObject.contentDocument && this._resizeObject.contentDocument.defaultView.removeEventListener("resize", this.compareAndNotify), this.$el.removeChild(this._resizeObject), this._resizeObject.onload = null, this._resizeObject = null);
    }
  }
};
const m0 = /* @__PURE__ */ bv("data-v-b329ee4c");
vv("data-v-b329ee4c");
const w0 = {
  class: "resize-observer",
  tabindex: "-1"
};
mv();
const y0 = /* @__PURE__ */ m0((r, s, o, c, d, _) => (K(), ni("div", w0)));
fi.render = y0;
fi.__scopeId = "data-v-b329ee4c";
fi.__file = "src/components/ResizeObserver.vue";
var hl = (r = "theme") => ({
  computed: {
    themeClass() {
      return a0(this[r]);
    }
  }
});
const x0 = Qt({
  name: "VPopperContent",
  components: {
    ResizeObserver: fi
  },
  mixins: [
    hl()
  ],
  props: {
    popperId: String,
    theme: String,
    shown: Boolean,
    mounted: Boolean,
    skipTransition: Boolean,
    autoHide: Boolean,
    handleResize: Boolean,
    classes: Object,
    result: Object
  },
  emits: [
    "hide",
    "resize"
  ],
  methods: {
    toPx(r) {
      return r != null && !isNaN(r) ? `${r}px` : null;
    }
  }
}), b0 = ["id", "aria-hidden", "tabindex", "data-popper-placement"], T0 = {
  ref: "inner",
  class: "v-popper__inner"
}, $0 = /* @__PURE__ */ Ce("div", { class: "v-popper__arrow-outer" }, null, -1), A0 = /* @__PURE__ */ Ce("div", { class: "v-popper__arrow-inner" }, null, -1), C0 = [
  $0,
  A0
];
function S0(r, s, o, c, d, _) {
  const m = Xn("ResizeObserver");
  return K(), J("div", {
    id: r.popperId,
    ref: "popover",
    class: Jn(["v-popper__popper", [
      r.themeClass,
      r.classes.popperClass,
      {
        "v-popper__popper--shown": r.shown,
        "v-popper__popper--hidden": !r.shown,
        "v-popper__popper--show-from": r.classes.showFrom,
        "v-popper__popper--show-to": r.classes.showTo,
        "v-popper__popper--hide-from": r.classes.hideFrom,
        "v-popper__popper--hide-to": r.classes.hideTo,
        "v-popper__popper--skip-transition": r.skipTransition,
        "v-popper__popper--arrow-overflow": r.result && r.result.arrow.overflow,
        "v-popper__popper--no-positioning": !r.result
      }
    ]]),
    style: Ro(r.result ? {
      position: r.result.strategy,
      transform: `translate3d(${Math.round(r.result.x)}px,${Math.round(r.result.y)}px,0)`
    } : void 0),
    "aria-hidden": r.shown ? "false" : "true",
    tabindex: r.autoHide ? 0 : void 0,
    "data-popper-placement": r.result ? r.result.placement : void 0,
    onKeyup: s[2] || (s[2] = Tv((w) => r.autoHide && r.$emit("hide"), ["esc"]))
  }, [
    Ce("div", {
      class: "v-popper__backdrop",
      onClick: s[0] || (s[0] = (w) => r.autoHide && r.$emit("hide"))
    }),
    Ce("div", {
      class: "v-popper__wrapper",
      style: Ro(r.result ? {
        transformOrigin: r.result.transformOrigin
      } : void 0)
    }, [
      Ce("div", T0, [
        r.mounted ? (K(), J(Zt, { key: 0 }, [
          Ce("div", null, [
            wn(r.$slots, "default")
          ]),
          r.handleResize ? (K(), ni(m, {
            key: 0,
            onNotify: s[1] || (s[1] = (w) => r.$emit("resize", w))
          })) : je("", !0)
        ], 64)) : je("", !0)
      ], 512),
      Ce("div", {
        ref: "arrow",
        class: "v-popper__arrow-container",
        style: Ro(r.result ? {
          left: r.toPx(r.result.arrow.x),
          top: r.toPx(r.result.arrow.y)
        } : void 0)
      }, C0, 4)
    ], 4)
  ], 46, b0);
}
var dl = /* @__PURE__ */ li(x0, [["render", S0]]), pl = {
  methods: {
    show(...r) {
      return this.$refs.popper.show(...r);
    },
    hide(...r) {
      return this.$refs.popper.hide(...r);
    },
    dispose(...r) {
      return this.$refs.popper.dispose(...r);
    },
    onResize(...r) {
      return this.$refs.popper.onResize(...r);
    }
  }
};
const P0 = Qt({
  name: "VPopperWrapper",
  components: {
    Popper: _0,
    PopperContent: dl
  },
  mixins: [
    pl,
    hl("finalTheme")
  ],
  props: {
    theme: {
      type: String,
      default: null
    }
  },
  computed: {
    finalTheme() {
      var r;
      return (r = this.theme) != null ? r : this.$options.vPopperTheme;
    }
  },
  methods: {
    getTargetNodes() {
      return Array.from(this.$el.children).filter((r) => r !== this.$refs.popperContent.$el);
    }
  }
});
function E0(r, s, o, c, d, _) {
  const m = Xn("PopperContent"), w = Xn("Popper");
  return K(), ni(w, {
    ref: "popper",
    theme: r.finalTheme,
    "target-nodes": r.getTargetNodes,
    "popper-node": () => r.$refs.popperContent.$el,
    class: Jn([
      r.themeClass
    ])
  }, {
    default: Zr(({
      popperId: $,
      isShown: L,
      shouldMountContent: C,
      skipTransition: E,
      autoHide: O,
      show: D,
      hide: U,
      handleResize: Q,
      onResize: N,
      classes: G,
      result: F
    }) => [
      wn(r.$slots, "default", {
        shown: L,
        show: D,
        hide: U
      }),
      Za(m, {
        ref: "popperContent",
        "popper-id": $,
        theme: r.finalTheme,
        shown: L,
        mounted: C,
        "skip-transition": E,
        "auto-hide": O,
        "handle-resize": Q,
        classes: G,
        result: F,
        onHide: U,
        onResize: N
      }, {
        default: Zr(() => [
          wn(r.$slots, "popper", {
            shown: L,
            hide: U
          })
        ]),
        _: 2
      }, 1032, ["popper-id", "theme", "shown", "mounted", "skip-transition", "auto-hide", "handle-resize", "classes", "result", "onHide", "onResize"])
    ]),
    _: 3
  }, 8, ["theme", "target-nodes", "popper-node", "class"]);
}
var Jo = /* @__PURE__ */ li(P0, [["render", E0]]);
const O0 = Qt(jn(pt({}, Jo), {
  name: "VDropdown",
  vPopperTheme: "dropdown"
})), L0 = Qt(jn(pt({}, Jo), {
  name: "VMenu",
  vPopperTheme: "menu"
})), I0 = Qt(jn(pt({}, Jo), {
  name: "VTooltip",
  vPopperTheme: "tooltip"
})), R0 = Qt({
  name: "VTooltipDirective",
  components: {
    Popper: fl(),
    PopperContent: dl
  },
  mixins: [
    pl
  ],
  inheritAttrs: !1,
  props: {
    theme: {
      type: String,
      default: "tooltip"
    },
    html: {
      type: Boolean,
      default: (r) => xn(r.theme, "html")
    },
    content: {
      type: [String, Number, Function],
      default: null
    },
    loadingContent: {
      type: String,
      default: (r) => xn(r.theme, "loadingContent")
    }
  },
  data() {
    return {
      asyncContent: null
    };
  },
  computed: {
    isContentAsync() {
      return typeof this.content == "function";
    },
    loading() {
      return this.isContentAsync && this.asyncContent == null;
    },
    finalContent() {
      return this.isContentAsync ? this.loading ? this.loadingContent : this.asyncContent : this.content;
    }
  },
  watch: {
    content: {
      handler() {
        this.fetchContent(!0);
      },
      immediate: !0
    },
    async finalContent() {
      await this.$nextTick(), this.$refs.popper.onResize();
    }
  },
  created() {
    this.$_fetchId = 0;
  },
  methods: {
    fetchContent(r) {
      if (typeof this.content == "function" && this.$_isShown && (r || !this.$_loading && this.asyncContent == null)) {
        this.asyncContent = null, this.$_loading = !0;
        const s = ++this.$_fetchId, o = this.content(this);
        o.then ? o.then((c) => this.onResult(s, c)) : this.onResult(s, o);
      }
    },
    onResult(r, s) {
      r === this.$_fetchId && (this.$_loading = !1, this.asyncContent = s);
    },
    onShow() {
      this.$_isShown = !0, this.fetchContent();
    },
    onHide() {
      this.$_isShown = !1;
    }
  }
}), M0 = ["innerHTML"], D0 = ["textContent"];
function W0(r, s, o, c, d, _) {
  const m = Xn("PopperContent"), w = Xn("Popper");
  return K(), ni(w, It({ ref: "popper" }, r.$attrs, {
    theme: r.theme,
    "popper-node": () => r.$refs.popperContent.$el,
    onApplyShow: r.onShow,
    onApplyHide: r.onHide
  }), {
    default: Zr(({
      popperId: $,
      isShown: L,
      shouldMountContent: C,
      skipTransition: E,
      autoHide: O,
      hide: D,
      handleResize: U,
      onResize: Q,
      classes: N,
      result: G
    }) => [
      Za(m, {
        ref: "popperContent",
        class: Jn({
          "v-popper--tooltip-loading": r.loading
        }),
        "popper-id": $,
        theme: r.theme,
        shown: L,
        mounted: C,
        "skip-transition": E,
        "auto-hide": O,
        "handle-resize": U,
        classes: N,
        result: G,
        onHide: D,
        onResize: Q
      }, {
        default: Zr(() => [
          r.html ? (K(), J("div", {
            key: 0,
            innerHTML: r.finalContent
          }, null, 8, M0)) : (K(), J("div", {
            key: 1,
            textContent: Cv(r.finalContent)
          }, null, 8, D0))
        ]),
        _: 2
      }, 1032, ["class", "popper-id", "theme", "shown", "mounted", "skip-transition", "auto-hide", "handle-resize", "classes", "result", "onHide", "onResize"])
    ]),
    _: 1
  }, 16, ["theme", "popper-node", "onApplyShow", "onApplyHide"]);
}
var N0 = /* @__PURE__ */ li(R0, [["render", W0]]);
const gl = "v-popper--has-tooltip";
function B0(r, s) {
  let o = r.placement;
  if (!o && s)
    for (const c of ll)
      s[c] && (o = c);
  return o || (o = xn(r.theme || "tooltip", "placement")), o;
}
function _l(r, s, o) {
  let c;
  const d = typeof s;
  return d === "string" ? c = { content: s } : s && d === "object" ? c = s : c = { content: !1 }, c.placement = B0(c, o), c.targetNodes = () => [r], c.referenceNode = () => r, c;
}
let Bo, Zn, H0 = 0;
function F0() {
  if (Bo)
    return;
  Zn = Ho([]), Bo = $v({
    name: "VTooltipDirectiveApp",
    setup() {
      return {
        directives: Zn
      };
    },
    render() {
      return this.directives.map((s) => Av(N0, jn(pt({}, s.options), {
        shown: s.shown || s.options.shown,
        key: s.id
      })));
    },
    devtools: {
      hide: !0
    }
  });
  const r = document.createElement("div");
  document.body.appendChild(r), Bo.mount(r);
}
function z0(r, s, o) {
  F0();
  const c = Ho(_l(r, s, o)), d = Ho(!1), _ = {
    id: H0++,
    options: c,
    shown: d
  };
  return Zn.value.push(_), r.classList && r.classList.add(gl), r.$_popper = {
    options: c,
    item: _,
    show() {
      d.value = !0;
    },
    hide() {
      d.value = !1;
    }
  };
}
function vl(r) {
  if (r.$_popper) {
    const s = Zn.value.indexOf(r.$_popper.item);
    s !== -1 && Zn.value.splice(s, 1), delete r.$_popper, delete r.$_popperOldShown, delete r.$_popperMountTarget;
  }
  r.classList && r.classList.remove(gl);
}
function Ka(r, { value: s, modifiers: o }) {
  const c = _l(r, s, o);
  if (!c.content || xn(c.theme || "tooltip", "disabled"))
    vl(r);
  else {
    let d;
    r.$_popper ? (d = r.$_popper, d.options.value = c) : d = z0(r, s, o), typeof s.shown < "u" && s.shown !== r.$_popperOldShown && (r.$_popperOldShown = s.shown, s.shown ? d.show() : d.hide());
  }
}
var U0 = {
  beforeMount: Ka,
  updated: Ka,
  beforeUnmount(r) {
    vl(r);
  }
};
function Ya(r) {
  r.addEventListener("click", ml), r.addEventListener("touchstart", wl, Jt ? {
    passive: !0
  } : !1);
}
function Xa(r) {
  r.removeEventListener("click", ml), r.removeEventListener("touchstart", wl), r.removeEventListener("touchend", yl), r.removeEventListener("touchcancel", xl);
}
function ml(r) {
  const s = r.currentTarget;
  r.closePopover = !s.$_vclosepopover_touch, r.closeAllPopover = s.$_closePopoverModifiers && !!s.$_closePopoverModifiers.all;
}
function wl(r) {
  if (r.changedTouches.length === 1) {
    const s = r.currentTarget;
    s.$_vclosepopover_touch = !0;
    const o = r.changedTouches[0];
    s.$_vclosepopover_touchPoint = o, s.addEventListener("touchend", yl), s.addEventListener("touchcancel", xl);
  }
}
function yl(r) {
  const s = r.currentTarget;
  if (s.$_vclosepopover_touch = !1, r.changedTouches.length === 1) {
    const o = r.changedTouches[0], c = s.$_vclosepopover_touchPoint;
    r.closePopover = Math.abs(o.screenY - c.screenY) < 20 && Math.abs(o.screenX - c.screenX) < 20, r.closeAllPopover = s.$_closePopoverModifiers && !!s.$_closePopoverModifiers.all;
  }
}
function xl(r) {
  const s = r.currentTarget;
  s.$_vclosepopover_touch = !1;
}
var k0 = {
  beforeMount(r, { value: s, modifiers: o }) {
    r.$_closePopoverModifiers = o, (typeof s > "u" || s) && Ya(r);
  },
  updated(r, { value: s, oldValue: o, modifiers: c }) {
    r.$_closePopoverModifiers = c, s !== o && (typeof s > "u" || s ? Ya(r) : Xa(r));
  },
  beforeUnmount(r) {
    Xa(r);
  }
};
function q0(r, s = {}) {
  r.$_vTooltipInstalled || (r.$_vTooltipInstalled = !0, ul(gt, s), r.directive("tooltip", U0), r.directive("close-popper", k0), r.component("VTooltip", I0), r.component("VDropdown", O0), r.component("VMenu", L0));
}
const G0 = {
  version: "2.0.0-beta.20",
  install: q0,
  options: gt
}, K0 = {
  install(r) {
    r.config.unwrapInjectedRef = !0, r.use(gm).use(Am, {
      color: "currentColor"
    }).use(G0), r.mixin(pm);
    for (const s in Mo)
      if (Mo.hasOwnProperty(s)) {
        let o = Mo[s];
        r.component(o.name, o);
      }
  }
};
export {
  K0 as default
};
//# sourceMappingURL=index.es.js.map
